<?php
/**
 * Add child styles.
 */
function solatec_child_enqueue_styles()
{
    $parent_style = 'solatec';
    wp_enqueue_style($parent_style, get_template_directory_uri() . '/assets/css/theme.min.css');
    wp_enqueue_style('solatec-child-style', get_stylesheet_directory_uri() . '/style.css', array(
        $parent_style
    ));
}
add_action('wp_enqueue_scripts', 'solatec_child_enqueue_styles');

/**
  * Set up Solatec Child Theme's textdomain.
  *
  * Declare textdomain for this child theme.
  * Translations can be added to the /languages/ directory.
  */
add_action( 'after_setup_theme', 'solatec_child_theme_setup' );
function solatec_child_theme_setup() {
    load_child_theme_textdomain( 'solatec-child', get_stylesheet_directory() . '/languages' );
}

add_action('after_switch_theme', 'solatec_child_redirect_to_welcome_page');
function solatec_child_redirect_to_welcome_page()
{
    if (is_child_theme()) {
        $parent_theme = wp_get_theme()->parent();
        if (class_exists('CMS_PORTAL')) {
            wp_safe_redirect(admin_url("themes.php?page={$parent_theme->get('TextDomain')}"));
        } else {
            wp_safe_redirect(admin_url("themes.php?page={$parent_theme->get('TextDomain')}-welcome"));
        }
    }
}