<?php
use Elementor\Controls_Manager;
// Register Elementor Widgets through plugin core
if (!function_exists('solatec_elementor_register_widgets')) {
    add_filter('etc_register_widgets', 'solatec_elementor_register_widgets');
    function solatec_elementor_register_widgets($widgets)
    {
        $widgets = [
            [ // Cms Accordion
                'name'       => 'cms_accordion',
                'title'      => esc_html__('CMS Accordion', 'solatec'),
                'icon'       => 'eicon-accordion',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'cms-accordion'
                ),
                'keywords' => [
                    'solatec', 'cms accordion', 'accordion'
                ]
            ],
            [ // Cms Breadcrumb
                'name'       => 'cms_breadcrumb',
                'title'      => esc_html__('CMS Breadcrumb', 'solatec'),
                'icon'       => 'eicon-archive-title',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms breadcrumb', 'breadcrumb'
                ]
            ],
            [ // Cms Button
                'name'       => 'cms_button',
                'title'      => esc_html__('CMS Button', 'solatec'),
                'icon'       => 'eicon-button',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms button', 'button'
                ]
            ],
            [ // Cms Career
                'name'       => 'cms_careers',
                'title'      => esc_html__('CMS Careers', 'solatec'),
                'icon'       => 'eicon-lock-user',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms Careers', 'Careers'
                ]
            ],
            [ // Cms Clients
                'name'       => 'cms_clients',
                'title'      => esc_html__('CMS Clients', 'solatec'),
                'icon'       => 'eicon-slider-push',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms Clients', 'Clients'
                ]
            ],
            [ // Cms Company History
                'name'       => 'cms_company_history',
                'title'      => esc_html__('CMS Company History', 'solatec'),
                'icon'       => 'eicon-history',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms Company History', 'Company', 'History'
                ]
            ],
            [ // Cms Counter
                'name'       => 'cms_counter',
                'title'      => esc_html__('CMS Counter', 'solatec'),
                'icon'       => 'eicon-counter-circle',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-numerator',
                    'cms-counter',
                ),
                'keywords' => [
                    'solatec', 'cms Counter', 'Counter'
                ]
            ],
            [ // Cms Call To Action CTA
                'name'       => 'cms_cta',
                'title'      => esc_html__('CMS Call to Action', 'solatec'),
                'icon'       => 'eicon-image-rollover',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms Call To action', 'Call to action', 'cta'
                ]
            ],
            [ // Cms Fancy Box
                'name'       => 'cms_fancy_box',
                'title'      => esc_html__('CMS Fancy Box', 'solatec'),
                'icon'       => 'eicon-icon-box',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms fancy box', 'fancy', 'box'
                ]
            ],
            [ // Cms Features
                'name'       => 'cms_features',
                'title'      => esc_html__('CMS Features', 'solatec'),
                'icon'       => 'eicon-feature',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms Features', 'Features', 'Feature'
                ]
            ],
            [ // Cms Heading
                'name'       => 'cms_heading',
                'title'      => esc_html__('CMS Heading', 'solatec'),
                'icon'       => 'eicon-t-letter',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms Headings', 'Headings', 'Heading'
                ]
            ],
            [ // Cms Headline
                'name'       => 'cms_headline',
                'title'      => esc_html__('CMS Headline', 'solatec'),
                'icon'       => 'eicon-posts-carousel',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms Headline', 'Headline', 'Headline'
                ]
            ],
            [ // Cms How it Works
                'name'       => 'cms_howitwork',
                'title'      => esc_html__('CMS How It Work', 'solatec'),
                'icon'       => 'eicon-testimonial',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms How it Works', 'How it Works', 'How it Works'
                ]
            ],
            [ // Cms Icon Boxes
                'name'       => 'cms_icon_box',
                'title'      => esc_html__('CMS Icon Box', 'solatec'),
                'icon'       => 'eicon-icon-box',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms icon box', 'icon box', 'icon box'
                ]
            ],
            [ // Cms Image Galleries
                'name'       => 'cms_image_gallery',
                'title'      => esc_html__('CMS Image Gallery', 'solatec'),
                'icon'       => 'eicon-gallery-grid',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'keywords' => [
                    'solatec', 'cms gallery', 'gallery', 'gallery'
                ]
            ],
            [ // CMS Locate Pointers
                'name'       => 'cms_locate_pointers',
                'title'      => esc_html__('CMS Locate Pointers', 'solatec'),
                'icon'       => 'eicon-info-box',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'keywords' => [
                    'solatec', 'cms locate pointer', 'locate pointer', 'locate'
                ]
            ],
            [ // CMS Menu
                'name'       => 'cms_menu',
                'title'      => esc_html__('CMS Menu', 'solatec'),
                'icon'       => 'eicon-menu-bar',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'keywords' => [
                    'solatec', 'cms menu', 'menu'
                ]
            ],
            [ // CMS Page Title
                'name'       => 'cms_page_title',
                'title'      => esc_html__('CMS Page Title', 'solatec'),
                'icon'       => 'eicon-archive-title',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'keywords' => [
                    'solatec', 'cms Page title', 'Page title'
                ]
            ],
            [ // Cms Post Carousel
                'name'       => 'cms_post_carousel',
                'title'      => esc_html__('CMS Post Carousel', 'solatec'),
                'icon'       => 'eicon-posts-carousel',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick',
                ),
                'keywords' => [
                    'solatec', 'cms post Carousel', 'post', 'carousel'
                ]
            ],
            [ // Cms Post Grid
                'name'       => 'cms_post_grid',
                'title'      => esc_html__('CMS Post Grid', 'solatec'),
                'icon'       => 'eicon-posts-grid',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'imagesloaded',
                    'isotope',
                    'cms-post-grid',
                ),
                'keywords' => [
                    'solatec', 'cms post Grid', 'post', 'Grid'
                ]
            ],
            [ // Cms Post Featured
                'name'       => 'cms_post_featured',
                'title'      => esc_html__('CMS Post Featured', 'solatec'),
                'icon'       => 'eicon-archive-title',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms post Carousel', 'post', 'carousel'
                ]
            ],
            [ // Cms Pricing Table
                'name'       => 'cms_pricing_table',
                'title'      => esc_html__('CMS Pricing Table', 'solatec'),
                'icon'       => 'eicon-price-table',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms pricing tablet', 'pricing', 'tablet'
                ]
            ],
            [ // Cms Progress Bar
                'name'       => 'cms_progressbar',
                'title'      => esc_html__('CMS Progress Bar', 'solatec'),
                'icon'       => 'eicon-skill-bar',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array('cms-progressbar'),
                'keywords' => [
                    'solatec', 'cms Progress Bar', 'progress', 'bar'
                ]
            ],
            [ // Cms Quick Contact
                'name'       => 'cms_quickcontact',
                'title'      => esc_html__('CMS Quick Contact', 'solatec'),
                'icon'       => 'eicon-mail',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms quick contact', 'quick', 'contact'
                ]
            ],
            [ // Cms Ratings
                'name'       => 'cms_rating',
                'title'      => esc_html__('CMS Ratings', 'solatec'),
                'icon'       => 'eicon-rating',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms rating', 'rating'
                ]
            ],
            [ // Cms Search
                'name'       => 'cms_search',
                'title'      => esc_html__('CMS Search', 'solatec'),
                'icon'       => 'eicon-search',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms search', 'search'
                ]
            ],
            [ // Cms Slider
                'name'       => 'cms_slider',
                'title'      => esc_html__('CMS Slider', 'solatec'),
                'icon'       => 'eicon-slides',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'swiper',
                    'cms-swiper',
                    'cms-animation'
                ),
                'keywords' => [
                    'solatec', 'cms slider', 'slider'
                ]
            ],
            [ // Cms Socials
                'name'       => 'cms_socials',
                'title'      => esc_html__('CMS Social', 'solatec'),
                'icon'       => 'eicon-social-icons',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms social', 'social'
                ]
            ],
            [ // Cms Team
                'name'       => 'cms_teams',
                'title'      => esc_html__('CMS Teams', 'solatec'),
                'icon'       => 'eicon-slider-push',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick'
                ),
                'keywords' => [
                    'solatec', 'cms team', 'team'
                ]
            ],
            [ // Cms Testimonial
                'name'       => 'cms_testimonial',
                'title'      => esc_html__('CMS Testimonial', 'solatec'),
                'icon'       => 'eicon-testimonial',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery-slick',
                    'cms-jquery-slick'
                ),
                'keywords' => [
                    'solatec', 'cms Testimonial', 'Testimonial'
                ]
            ],
            [ // Cms Video
                'name'       => 'cms_video',
                'title'      => esc_html__('CMS Video', 'solatec'),
                'icon'       => 'eicon-play',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(
                    'jquery',
                    'magnific-popup'
                ),
                'styles'     => array(
                    'magnific-popup'
                ),
                'keywords' => [
                    'solatec', 'cms video', 'video'
                ]
            ]
        ];
        // Contact Form 7
        if(class_exists('WPCF7')){
            $widgets[] = [ // Cms Contact Form 7
                'name'       => 'cms_ctf7',
                'title'      => esc_html__('CMS Contact Form 7', 'solatec'),
                'icon'       => 'eicon-form-horizontal',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms contact form 7', 'contact', 'form'
                ]
            ];
        }
        // Language Switcher
        if(class_exists('TRP_Translate_Press')){
            $widgets[] = [ // Cms Contact Form 7
                'name'       => 'cms_language_switcher',
                'title'      => esc_html__('CMS Languae Switcher', 'solatec'),
                'icon'       => 'eicon-posts-carousel',
                'categories' => array(Elementor_Theme_Core::ETC_CATEGORY_NAME),
                'scripts'    => array(),
                'keywords' => [
                    'solatec', 'cms language switcher', 'language switcher', 'language'
                ]
            ];
        }
        return $widgets;
    }
}

/**
 * Get Page List 
 * @return array
*/
if(!function_exists('solatec_elementor_list_page_opts')){
    function solatec_elementor_list_page_opts($default = []){
        $page_list = array();
        if(!empty($default))
            $page_list[$default['value']] = $default['label'];
        $pages = get_pages(array('hierarchical' => 0, 'posts_per_page' => '-1'));
        foreach($pages as $page){
            $page_list[$page->post_name] = $page->post_title;
        }
        return $page_list;
    }
}
/**
 * Term option for post type
 * make option for elementor element option 
*/
if(!function_exists('etc_get_grid_term_by_post_type_options')){
    function etc_get_grid_term_by_post_type_options($widget, $args=[]){
        $args = wp_parse_args($args, ['condition' => 'post_type', 'custom_condition' => []]);
        $post_types = get_post_types([
            'public'   => true,
            //'_builtin' => false
        ], 'objects');
        $DefaultExcludedPostTypes = [
            'page',
            'attachment',
            'revision',
            'nav_menu_item',
            'vc_grid_item',
            'custom_css',
            'customize_changeset',
            'oembed_cache',
            'cms-mega-menu',
            'elementor_library',
        ];
        $ExtraExcludedPostTypes = apply_filters('etc_get_post_types', []);
        $excludedPostTypes      = array_merge($DefaultExcludedPostTypes, $ExtraExcludedPostTypes );
        if (!is_array($post_types))
            return $result;
        foreach ($post_types as $post_type) {
            if (!$post_type instanceof WP_Post_Type)
                continue;
            if (in_array($post_type->name, $excludedPostTypes))
                continue;
            $widget->add_control(
                'source_'.$post_type->name,
                [
                    'label'    => sprintf(esc_html__( 'Select Term of %s', 'solatec' ), $post_type->labels->singular_name),
                    'type'     => Controls_Manager::SELECT2,
                    'multiple' => true,
                    'options'  => etc_get_grid_term_options($post_type->name),
                    'condition' => array_merge(
                        [
                            $args['condition'] => [$post_type->name]
                        ],
                        $args['custom_condition']
                    )
                ]
            );
        }
    }
}
/**
 * Extra Elementor Icons
*/
if(!function_exists('solatec_register_custom_icon_library')){
    add_filter('elementor/icons_manager/native', 'solatec_register_custom_icon_library');
    function solatec_register_custom_icon_library($tabs){
        $custom_tabs = [
            'cms_solatec_icon' => [
                'name'          => 'cms-solatec',
                'label'         => esc_html__( 'CMS Solatec', 'solatec' ),
                'url'           => get_template_directory_uri() . '/assets/fonts/cms-solatec/styles.css',
                'enqueue'       => [],
                'prefix'        => 'cmsi-',
                'displayPrefix' => '',
                'labelIcon'     => 'cmsi-green-energy',
                'ver'           => '1.0.0',
                'fetchJson'     => get_template_directory_uri() . '/assets/fonts/cms-solatec/cms-font-solatec.js',
                'native'        => true,
            ]
        ];
        $tabs = array_merge($custom_tabs, $tabs);
        return $tabs;
    }
}
if(!function_exists('solatec_elementor_post_layout')){
    function solatec_elementor_post_layout(){
        return [
            '1' => [
                'label' => esc_html__( 'Layout 1', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout1.png'
            ],
            '2' => [
                'label' => esc_html__( 'Layout 2', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout2.png'
            ],
            '3' => [
                'label' => esc_html__( 'Layout 3', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout3.png'
            ],
            '4' => [
                'label' => esc_html__( 'Layout 4', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout4.png'
            ],
            '5' => [
                'label' => esc_html__( 'Layout 5', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout5.png'
            ],
            '6' => [
                'label' => esc_html__( 'Layout 6', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout6.png'
            ],
            '7' => [
                'label' => esc_html__( 'Layout 7', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout7.png'
            ],
            '8' => [
                'label' => esc_html__( 'Layout 8', 'solatec' ),
                'image' => get_template_directory_uri() . '/elementor/templates/layouts/posts/layout8.png'
            ]
        ];
    }
}
// Theme color option
if(!function_exists('solatec_elementor_theme_color_opts')){
    function solatec_elementor_theme_color_opts($args = []){
        $args = wp_parse_args($args, [
            'custom' => true
        ]);
        $theme_colors = solatec_configs('theme_colors');
        $option = ['' => esc_html('Default', 'solatec')];
        foreach ($theme_colors as $key => $color) {
            $option[$key] = $color['title'];
        }
        if($args['custom']) $option['custom'] = esc_html('Custom', 'solatec');
        return $option;
    }
}

if(!function_exists('solatec_elementor_theme_colors')){
    function solatec_elementor_theme_colors($widget, $args = []){
        $args = wp_parse_args($args, [
            'name'                => 'main_color',
            'label'               => esc_html__('Main Color', 'solatec'),
            'custom'              => true,
            'custom_name'         => 'main_custom_color',
            'custom_label'        => esc_html__('Custom Main Color', 'solatec'),
            'custom_selector'     => '',
            'custom_selector_tag' => 'color',
            'prefix_class'        => '',
            'relation'            => '',
            'output'              => true 
        ]);
        $custom_selector = [];
        if(!empty($args['custom_selector']) && $args['output'] === true){
            if($args['relation'] === 'and'){
                $custom_selector = [
                    '{{WRAPPER}}'.$args['custom_selector'] => $args['custom_selector_tag'].': {{VALUE}};' //$custom_selector
                ];
            } else {
                $custom_selector = [
                    '{{WRAPPER}} '.$args['custom_selector'] => $args['custom_selector_tag'].': {{VALUE}};' //$custom_selector
                ];
            }
        } 
        $widget->add_control(
            $args['name'],
            [
                'label'       => $args['label'],
                'type'        => Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(),  
                'default'     => '',
                //'prefix_class' => $args['prefix_class']
            ]
        );
        if($args['custom']){
            $widget->add_control(
                'custom_'.$args['name'],
                [
                    'label'       => $args['custom_label'],
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'condition'   => [
                        $args['name'] => 'custom'
                    ],
                    'selectors'    => $custom_selector,
                    //'prefix_class' => $args['prefix_class']
                ]
            );
        }
    }
}

// Alignment options
if(!function_exists('solatec_elementor_text_align')){
    function solatec_elementor_text_align($widget, $args = []) {
        $args = wp_parse_args($args, [
            'default' => '',
            'label'   => esc_html__( 'Content Alignment', 'solatec' ),
            'label_block' => false
        ]);
        $widget->add_responsive_control(
            'text-align',
            [
                'label'        => $args['label'],
                'label_block'  => $args['label_block'],
                'type'         => \Elementor\Controls_Manager::CHOOSE,
                'options'      => solatec_text_align_opts(),
                'default'      => $args['default']
            ]
        );
    }
}
if(!function_exists('solatec_text_align_opts')){
    function solatec_text_align_opts($args = []){
        $args = wp_parse_args($args, [
            'default' => '',
        ]);
        return [
            'start' => [
                'title' => esc_html__( 'Left', 'solatec' ),
                'icon' => 'eicon-text-align-left',
            ],
            'center' => [
                'title' => esc_html__( 'Center', 'solatec' ),
                'icon' => 'eicon-text-align-center',
            ],
            'end' => [
                'title' => esc_html__( 'Right', 'solatec' ),
                'icon' => 'eicon-text-align-right',
            ],
            'justify' => [
                'title' => esc_html__( 'Justified', 'solatec' ),
                'icon' => 'eicon-text-align-justify',
            ],
        ];
    }
}
// Alignment css class
// Text Align
if(!function_exists('solatec_elementor_align_class')){
    function solatec_elementor_align_class($settings, $id = 'text-align', $extra_class = ''){
        $align_class = [];
        // Text Align
        if( !empty($settings[$id.'_mobile']) ){
            $align_class[] = 'text-sm-'.$settings[$id.'_mobile'];
        }
        if( !empty($settings[$id.'_tablet']) ){
            $align_class[] = 'text-md-'.$settings[$id.'_tablet'];
        }
        if( !empty($settings[$id]) && (empty($settings[$id.'_mobile']) && empty($settings[$id.'_tablet']) ) ) {
            $align_class[] = 'text-'.$settings[$id];
        } elseif( !empty($settings[$id] )) {
            $align_class[] = 'text-lg-'.$settings[$id];
        }
        
        $align_class[] = $extra_class;
        return trim(implode(' ', $align_class));
    }
}
// Row content align
if(!function_exists('solatec_elementor_row_align')){
    function solatec_elementor_row_align($widget, $args = []) {
        $args = wp_parse_args($args, [
            'name'      => 'row-align',  
            'label'     => esc_html__( 'Justify Content', 'solatec' ),    
            'default'   => '',
            'condition' => [],
            'prefix_class' => ''
        ]);
        $widget->add_responsive_control(
            $args['name'],
            [
                'label'        => $args['label'],
                'type'         => \Elementor\Controls_Manager::CHOOSE,
                'options'      => [
                    'start' => [
                        'title' => esc_html__( 'Start', 'solatec' ),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__( 'Center', 'solatec' ),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'end' => [
                        'title' => esc_html__( 'End', 'solatec' ),
                        'icon' => 'eicon-text-align-right',
                    ],
                    'around' => [
                        'title' => esc_html__( 'Around', 'solatec' ),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'between' => [
                        'title' => esc_html__( 'Between', 'solatec' ),
                        'icon' => 'eicon-text-align-justify',
                    ],
                ],
                'default'      => $args['default'],
                'condition'    => $args['condition'],
                //'prefix_class' => $args['prefix_class']
            ]
        );
    }
}
// Row Alignment content
if(!function_exists('solatec_elementor_row_justify_class')){
    function solatec_elementor_row_justify_class($settings, $id = 'row-align', $extra_class = ''){
        $align_class = [];
        if( !empty($settings[$id.'_mobile']) ){
            $align_class[] = 'justify-content-max-sm-'.$settings[$id.'_mobile'];
        }
        if( !empty($settings[$id.'_tablet']) ){
            $align_class[] = 'justify-content-max-md-'.$settings[$id.'_tablet'];
        }
        if( !empty($settings[$id]) ){
            $align_class[] = 'justify-content-'.$settings[$id];
        }
        $align_class[] = $extra_class;
        return trim(implode(' ', $align_class));
    }
}
// Doctor social
if(!function_exists('solatec_doctor_infomation_opts')){
    function solatec_doctor_infomation_opts($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => Controls_Manager::TAB_CONTENT,
            'condition' => [
                'post_type' => 'cms-doctor'
            ]
        ]);
        $widget->start_controls_section(
            'doctor_infomation_settings',
            [
                'label'     => esc_html__('Doctor Info', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            $widget->add_control(
                'show_fb',
                [
                    'label'        => esc_html__('Show Facebook', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'yes'
                ]
            );
            $widget->add_control(
                'show_tw',
                [
                    'label'        => esc_html__('Show Twitter', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'yes',
                ]
            );
            $widget->add_control(
                'show_insta',
                [
                    'label'        => esc_html__('Show Instagram', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'no',
                ]
            );
            $widget->add_control(
                'show_email',
                [
                    'label'        => esc_html__('Show Email', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'yes',
                ]
            );
            $widget->add_control(
                'show_phone',
                [
                    'label'        => esc_html__('Show Phone', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'yes',
                    'return_value' => 'true'
                ]
            );
        $widget->end_controls_section();
    }
}
// Slick Slider Settings
if(!function_exists('solatec_elementor_slick_slider_settings')){
    function solatec_elementor_slick_slider_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => []
        ]);
        $slides_to_show = range( 1, 10 );
        $slides_to_show = array_combine( $slides_to_show, $slides_to_show );
        $widget->start_controls_section(
            'section_slick_slider_settings',
            [
                'label'     => esc_html__('Carousel Settings', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            $widget->add_responsive_control(
                'slide_rows',
                [
                    'label' => esc_html__('Rows', 'solatec'),
                    'description' => esc_html__('Setting this to more than 1 initializes grid mode. Use slidesPerRow to set how many slides should be in each row.', 'solatec'),
                    'type' => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        '1' => '1',
                        '2' => '2',
                        '3' => '3',
                        '4' => '4'
                    ],
                    'default'      => '1'
                ]
            );
            $widget->add_control(
                'slide_mode',
                [
                    'label' => esc_html__('Slide mode', 'solatec'),
                    'type' => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        'true' => esc_html__('Fade', 'solatec'),
                        'false' => esc_html__('Slide', 'solatec'),
                    ],
                    'default' => 'false',
                ]
            );
            $widget->add_responsive_control(
                'slides_to_show',
                [
                    'label'        => esc_html__('Slides to Show', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => [
                            '' => esc_html__('Default', 'solatec' ),
                        ] + $slides_to_show,
                    'condition' => [
                        'slide_mode' => 'false'
                    ]
                ]
            );
            $widget->add_responsive_control(
                'slides_to_scroll',
                [
                    'label'        => esc_html__('Slides to Scroll', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => [
                            '' => esc_html__('Default', 'solatec' ),
                        ] + $slides_to_show,
                    'condition' => [
                        'slide_mode'      => 'false',
                        'slides_to_show!' => '1',
                    ],
                ]
            );
            $widget->add_control(
                'gap',
                [
                    'label'        => esc_html__('Item Gap', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::NUMBER,
                    'default'      => 30,
                ]
            );
            $widget->add_control(
                'gap_extra',
                [
                    'label'        => esc_html__( 'Extra Gap Bottom', 'solatec' ),
                    'description'  => esc_html__( 'Add extra space at bottom of each items','solatec'),
                    'type'         => \Elementor\Controls_Manager::NUMBER,
                    'default'      => 0,
                ]
            );
            $widget->add_control(
                'asnavfor',
                [
                    'label'        => esc_html__('as Nav For', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'false',
                    'separator'    => 'before'
                ]
            );
            $widget->add_responsive_control(
                'arrows',
                [
                    'label'        => esc_html__('Show Arrows', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'false', 
                    'separator'    => 'before'
                ]
            );
            $widget->add_control(
                'arrows_pos',
                [
                    'label'        => esc_html__('Arrows Position', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    //'control_type' => 'responsive',
                    'default'      => 'in-vertical',
                    'options'      => [
                        'in-vertical'   => esc_html__('Inside Vertical','solatec'),
                        'out-vertical'  => esc_html__('Outside Vertical','solatec'),
                        'top-left'      => esc_html__('Top Left','solatec'),
                        'top-right'     => esc_html__('Top Right','solatec'),
                        'top-center'    => esc_html__('Top Center','solatec'),
                        'bottom-left'   => esc_html__('Bottom Left','solatec'),
                        'bottom-right'  => esc_html__('Bottom Right','solatec'),
                        'bottom-center' => esc_html__('Bottom Center','solatec'),
                        'left-side'     => esc_html__('Left Side','solatec'),
                        'right-side'    => esc_html__('Right Side','solatec'),
                        'left-side2'     => esc_html__('Left Side2','solatec'),
                        'right-side2'    => esc_html__('Right Side2','solatec'),
                        'left-side3'     => esc_html__('Left Side 3','solatec'),
                        'right-side3'    => esc_html__('Right Side 3','solatec')
                    ],
                    'condition' => [
                        'arrows'   => 'true'
                    ],
                    'prefix_class' => 'cms-slick-nav-',
                ]
            );
            $widget->add_control(
                'arrows_style',
                [
                    'label'        => esc_html__('Arrows Styles', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => 'default',
                    'options'      => [
                        'default'  => esc_html__('Default','solatec'),
                        'long-arrow-text' => esc_html__('Long Arrow with Text','solatec'),
                    ],
                    'condition' => [
                        'arrows'   => 'true'
                    ],
                    'prefix_class' => 'cms-slick-nav-style-',
                ]
            );
            $widget->add_control(
                'arrows_color',
                [
                    'label'        => esc_html__('Arrows Color', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => solatec_elementor_theme_color_opts(['custom' =>  false]),
                    'condition' => [
                        'arrows'   => 'true'
                    ],
                    'prefix_class' => 'cms-slick-nav-color-',
                ]
            );
            $widget->add_control(
                'arrows_color_hover',
                [
                    'label'        => esc_html__('Arrows Color Hover', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => solatec_elementor_theme_color_opts(['custom' =>  false]),
                    'condition' => [
                        'arrows'   => 'true'
                    ],
                    'prefix_class' => 'cms-slick-nav-color-hover-',
                ]
            );
            $widget->add_responsive_control(
                'dots',
                [
                    'label'        => esc_html__('Show Dots', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'yes',
                    'separator'    => 'before',
                ]
            );
            $widget->add_control(
                'dots_in_nav',
                [
                    'label'        => esc_html__('Dots In Nav', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default'      => 'false',
                    'separator'    => 'before',
                    'condition'    => [
                        'dots'       => 'true',
                        'arrows'     => 'true',
                        'arrows_pos!' => ['in-vertical', 'out-vertical']
                    ],
                    'prefix_class' => 'cms-slick-dots-in-nav-',
                    'return_value' => 'true' 
                ]
            );
            $widget->add_responsive_control(
                'dots_pos',
                [
                    'label'        => esc_html__('Dots Position', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => 'out',
                    'options'      => [
                        'in'  => esc_html__('Inside','solatec'),
                        'out' => esc_html__('Outside','solatec'),
                    ],
                    'condition' => [
                        'dots'        => 'true',
                        'dots_in_nav' => 'false'
                    ],
                    'prefix_class' => 'cms-slick-dots-',
                    'separator'    => 'before',
                ]
            );
            $widget->add_control(
                'dots_color',
                [
                    'label'        => esc_html__('Dots Color', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => solatec_elementor_theme_color_opts(['custom' =>  false]),
                    'condition' => [
                        'dots'        => 'true'
                    ],
                    'prefix_class' => 'cms-slick-dots-color-',
                ]
            );
            $widget->add_control(
                'dots_color_hover',
                [
                    'label'        => esc_html__('Dots Color Hover', 'solatec'),
                    'type'         => \Elementor\Controls_Manager::SELECT,
                    'default'      => '',
                    'options'      => solatec_elementor_theme_color_opts(['custom' =>  false]),
                    'condition' => [
                        'dots'        => 'true',
                    ],
                    'prefix_class' => 'cms-slick-dots-color-hover-',
                ]
            );
            solatec_elementor_row_align($widget, [
                'name'      => 'dots_align',
                'label'     => esc_html__('Dots Align', 'solatec'),
                'condition' => [
                    'dots'        => 'true',
                    'dots_in_nav' => ''
                ],
                'prefix_class' => 'cms-slick-dots-align-'
            ]);
            $widget->add_control(
                'pause_on_hover',
                [
                    'label'   => esc_html__('Pause on Hover', 'solatec'),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default' => 'true'
                ]
            );
            $widget->add_control(
                'autoplay',
                [
                    'label'   => esc_html__('Autoplay', 'solatec'),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default' => 'true'
                ]
            );
            $widget->add_control(
                'autoplay_speed',
                [
                    'label'     => esc_html__('Autoplay Speed', 'solatec'),
                    'type'      => \Elementor\Controls_Manager::NUMBER,
                    'default'   => 2000,
                    'condition' => [
                        'autoplay' => 'true'
                    ]
                ]
            );
            $widget->add_control(
                'infinite',
                [
                    'label' => esc_html__('Infinite Loop', 'solatec'),
                    'type'  => \Elementor\Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                ]
            );
            $widget->add_control(
                'speed',
                [
                    'label'   => esc_html__('Animation Speed', 'solatec'),
                    'type'    => \Elementor\Controls_Manager::NUMBER,
                    'default' => 500,
                ]
            );
        $widget->end_controls_section();
    }
}
if(!function_exists('solatec_slick_slider_arrows')){
    function solatec_slick_slider_arrows($settings){
        if(in_array($settings['arrows_pos'], ['in-vertical', 'out-vertical'])): ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows"><?php 
            ?></div></div>
        <?php endif;
    }
}
if(!function_exists('solatec_slick_slider_arrows_side')){
    function solatec_slick_slider_arrows_side($settings){
        if(in_array($settings['arrows_pos'], ['left-side', 'right-side'])): 
        ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows"></div></div>
        <?php
            $link_attrs = [];
            if ( ! empty( $settings['other_link']['url'] ) ) {
                $link_attrs[] = 'href="'.$settings['other_link']['url'].'"';
            }
            if ( ! empty($settings['other_link']['is_external'] )) {
                $link_attrs[] = 'target="_blank"';
            }
            if ( ! empty($settings['other_link']['nofollow'] )) {
                $link_attrs[] = 'rel="nofollow"';
            }
            if( ! empty($settings['other_link']['custom_attributes'])){
                $custom_attributes = explode('|', $settings['other_link']['custom_attributes']);
                foreach ($custom_attributes as $atts_value) {
                    $_custom_attributes = explode(':', $atts_value);
                    $link_attrs[] = $_custom_attributes[0].'="'.$_custom_attributes[1].'"';
                }
            }
            echo esc_html($settings['other_text']); 
            if(!empty($settings['other_link_text'])){
                ?>
                    <a data-other-link="other-link" <?php echo implode(' ', $link_attrs); ?>><?php echo esc_html($settings['other_link_text']); ?> <span class="cmsi-arrow-right2 ml-5 text-12"></span></a>
                <?php
            }
        endif;
    }
}
if(!function_exists('solatec_slick_slider_arrows_side2')){
    function solatec_slick_slider_arrows_side2($settings){
        if(in_array($settings['arrows_pos'], ['left-side2', 'right-side2'])): 
        ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows"><?php 
                solatec_slick_slider_dots_in_nav($settings);
            ?></div></div>
        <?php
        endif;
    }
}
if(!function_exists('solatec_slick_slider_arrows_side3')){
    function solatec_slick_slider_arrows_side3($settings){
        if(in_array($settings['arrows_pos'], ['left-side3', 'right-side3'])): 
        ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows"><?php 
                solatec_slick_slider_dots_in_nav($settings);
            ?></div></div>
        <?php
        endif;
    }
}
if(!function_exists('solatec_slick_slider_arrows_top')){
    function solatec_slick_slider_arrows_top($settings){
        if(in_array($settings['arrows_pos'], ['top-left', 'top-right'])): ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows empty-none"><?php 
                solatec_slick_slider_dots_in_nav($settings);
            ?></div></div>
        <?php endif;
    }
}
if(!function_exists('solatec_slick_slider_arrows_bottom')){
    function solatec_slick_slider_arrows_bottom($settings){
        if(in_array($settings['arrows_pos'], ['bottom-left', 'bottom-right'])): ?>
            <div class="cms-slick--arrows"><div class="cms-slick-arrows empty-none"><?php
                solatec_slick_slider_dots_in_nav($settings);
            ?></div></div>
        <?php endif;
    }
}
if(!function_exists('solatec_slick_slider_dots')){
    function solatec_slick_slider_dots($settings){
        if($settings['dots'] === 'true' && $settings['dots_in_nav'] !== 'true') {
        ?>
            <div class="cms-slick-dots empty-none"></div>
        <?php
        }
    }
}
if(!function_exists('solatec_slick_slider_dots_in_nav')){
    function solatec_slick_slider_dots_in_nav($settings){
        if($settings['dots'] === 'true' && $settings['dots_in_nav'] === 'true') {
        ?>
            <div class="cms-slick-dots empty-none"></div>
        <?php
        }
    }
}
if(!function_exists('solatec_slick_slider_settings')){
    function solatec_slick_slider_settings($widget, $class=''){
        $slide_mode              = $widget->get_setting('slide_mode', 'false');
        $slide_rows              = $widget->get_setting('slide_rows', '1');
        $slides_to_show          = $widget->get_setting('slides_to_show', '3');
        $slides_to_show_tablet   = $widget->get_setting('slides_to_show_tablet', '2');
        $slides_to_show_mobile   = $widget->get_setting('slides_to_show_mobile', '1');
        $slides_to_scroll        = $widget->get_setting('slides_to_scroll', $slides_to_show );
        $slides_to_scroll_tablet = $widget->get_setting('slides_to_scroll_tablet', $slides_to_show_tablet);
        $slides_to_scroll_mobile = $widget->get_setting('slides_to_scroll_mobile', $slides_to_show_mobile);

        $slideRows =  !empty($slide_rows) ? $slide_rows : 1;
        $slideRowsTablet = !empty($slide_rows_tablet) ? $slide_rows_tablet : $slideRows;
        $slideRowsMobile = !empty($slide_rows_mobile) ? $slide_rows_mobile : $slideRows;

        if($slide_mode == 'true'){
            $slidesToShow = $slidesToShowTablet = $slidesToShowMobile = $slidesToScroll = $slidesToScrollTablet = $slidesToScrollMobile = 1;
        } else {
            if(1 === (int)$slides_to_show){
                $slidesToShow = $slidesToShowTablet = $slidesToShowMobile = $slidesToScroll = $slidesToScrollTablet = $slidesToScrollMobile = 1;
            } else {
                $slidesToShow       = $slides_to_show;
                $slidesToShowTablet = $slides_to_show_tablet;
                $slidesToShowMobile = $slides_to_show_mobile;

                $slidesToScroll = $slides_to_scroll;
                $slidesToScrollTablet = $slides_to_scroll_tablet;
                $slidesToScrollMobile = $slides_to_scroll_mobile;
            }
        }

        $slides_gutter  = (int) $widget->get_setting('gap', '30')/2;
        $asnavfor       = $widget->get_setting('asnavfor');
        $arrows         = $widget->get_setting('arrows', 'false');
        $arrows_tablet  = $widget->get_setting('arrows_tablet', 'false');
        $arrows_mobile  = $widget->get_setting('arrows_mobile', 'false');
        $arrows_pos     = $widget->get_setting('arrows_pos','in-vertical');
        $dots           = $widget->get_setting('dots');
        $dots_tablet    = $widget->get_setting('dots_tablet', $dots);
        $dots_mobile    = $widget->get_setting('dots_mobile', $dots_tablet);
        $dots_pos       = $widget->get_setting('dots_pos','out');
        $pause_on_hover = $widget->get_setting('pause_on_hover', 'true');
        $autoplay       = $widget->get_setting('autoplay');
        $autoplay_speed = $widget->get_setting('autoplay_speed', '5000');
        $infinite       = $widget->get_setting('infinite');
        $speed          = $widget->get_setting('speed', '500');
        $titlenext      = $widget->get_setting('nav_title_next', 'Next');
        $titleprev      = $widget->get_setting('nav_title_prev', 'Prev');

        $dir = is_rtl() ? 'true' : 'false';
        $rtl = is_rtl() ? 'rtl' : 'ltr';
        $widget->add_render_attribute( 'cms-slider-settings', [
            'class'                     => trim('cms-slick-slider '.$class),
            'data-fade'                 => $slide_mode,
            'data-rows'                 => $slideRows,
            'data-rowstablet'           => $slideRowsTablet,
            'data-rowsmobile'           => $slideRowsMobile,
            'data-arrows'               => $arrows,
            'data-arrowstablet'         => $arrows_tablet,
            'data-arrowsmobile'         => $arrows_mobile,
            'data-dots'                 => $dots,
            'data-dotstablet'           => $dots_tablet,
            'data-dotsmobile'           => $dots_mobile,
            'data-pauseOnHover'         => $pause_on_hover,
            'data-autoplay'             => $autoplay,
            'data-autoplaySpeed'        => $autoplay_speed,
            'data-infinite'             => $infinite,
            'data-speed'                => $speed,
            'data-slidestoshow'         => $slidesToShow,
            'data-slidestoshowtablet'   => $slidesToShowTablet,
            'data-slidestoshowmobile'   => $slidesToShowMobile,
            'data-slidestoscroll'       => $slidesToScroll,
            'data-slidestoscrolltablet' => $slidesToScrollTablet,
            'data-slidestoscrollmobile' => $slidesToScrollMobile,
            'data-gutter'               => $slides_gutter,
            'data-rtl'                  => $dir,
            'dir'                       => $rtl,
            'data-asnavfor'             => $asnavfor,
            'data-titlenext'            => $titlenext,
            'data-titleprev'            => $titleprev,
            'style'                     => 'margin-left:-'.$slides_gutter.'px;margin-right:-'.$slides_gutter.'px;',    
        ] );
        if((int)$slideRows > 1) $widget->add_render_attribute( 'cms-slider-settings', 'class', 'multi-rows-xl');
        if((int)$slideRowsTablet > 1) $widget->add_render_attribute( 'cms-slider-settings', 'class', 'multi-rows-lg');
        if((int)$slideRowsMobile > 1) $widget->add_render_attribute( 'cms-slider-settings', 'class', 'multi-rows-md');

        etc_print_html($widget->get_render_attribute_string( 'cms-slider-settings' ));
    }
}
// Grid settings
if(!function_exists('solatec_column_settings')){
    function solatec_column_settings($widget){
        $options = [
            '12' => '12',
            '6'  => '6',
            '3'  => '3',
            '4'  => '4',
            '2'  => '2',
            '1'  => '1'
        ];
        $widget->add_control(
            'col_sm',
            [
                'label'   => esc_html__( 'Mobile', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => '1',
                'options' => $options
            ]
        );
        $widget->add_control(
            'col_md',
            [
                'label'   => esc_html__( 'Table', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => '2',
                'options' => $options
            ]
        );
        $widget->add_control(
            'col_lg',
            [
                'label'   => esc_html__( 'Small Desktop', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => '3',
                'options' => $options
            ]
        );
        $widget->add_control(
            'col_xl',
            [
                'label'   => esc_html__( 'Large Desktop', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => '4',
                'options' => $options
            ]
        );
        $widget->add_control(
            'gap',
            [
                'label'        => esc_html__( 'Item Gap', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::NUMBER,
                'control_type' => 'responsive',
                'default'      => 30
            ]
        );
        $widget->add_control(
            'gap_extra',
            [
                'label'        => esc_html__( 'Extra Gap Bottom', 'solatec' ),
                'description'  => esc_html__( 'Add extra space at bottom of each items','solatec'),
                'type'         => \Elementor\Controls_Manager::NUMBER,
                'default'      => 0
            ]
        );
    }
}
if(!function_exists('solatec_grid_column_settings')){
    function solatec_grid_column_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => [],
            'extra'     => []    
        ]);
        $widget->start_controls_section(
            'section_grid_settings',
            [
                'label'     => esc_html__('Grid Columns Settings', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            solatec_column_settings($widget);
        $widget->end_controls_section();
    }
}
// get column width
if(!function_exists('solatec_elementor_grid_column_class')){
    function solatec_elementor_grid_column_class($widget, $settings){
        $class = [];
        $class[] = 'col-xl-'.round(12/$settings['col_xl']);
        $class[] = 'col-lg-'.round(12/$settings['col_lg']);
        $class[] = 'col-md-'.round(12/$settings['col_md']);
        $class[] = 'col-sm-'.round(12/$settings['col_sm']);

        echo trim(implode(' ', $class));
    }
}

/**
 * Masonry Settings
*/
if(!function_exists('solatec_elementor_masonry_settings')){
    function solatec_elementor_masonry_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => []
        ]);
        $widget->start_controls_section(
            'section_masonry_settings',
            [
                'label'     => esc_html__('Masonry Settings', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            $widget->add_control(
                'masonry_mode',
                [
                    'label'   => esc_html__( 'Masonry Mode', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        'fitRows' => esc_html__( 'Basic Grid', 'solatec' ),
                        'masonry' => esc_html__( 'Masonry Grid', 'solatec' ),
                    ],
                    'default'   => 'fitRows'
                ]
            );
        $widget->end_controls_section();
    }
}
if(!function_exists('solatec_elementor_masonry_filter_settings')){
    function solatec_elementor_masonry_filter_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => []
        ]);
        $widget->start_controls_section(
            'section_filter_settings',
            [
                'label'     => esc_html__('Filter Settings', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            $widget->add_control(
                'filter',
                [
                    'label'   => esc_html__( 'Show Filter', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'default' => 'false',
                    'options' => [
                        'true'  => esc_html__( 'Enable', 'solatec' ),
                        'false' => esc_html__( 'Disable', 'solatec' ),
                    ]
                ]
            );
            $widget->add_control(
                'filter_default_title',
                [
                    'label'     => esc_html__( 'Default Title', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::TEXT,
                    'default'   => esc_html__( 'All', 'solatec' ),
                    'condition' => [
                        'filter' => 'true',
                    ]
                ]
            );
            $widget->add_control(
                'filter_alignment',
                [
                    'label'   => esc_html__( 'Alignment', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'default' => 'center',
                    'options' => [
                        'start'  => esc_html__( 'Start', 'solatec' ),
                        'center' => esc_html__( 'Center', 'solatec' ),
                        'end'    => esc_html__( 'End', 'solatec' ),
                    ],
                    'condition' => [
                        'filter' => 'true',
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}
if(!function_exists('solatec_elementor_masonry_pagination_settings')){
    function solatec_elementor_masonry_pagination_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => []
        ]);
        $widget->start_controls_section(
            'section_pagination_settings',
            [
                'label'     => esc_html__('Pagination Settings', 'solatec'),
                'tab'       => $args['tab'],
                'condition' => $args['condition']
            ]
        );
            $widget->add_control(
                'pagination_type',
                [
                    'label'   => esc_html__( 'Pagination Type', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'default' => 'false',
                    'options' => [
                        'pagination' => esc_html__( 'Pagination', 'solatec' ),
                        'loadmore'   => esc_html__( 'Loadmore', 'solatec' ),
                        'false'      => esc_html__( 'Disable', 'solatec' ),
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}
if(!function_exists('solatec_elementor_masonry_column_settings')){
    function solatec_elementor_masonry_column_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
            'condition' => []
        ]);
        solatec_grid_column_settings($widget, [
            'tab'       => $args['tab'],
            'condition' => $args['condition']
        ]);
    }
}

if(!function_exists('solatec_elementor_masonry_settings_render_attrs')){
    function solatec_elementor_masonry_settings_render_attrs($widget, $settings, $_args = []){
        $_args = wp_parse_args($_args,[
            'post_type' => 'post',
            'class'     => ''
        ]);
        $html_id   = etc_get_element_id($settings);
        extract(etc_get_posts_of_grid($_args['post_type'], [
            'source'   => $widget->get_setting('source_'.$_args['post_type'], ''),
            'orderby'  => $widget->get_setting('orderby', 'date'),
            'order'    => $widget->get_setting('order', 'desc'),
            'limit'    => $widget->get_setting('limit', 6),
            'post_ids' => $widget->get_setting('post_ids', ''),
        ]));
        $widget->add_render_attribute( 'wrapper', [
            'id'              => $html_id,
            'class'           => trim('cms-grid '.$_args['class']),
            'data-layoutmode' => $settings['masonry_mode'],
            'data-layout'     => 'masonry',
            'data-start-page' => $paged,
            'data-max-pages'  => $max,
            'data-total'      => $total,
            'data-perpage'    => $widget->get_setting('limit', 6),
            'data-next-link'  => $next_link
        ]);
        etc_print_html($widget->get_render_attribute_string( 'wrapper' ));
    }
}
/**
 * Hyperlink Settings
**/
if(!function_exists('solatec_elementor_hyperlink_settings')){
    function solatec_elementor_hyperlink_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'options'           => [],
            'condition'         => [],
            'prefix'            => '',
            'link_type'         => '',
            'link_type_default' => 'custom',
            'link_page'         => true
        ]);
        $_link_type = [
            'custom'   => esc_html__('Custom','solatec')
        ];  
        if($args['link_page']){
            $_link_type['page'] =  esc_html__('Internal Page','solatec');
        }
        $widget->add_control(
            $args['prefix'].'link_type',
            [
                'label'       => esc_html__( 'Link Type', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['link_type_default'],
                'options'     => array_merge(
                    $_link_type, 
                    $args['options']
                ),
                'condition'   => $args['condition']
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_text',
            [
                'label'     => esc_html__( 'Text', 'solatec' ),
                'type'      => \Elementor\Controls_Manager::TEXT,
                'condition' => array_merge($args['condition']),
                'dynamic'   => [
                    'active' => true,
                ]
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_page',
            [
                'label'        => esc_html__( 'Page Link', 'solatec' ),
                'type'         => Elementor_Theme_Core::POSTS_CONTROL,
                'post_type'    => [ 'page' ],
                'multiple'     => false,
                'condition'    => array_merge($args['condition'], [$args['prefix'].'link_type' => 'page']),
            ]
        ); 
        $widget->add_control(
            $args['prefix'].'hyper_link',
            [
                'label'       => esc_html__( 'Custom Link', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::URL,
                'placeholder' => esc_html__( 'https://your-link.com', 'solatec' ),
                'default'     => [
                    'url'         => '#',
                    'is_external' => 'on'
                ],
                'condition'   => array_merge($args['condition'], [$args['prefix'].'link_type' => 'custom'], [$args['prefix'].'link_text!' => '']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_color',
            [
                'label'       => esc_html__( 'Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'condition'   => array_merge([$args['prefix'].'link_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_hover_color',
            [
                'label'       => esc_html__( 'Hover Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'condition'   => array_merge([$args['prefix'].'link_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_align',
            [
                'label'        => esc_html__( 'Alignment', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::CHOOSE,
                'control_type' => 'responsive',
                'options'      => solatec_text_align_opts(),
                'condition'    => array_merge([$args['prefix'].'link_text!' => ''], $args['condition'])
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_icon',
            [
                'label'            => esc_html__( 'Icon', 'solatec' ),
                'type'             => \Elementor\Controls_Manager::ICONS,
                'label_block'      => true,
                'fa4compatibility' => 'icon',
                'condition' => array_merge([$args['prefix'].'link_text!' => ''], $args['condition'])
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_icon_align',
            [
                'label'   => esc_html__( 'Icon Position', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => 'left',
                'options' => [
                    'left'  => esc_html__( 'Before', 'solatec' ),
                    'right' => esc_html__( 'After', 'solatec' ),
                ],
                'condition' => array_merge([
                        $args['prefix'].'link_text!' => '',
                        $args['prefix'].'link_icon[value]!' => ''
                    ],
                    $args['condition']
                )
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_icon_size',
            [
                'label' => esc_html__( 'Icon Size', 'solatec' ),
                'type'  => \Elementor\Controls_Manager::SLIDER,
                'range' => [
                    'px' => [
                        'min' => 15,
                        'max' => 200,
                    ],
                ],
                'condition' => array_merge([
                        $args['prefix'].'link_text!' => '',
                        $args['prefix'].'link_icon[value]!' => ''
                    ],
                    $args['condition']
                ),
                'selectors' => [
                    '{{WRAPPER}} .cms-link .cms-icon' => 'font-size: {{SIZE}}{{UNIT}};'
                ]
            ]
        );
        $widget->add_control(
            $args['prefix'].'link_icon_indent',
            [
                'label' => esc_html__( 'Icon Spacing', 'solatec' ),
                'type'  => \Elementor\Controls_Manager::SLIDER,
                'range' => [
                    'px' => [
                        'min' => 5,
                        'max' => 200,
                    ],
                ],
                'condition' => array_merge([
                        $args['prefix'].'link_text!' => '',
                        $args['prefix'].'link_icon[value]!' => ''
                    ],
                    $args['condition']
                ),
                'selectors' => [
                    '{{WRAPPER}} .cms-link .cms-link-icon.cms-align-icon-right' => 'margin-left: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .cms-link .cms-link-icon.cms-align-icon-left' => 'margin-right: {{SIZE}}{{UNIT}};',
                ]
            ]
        );
    }
}
if(!function_exists('solatec_elementor_custom_link_attrs')){
    function solatec_elementor_custom_link_attrs($settings, $args = []){
        $args = wp_parse_args($args, [
            'name'   => 'hyper_link',
            'prefix' => '',
            'class'  => '',
            'echo'   => false
        ]);
        $settings[$args['prefix'].$args['name']]['custom_attributes'] =  empty($settings[$args['prefix'].$args['name']]['custom_attributes']) ? 'class|' : $settings[$args['prefix'].$args['name']]['custom_attributes'];
        $link_attrs = [];
        if ( ! empty( $settings[$args['prefix'].$args['name']]['url'] ) ) {
            $link_attrs[] = 'href="'.$settings[$args['prefix'].$args['name']]['url'].'"';
        }
        if ( ! empty($settings[$args['prefix'].$args['name']]['is_external'] )) {
            $link_attrs[] = 'target="_blank"';
        }
        if ( ! empty($settings[$args['prefix'].$args['name']]['nofollow'] )) {
            $link_attrs[] = 'rel="nofollow"';
        }
        if( ! empty($settings[$args['prefix'].$args['name']]['custom_attributes'])){
            $custom_attributes = explode(',', $settings[$args['prefix'].$args['name']]['custom_attributes']);
            foreach ($custom_attributes as $atts_value) {
                $_custom_attributes = explode('|', $atts_value);
                if($_custom_attributes[0] === 'class') $_custom_attributes[1] .= ' '.$args['class'];
                $link_attrs[] = $_custom_attributes[0].'="'.$_custom_attributes[1].'"';
            }
        }
        if($args['echo']){
            return trim(implode(' ', $link_attrs));
        } else {
            return $link_attrs;
        }
    }
}
if(!function_exists('solatec_elementor_page_link_attrs')){
    function solatec_elementor_page_link_attrs($settings, $args = []){
        $args = wp_parse_args($args, [
            'prefix' => '',
            'class'  => '',
            'echo'   => false,
        ]);
        $page_link_attrs = [];
        $page_link_attrs[] = 'href="'.solatec_get_link_by_slug($settings[$args['prefix'].'link_page'],'page').'"';
        $page_link_attrs[] = 'target="_blank"';
        $page_link_attrs[] = 'class="'.$args['class'].'"';
        if($args['echo']){
            return trim(implode(' ',$page_link_attrs));
        } else {
            return $page_link_attrs;
        }
    }
}

if(!function_exists('solatec_elementor_hyperlink_render')){
    function solatec_elementor_hyperlink_render($settings, $args = []){
        $args = wp_parse_args($args, [
            'prefix'       => '',
            'tag'          => 'div',
            'link_type'    => 'custom',
            //'link_text'    => !empty($settings[$args['prefix'].'link_text']) ? $settings[$args['prefix'].'link_text'] : 'Read More';
            'wrap_class'   => '',    
            'class'        => '',
            'default_icon' => [
                'value'   => 'cmsi-arrow-circle-right',
                'library' => 'cmsi'
            ],
            'icon_align'   => 'left', 
            'echo'         => true,
        ]);
        if(array_key_exists('link_text', $args)){
            $link_text = $args['link_text'];
        } else {
            $link_text = !empty($settings[$args['prefix'].'link_text']) ? $settings[$args['prefix'].'link_text'] : 'Read More';
        }
        $link_attrs = '';
        $args['class'] .= ' d-inline-block text-'.$settings[$args['prefix'].'link_color'].' text-hover-'.$settings[$args['prefix'].'link_hover_color'];
        if($args['prefix'].$args['link_type'] === 'custom'){
            $link_attrs = solatec_elementor_custom_link_attrs($settings, $args);
        } else {
            $link_attrs = solatec_elementor_page_link_attrs($settings, $args);
        }
        $settings[$args['prefix'].'link_icon_align'] = empty($settings[$args['prefix'].'link_icon_align']) ? $args['icon_align'] : $settings[$args['prefix'].'link_icon_align'];
        if($settings[$args['prefix'].'link_icon_align'] === 'left'){
            $icon_class = 'order-first';
        } else {
            $icon_class = 'order-last';
        }
        ?>
            <<?php printf('%s', $args['tag']);?> class="<?php echo trim(implode(' ', ['cms-link', $args['wrap_class']]));?>">
                <a <?php printf('%s', $link_attrs) ;?>>
                    <span class="cms-btn-content"><?php 
                        solatec_elementor_icon_render($settings, [
                            'id'           => $args['prefix'].'link_icon',
                            'loop'         => false,
                            'tag'          => 'span',   
                            'wrap_class'   => 'cms-btn-icon '.$icon_class,
                            'class'        => 'cms-link-icon cms-align-icon-'.$settings[$args['prefix'].'link_icon_align'].' rtl-flip',
                            'style'        => '',
                            'before'       => '',
                            'after'        => '',
                            'atts'         => [],
                            'default_icon' => $args['default_icon']
                        ]);
                        printf('%s', '<span class="cms-btn-text">'.$link_text.'</span>');
                    ?></span>
                </a>
            </<?php printf('%s', $args['tag']);?>>
        <?php
    }
}
/**
 * Buttons Settings
**/
if(!function_exists('solatec_elementor_button_settings')){
    function solatec_elementor_button_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'options'               => [],
            'condition'             => [],
            'prefix'                => '',
            'btn_text'              => '',
            'btn_type'              => [],
            'btn_type_default'      => 'btn btn-fill',
            'btn_link_type'         => [],
            'btn_link_type_default' => 'custom',
            'btn_color'             => 'accent',
            'btn_hover_color'       => 'primary',
            'btn_size'              => '',
            'btn_align'             => 'start',
            'icon_default'          => [
                'value'             => 'cmsi-arrow-circle-right',
                'library'           => 'cmsi'
            ],
            'icon_align'            => 'left',
            'effect'                => true
        ]);
        $widget->add_control(
            $args['prefix'].'btn_text',
            [
                'label'       => esc_html__( 'Button Text', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::TEXT,
                'default'     => $args['btn_text'],
                'placeholder' => esc_html__('Your Text', 'solatec'),
                'condition'   => $args['condition'],
            ]
        );
        $widget->add_control(
            $args['prefix'].'show_btn_text',
            [
                'label'       => esc_html__( 'Show Button Text', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'      => [
                    'yes' => esc_html__('Yes', 'solatec'),
                    'no'  => esc_html__('No','solatec')
                ],
                'default'     => 'yes',
                'condition'   => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'show_in_popup',
            [
                'label'       => esc_html__( 'Show Content In Popup', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'      => [
                    'true' => esc_html__('Yes', 'solatec'),
                    'false'  => esc_html__('No','solatec')
                ],
                'default'     => 'false',
                'condition'   => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_link_type',
            [
                'label'       => esc_html__( 'Link Type', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['btn_link_type_default'],
                'options'     => array_merge(
                    [
                        'custom'   => esc_html__('Custom','solatec'),
                        'page'     => esc_html__('Internal Page','solatec'),
                    ],
                    $args[ 'btn_link_type']
                ),
                'condition' => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_link_page',
            [
                'label'     => esc_html__( 'Page Link', 'solatec' ),
                'type'      => Elementor_Theme_Core::POSTS_CONTROL,
                'post_type' => [ 'page' ],
                'multiple'  => false,
                'condition' => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition'], [$args['prefix'].'btn_link_type' => 'page']),
            ]
        );            
        $widget->add_control(
            $args['prefix'].'btn_link',
            [
                'label'       => esc_html__( 'Link', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::URL,
                'placeholder' => esc_html__( 'https://your-link.com', 'solatec' ),
                'default'     => [
                    'url' => '#',
                ],
                'condition' => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition'], [$args['prefix'].'btn_link_type' => 'custom']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_type',
            [
                'label'       => esc_html__( 'Mode', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['btn_type_default'],
                'options'     => array_merge(
                    [
                        'btn btn-fill'    => esc_html__('Fill','solatec'),
                        'btn btn-outline' => esc_html__('Outline','solatec'),
                        'btn-overlay'     => esc_html__('Overlay','solatec'),
                        'just-link'       => esc_html__('Plain Text','solatec'),
                    ],
                    $args['btn_type']
                ),
                'condition' => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_color',
            [
                'label'       => esc_html__( 'Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['btn_color'],
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'condition'   => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_hover_color',
            [
                'label'       => esc_html__( 'Hover Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['btn_hover_color'],
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'condition'   => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_size',
            [
                'label'       => esc_html__( 'Size', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'default'     => $args['btn_size'],
                'options'     => [
                    'xs'  => esc_html__('Extra Small','solatec'),  
                    'sm'  => esc_html__('Small','solatec'),  
                    ''    => esc_html__('Default','solatec'),
                    'md'  => esc_html__('Medium','solatec'),
                    'lg'  => esc_html__('Large','solatec'),
                    'xl'  => esc_html__('Extra Large','solatec'),
                ],
                'condition' => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition'],[$args['prefix'].'btn_type!' => ['btn-overlay', 'btn-text', 'just-link']]), 
            ]
        );
        $widget->add_control(
            $args['prefix'].'align',
            [
                'label'        => esc_html__( 'Button Alignment', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::CHOOSE,
                'control_type' => 'responsive',
                'options'      => solatec_text_align_opts(),
                'default'      => $args['btn_align'],
                'condition'    => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition'])
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_icon',
            [
                'label'            => esc_html__( 'Icon', 'solatec' ),
                'type'             => \Elementor\Controls_Manager::ICONS,
                'label_block'      => false,
                'skin'             => 'inline',
                'condition'        => array_merge([$args['prefix'].'btn_text!' => ''], $args['condition']),
                'default'          => $args['icon_default']
            ]
        );
        $widget->add_control(
            $args['prefix'].'show_btn_icon',
            [
                'label'       => esc_html__( 'Show Button Icon', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'      => [
                    'yes' => esc_html__('Yes', 'solatec'),
                    'no'  => esc_html__('No','solatec')
                ],
                'default'     => 'yes',
                'condition' =>  array_merge([
                        $args['prefix'].'btn_text!' => '',
                        $args['prefix'].'btn_icon[value]!' => ''
                    ],
                    $args['condition']
                ),
            ]
        );
        $widget->add_control(
            $args['prefix'].'icon_align',
            [
                'label'   => esc_html__( 'Icon Position', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'default' => $args['icon_align'],
                'options' => [
                    'left'  => esc_html__( 'Before', 'solatec' ),
                    'right' => esc_html__( 'After', 'solatec' ),
                ],
                'condition' => array_merge([
                        $args['prefix'].'btn_text!' => '',
                        $args['prefix'].'btn_icon[value]!' => '',
                        $args['prefix'].'show_btn_icon' => ['true','yes']
                    ],
                    $args['condition']
                )
            ]
        );
        $widget->add_control(
            $args['prefix'].'icon_size',
            [
                'label' => esc_html__( 'Icon Size', 'solatec' ),
                'type'  => \Elementor\Controls_Manager::SLIDER,
                'range' => [
                    'px' => [
                        'min' => 0,
                        'max' => 200,
                    ],
                ],
                'condition' => array_merge([
                        $args['prefix'].'btn_text!' => '',
                        $args['prefix'].'btn_icon[value]!' => '',
                        $args['prefix'].'show_btn_icon' => 'true'
                    ],
                    $args['condition']
                ),
                'selectors' => [
                    '{{WRAPPER}} .cms-btn-content-'.$args['prefix'].' .cms-btn-icon' => 'font-size: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .cms-btn-content-'.$args['prefix'].' .cms-btn-icon' => 'font-size: {{SIZE}}{{UNIT}};',
                ]
            ]
        );
        $widget->add_control(
            $args['prefix'].'icon_indent',
            [
                'label' => esc_html__( 'Icon Spacing', 'solatec' ),
                'type'  => \Elementor\Controls_Manager::SLIDER,
                'range' => [
                    'px' => [
                        'min' => 5,
                        'max' => 200,
                    ],
                ],
                'condition' => array_merge([
                        $args['prefix'].'btn_text!' => '',
                        $args['prefix'].'btn_icon[value]!' => '',
                        $args['prefix'].'show_btn_icon' => 'true'
                    ],
                    $args['condition']
                ),
                'selectors' => [
                    '{{WRAPPER}} .cms-btn-content-'.$args['prefix'].' .cms-btn-icon.cms-align-icon-right' => 'margin-left: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .cms-btn-content-'.$args['prefix'].' .cms-btn-icon.cms-align-icon-left' => 'margin-right: {{SIZE}}{{UNIT}};',
                ]
            ]
        );
        $widget->add_control(
            $args['prefix'].'btn_css_class',
            [
                'label'       => esc_html__( 'Custom CSS Class', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::TEXT,
                'condition'   => $args['condition'],
            ]
        );
        if($args['effect']){
            $widget->add_control(
                $args['prefix'].'btn_animation',
                [
                    'label'     => esc_html__( 'Button Motion Effect', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::ANIMATION,
                    'condition' => [
                        $args['prefix'].'btn_text!' => ''
                    ]
                ]
            );
            $widget->add_control(
                $args['prefix'].'btn_animation_duration', 
                [
                    'label'   => __( 'Animation Duration', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'default' => 'normal',
                    'options' => [
                        'slow'   => __( 'Slow', 'solatec' ),
                        'normal' => __( 'Normal', 'solatec' ),
                        'fast'   => __( 'Fast', 'solatec' ),
                    ],
                    'condition' => [
                        $args['prefix'].'btn_animation!' => '',
                    ]
                ]
            );
            $widget->add_control(
                $args['prefix'].'btn_animation_delay',
                [
                    'label'     => esc_html__( 'Animation Delay', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::NUMBER,
                    'min'       => 0,
                    'step'      => 100,
                    'default'   => 300,
                    'condition' => [
                        $args['prefix'].'btn_animation!' => ''
                    ]
                ]
            );
        }
    }
}
// Button Render
if(!function_exists('solatec_elementor_button_render')){
    function solatec_elementor_button_render( $settings, $args = []){
        $args = wp_parse_args($args, [
            'post_id'     => '',
            'tag'         => 'div',
            'overwrite'   => false,
            'prefix'      => '',
            'wrap'        => true,
            'class'       => '',
            'btn_class'   => '',
            'icon_before' => '',
            'icon_after'  => '',
            'custom_link' => '',
            'default'     => [
                'btn_text'        => '',
                'btn_type'        => '',
                'btn_style'       => 'btn-style-1',
                'btn_color'       => 'accent',
                'btn_hover_color' => 'primary',
                'btn_size'        => 'lg'
            ],
            'align' => '',
            'attrs' => '',
            'btn_animation'       => '',
            'btn_animation_delay' => ''
        ]);
        if(empty($settings[$args['prefix'].'btn_text'])) return;
        $button_attrs = [];
        $button_class = [$settings[$args['prefix'].'btn_type']];
        
        if($settings[$args['prefix'].'btn_link_type'] === 'page'){
            $button_attrs[] = 'href="'.solatec_get_link_by_slug($settings[$args['prefix'].'btn_link_page'],'page').'"';
            $lightbox_url = solatec_get_link_by_slug($settings[$args['prefix'].'btn_link_page'],'page');
        } elseif ( ! empty( $settings[$args['prefix'].'btn_link']['url'] ) ) {
            // link 
            $url = str_replace(' ', '', $settings[$args['prefix'].'btn_link']['url']);
            $lightbox_url = $url;
            $button_attrs[] = 'href="'.$url.'"';
            // target
            if ( $settings[$args['prefix'].'btn_link']['is_external'] ) {
                $button_attrs[]  = 'target = "_blank"';
            }
            // rel
            if ( $settings[$args['prefix'].'btn_link']['nofollow'] ) {
                $button_attrs[] = 'rel="nofollow"';
            }
        } elseif($settings[$args['prefix'].'btn_link_type'] === 'post'){
            $button_attrs[] = 'href="'.get_the_permalink($args['post_id']).'"';
            $lightbox_url = get_the_permalink($args['post_id']);
        }  elseif($settings[$args['prefix'].'btn_link_type'] === 'video'){
            $button_attrs[] = 'href="'.$args['custom_link'].'"';
            $lightbox_url = $args['custom_link'];
            $button_class[] = 'cms-video-button';
        }
        if(empty($settings[$args['prefix'].'btn_type'])) $settings[$args['prefix'].'btn_type'] = $args['default']['btn_type'];
        if( !in_array($settings[$args['prefix'].'btn_type'], ['just-link','btn-overlay']) ){
            if ( ! empty( $settings[$args['prefix'].'btn_color'] ) ) {
                $button_class[] = 'btn-' . $settings[$args['prefix'].'btn_color'];
            }
            if ( ! empty( $settings[$args['prefix'].'btn_hover_color'] ) ) {
                $button_class[] = 'btn-hover-' . $settings[$args['prefix'].'btn_hover_color'];
            }
            if ( ! empty( $settings[$args['prefix'].'btn_size'] ) ) {
                $button_class[] = 'btn-' . $settings[$args['prefix'].'btn_size'];
            }
        } else {
            if ( ! empty( $settings[$args['prefix'].'btn_color'] ) ) {
                $button_class[] = 'text-' . $settings[$args['prefix'].'btn_color'];
            }
            if ( ! empty( $settings[$args['prefix'].'btn_hover_color'] ) ) {
                $button_class[] = 'text-hover-' . $settings[$args['prefix'].'btn_hover_color'];
            }
            if ( ! empty( $settings[$args['prefix'].'btn_size'] ) ) {
                $button_class[] = 'btn-' . $settings[$args['prefix'].'btn_size'];
            }
        }
        //$button_class[] = 'text-'.$settings[$args['prefix'].'align'];
        if( !empty($settings[$args['prefix'].'align'.'_mobile']) && $settings[$args['prefix'].'align'.'_mobile'] === 'justify' ){
            $button_class[] = 'd-sm-block';
        }
        if( !empty($settings[$args['prefix'].'align'.'_tablet']) && $settings[$args['prefix'].'align'.'_tablet'] === 'justify'){
            $button_class[] = 'd-md-block';
        }
        if( !empty($settings[$args['prefix'].'align']) && $settings[$args['prefix'].'align'] === 'justify' && ($settings[$args['prefix'].'align'.'_mobile'] !== 'justify' && $settings[$args['prefix'].'align'.'_tablet'] !== 'justify' ) ) {
            $button_class[] = 'd-block';
        } elseif( !empty($settings[$args['prefix'].'align']) && $settings[$args['prefix'].'align'] === 'justify'){
            $button_class[] = 'd-lg-block';
        }

        $button_class[] = $args['btn_class'];
        $button_class[] = $settings[$args['prefix'].'btn_css_class'];
        // button animation
        if(isset($settings[$args['prefix'].'btn_animation']) && ( $settings[$args['prefix'].'btn_animation'] !== '' || $args['btn_animation'] !== '' )){
            $button_class[] = 'cms-animate elementor-invisible';
        }
        // Button attrs
        $button_attrs[] = 'class="'.trim(implode(' ', $button_class)).'"';
        if($settings[$args['prefix'].'show_in_popup'] === 'true'){
            $button_class[] = 'elementor-clickable'; //'cms-popup';
            $button_attrs[] = 'data-elementor-open-lightbox="yes"';
            $button_attrs[] = 'data-elementor-lightbox={"type":"html","videoType":"youtube","url":"'.$lightbox_url.'","modalOptions":{"id":"cms-lightbox-'.$settings['element_id'].'","entranceAnimation":"","entranceAnimation_tablet":"","entranceAnimation_mobile":"","videoAspectRatio":169}}';
        }
        $is_new = \Elementor\Icons_Manager::is_migration_allowed();

        $settings[$args['prefix'].'icon_align'] = isset($settings[$args['prefix'].'icon_align']) ? $settings[$args['prefix'].'icon_align'] : 'left';
        
        // Button Animation
        $btn_animation = !empty($settings[$args['prefix'].'btn_animation']) ? $settings[$args['prefix'].'btn_animation'] : $args['btn_animation'];
        $btn_animation_delay = !empty($settings[$args['prefix'].'btn_animation_delay']) ? $settings[$args['prefix'].'btn_animation_delay'] : $args['btn_animation_delay'];
        
        if(isset($settings[$args['prefix'].'btn_animation']) && ($settings[$args['prefix'].'btn_animation'] !== '' || $args['btn_animation'] !== '' )){
            $button_attrs[] = 'data-settings=\''.json_encode([
                '_animation'      => $btn_animation,
                'animation'       => $btn_animation,
                'animation_delay' => $btn_animation_delay
            ]).'\'';
        }

        if($args['wrap'] == true):
    ?>
        <<?php echo esc_html($args['tag']);?> class="cms-btn-wraps <?php echo esc_attr($args['class'].' '.solatec_elementor_align_class($settings, $args['prefix'].'align') );?>">
    <?php endif; ?>
            <a <?php echo trim(implode(' ', $button_attrs)); ?>>
                <span class="cms-btn-content cms-btn-content-<?php echo esc_attr($args['prefix']);?>">
                    <?php if(!empty($settings[$args['prefix'].'btn_icon']['value']) && ($settings[$args['prefix'].'show_btn_icon'] === 'true' || $settings[$args['prefix'].'show_btn_icon'] === 'yes'  )) : ?>
                        <span class="cms-btn-icon order-<?php echo esc_attr($settings[$args['prefix'].'icon_align']);?>  rtl-flip">
                            <?php
                                \Elementor\Icons_Manager::render_icon( $settings[$args['prefix'].'btn_icon'], [ 'aria-hidden' => 'true' ] );
                            ?>
                        </span>
                    <?php endif; 
                    if($settings[$args['prefix'].'show_btn_text'] === 'true' || $settings[$args['prefix'].'show_btn_text'] === 'yes') {
                    ?>
                    <span class="cms-btn-text"><?php printf('%s', $settings[$args['prefix'].'btn_text']); ?></span>
                    <?php } ?>
                </span>
            </a>
        <?php  if($args['wrap'] == true): ?>
        </<?php echo esc_html($args['tag']);?>>
    <?php
        endif;
    }
}
// Button Link Render
if(!function_exists('solatec_elementor_button_link_render')){
    function solatec_elementor_button_link_render( $settings, $args = []){
        $args = wp_parse_args($args, [
            'text'   => '',
            'prefix' => ''
        ]);
        if(empty($args['text'])) return;
        $button_attrs = [];        
        if($settings[$args['prefix'].'btn_link_type'] === 'page'){
            $button_attrs[] = 'href="'.solatec_get_link_by_slug($settings[$args['prefix'].'btn_link_page'],'page').'"';
        } elseif ( ! empty( $settings[$args['prefix'].'btn_link']['url'] ) ) {
            // link 
            $button_attrs[] = 'href="'.$settings[$args['prefix'].'btn_link']['url'].'"';
            // target
            if ( $settings[$args['prefix'].'btn_link']['is_external'] ) {
                $button_attrs[]  = 'target = "_blank"';
            }
            // rel
            if ( $settings[$args['prefix'].'btn_link']['nofollow'] ) {
                $button_attrs[] = 'rel="nofollow"';
            }
        } elseif($settings[$args['prefix'].'btn_link_type'] === 'post'){
            $button_attrs[] = 'href="'.get_the_permalink($args['post_id']).'"';
        }  elseif($settings[$args['prefix'].'btn_link_type'] === 'video'){
            $button_attrs[] = 'href="'.$args['custom_link'].'"';
        }
       ?>
            <a <?php echo trim(implode(' ', $button_attrs)); ?>>
                <?php echo esc_html($args['text']); ?>
            </a>
        <?php 
    }
}
// Image Render 
if(!function_exists('solatec_elementor_image_render')){
    function solatec_elementor_image_render($settings, $args = [],  $data = []){
        $args = wp_parse_args($args, [
            'id'          => 'selected_img',
            'size'        => 'thumbnail_size',
            'custom_size' => '',
            'class'       => '',
            'default'     => true,
            'before'      => '',
            'after'       => ''
        ], $data);   
        $settings = !empty($data) ? $data : $settings;
        if(empty($settings[$args['id']])) return;
        if(empty($args['custom_size'])){
            $thumbnail_size_custom = isset($settings[$args['size'].'_custom_dimension']) ? $settings[$args['size'].'_custom_dimension'] : ['width' => '', 'height' => ''];
            if(isset($settings[$args['size'].'_size']) && $settings[$args['size'].'_size'] != 'custom'){
                $img_size = $settings[$args['size'].'_size'];
            }
            elseif(!empty($thumbnail_size_custom['width']) && !empty($thumbnail_size_custom['height'])){
                $img_size = $thumbnail_size_custom['width'] . 'x' . $thumbnail_size_custom['height'];
            }
            else{
                $img_size = 'full';
            }
        } else {
            $img_size = $args['custom_size'];
        }
        solatec_image_by_size([
            'id'      => $settings[$args['id']]['id'],
            'size'    => $img_size,
            'class'   => $args['class'],
            'default' => $args['default'],
            'before'  => $args['before'],
            'after'   => $args['after']
        ]);
    }
}

// Render icon 
if(!function_exists('solatec_elementor_icon_render')){
    function solatec_elementor_icon_render( $settings, $args = []){
        $args = wp_parse_args($args, [
            'id'         => 'selected_icon',
            'loop'       => false,
            'tag'        => 'div',   
            'wrap_class' => '',
            'class'      => '',
            'style'      => '',
            'before'     => '',
            'after'      => '',
            'atts'       => [],
            'default_icon'    => [
                'value'   => '',
                'library' => ''
            ]
        ]);
        if($args['loop']) {
            $icon = $args['id'];
        } else {
            $icon = $settings[$args['id']];
        }
        if(empty($icon['value'])) $icon = $args['default_icon'];
        if(empty($icon['value'])) return;
        $atts = [];
        foreach ($args['atts'] as $key => $att) {
            $atts[] = $key.'='.$att;
        }
        printf('%s', $args['before']);
        ?>
        <<?php echo esc_html($args['tag']);?> class="<?php echo trim(implode(' ',['cms-icon-wrap', $args['wrap_class']]));?>" <?php echo implode(' ', $atts);?>><?php 
            \Elementor\Icons_Manager::render_icon( $icon, [ 
                'aria-hidden' => 'true', 
                'class'       => trim(implode(' ', ['cms-icon', $args['class'] ])),
                'style'       => $args['style']  
            ]); 
        ?></<?php echo esc_html($args['tag']);?>>
        <?php
        printf('%s', $args['after']);
    }
}

// Render link options
if(!function_exists('solatec_elementor_link_render')){
    function solatec_elementor_link_render($key, $args =[]){
        $attributes = $atts = [];
        if ( ! empty( $key['url'] ) ) {
            $attributes['href'] = esc_url( $key['url'] );
        }

        if ( ! empty( $key['is_external'] ) ) {
            $attributes['target'] = '_blank';
        }

        if ( ! empty( $key['nofollow'] ) ) {
            $attributes['rel'] = 'nofollow';
        }
        
        if ( ! empty( $key['custom_attributes'] ) ) {
            // Custom URL attributes should come as a string of comma-delimited key|value pairs
            $attributes = array_merge( $attributes, solatec_parse_custom_attributes( $key['custom_attributes'] ) );
        }

        $attributes = solatec_array_merge_recursive($attributes, $args);
        
        echo trim(implode(' ', $attributes));
    }
}
// Get Excerpt
if(!function_exists('solatec_elementor_excerpt')){
    function solatec_elementor_excerpt($post, $num_words, $more ){
        if(!empty($post->post_excerpt)){
            echo wp_trim_words( $post->post_excerpt, $num_words, $more = null );
        } else {
            $content = strip_shortcodes( $post->post_content );
            $content = apply_filters( 'the_content', $content );
            $content = str_replace(']]>', ']]&gt;', $content);
            echo wp_trim_words( $content, $num_words, '' );
        }
    }
}
// Custom Attributes 
if(!function_exists('solatec_parse_custom_attributes')){
    function solatec_parse_custom_attributes( $attributes_string, $delimiter = ',' ) {
        $attributes = explode( $delimiter, $attributes_string );
        $result = [];

        foreach ( $attributes as $attribute ) {
            $attr_key_value = explode( '|', $attribute );

            $attr_key = mb_strtolower( $attr_key_value[0] );

            // Remove any not allowed characters.
            preg_match( '/[-_a-z0-9]+/', $attr_key, $attr_key_matches );

            if ( empty( $attr_key_matches[0] ) ) {
                continue;
            }

            $attr_key = $attr_key_matches[0];

            // Avoid Javascript events and unescaped href.
            if ( 'href' === $attr_key || 'on' === substr( $attr_key, 0, 2 ) ) {
                continue;
            }

            if ( isset( $attr_key_value[1] ) ) {
                $attr_value = trim( $attr_key_value[1] );
            } else {
                $attr_value = '';
            }

            $result[ $attr_key ] = $attr_value;
        }

        return $result;
    }
}
// Badge
if(!function_exists('solatec_elementor_badge_render')){
    function solatec_elementor_badge_render($settings, $args = []){
        $args = wp_parse_args($args, [
            'show_badge' => 'show_badge',
            'badge_text' => 'badge_text',
            'class'      => '',
            'style'      => '1',
            'before'     => '',
            'after'      => ''        
        ]);
        if($settings[$args['show_badge']] === 'true'){
            printf('%s', $args['before']);
            ?>
            <div class="cms-badge cms-badge-<?php echo esc_attr($args['style']);?> <?php echo esc_attr($args['class']);?>">
                <div class="cms-badge-text empty-none"><?php if(!empty($settings[$args['badge_text']])) echo esc_html($settings[$args['badge_text']]); ?></div>
            </div>
        <?php
            printf('%s', $args['after']);
        }
    }
}

// Zocdoc rating 
if(!function_exists('solatec_zocdoc_rating')){
    function solatec_zocdoc_rating($args = []){
        $args = wp_parse_args($args, [
            'show_rating'        => 'true',
            'rating_rated'       => '4.9',
            'rating_total'       => '7541',
            'rating_text1'       => esc_html__('Zocdoc', 'solatec'),
            'rating_text2'       => esc_html__('Overall Rating', 'solatec'),
            'rating_text3'       => esc_html__(', based on.', 'solatec'),
            'rating_text4'       => esc_html__('reviews.', 'solatec'),
            'rated_color'        => 'white',
            'text1_color'        => 'accent',
            'wrap_class'  => ''  
        ]);
        if($args['show_rating'] !== 'true') return;
        ?>
            <div class="<?php echo trim(implode(' ', ['cms-zodoc-rating row align-items-center gutters-20', $args['wrap_class'], 'text-'.$args['rated_color'] ]));?>">
                <div class="cms-zodoc-rated col-auto cms-heading text-37 text-<?php echo esc_attr($args['rated_color']);?>"><?php 
                    echo esc_html($args['rating_rated']);
                ?></div>
                <div class="cms-zodoc-text col">
                    <span class="text-13"><span class="text-border-bottom"><span class="text-14 font-700 text-<?php echo esc_attr($args['text1_color']);?>"><?php echo esc_html($args['rating_text1']);?></span> <?php echo esc_html($args['rating_text2']);?></span><?php echo esc_html($args['rating_text3']);?> <?php echo esc_html($args['rating_total']);?> <?php echo esc_html($args['rating_text4']);?></span>
                </div>
            </div>
        <?php
    }
}

/**
 * @since 2.0.0
*/
// Responsive option 
if(!function_exists('solatec_elementor_responsive_settings')){
    function solatec_elementor_responsive_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'prefix'       => 'cms',
            'prefix_class' => ''
        ]);
        $widget->add_control(
            $args['prefix'].'responsive_description',
            [ 
                'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                'type'            => \Elementor\Controls_Manager::RAW_HTML,
                'content_classes' => 'elementor-descriptor',
            ]
        );
        $widget->add_control(
            $args['prefix'].'hide_desktop',
            [
                'label'        => __( 'Hide On Desktop', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::SWITCHER,
                'default'      => '',
                'label_on'     => 'Hide',
                'label_off'    => 'Show',
                'return_value' => 'elementor-hidden-desktop'
            ]
        );
        $widget->add_control(
            $args['prefix'].'hide_tablet',
            [
                'label'        => __( 'Hide On Tablet', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::SWITCHER,
                'default'      => '',
                'label_on'     => 'Hide',
                'label_off'    => 'Show',
                'return_value' => 'elementor-hidden-tablet'
            ]
        );
        $widget->add_control(
            $args['prefix'].'hide_mobile',
            [
                'label'        => __( 'Hide On Mobile', 'solatec' ),
                'type'         => \Elementor\Controls_Manager::SWITCHER,
                'default'      => '',
                'label_on'     => 'Hide',
                'label_off'    => 'Show',
                'return_value' => 'elementor-hidden-phone'
            ]
        );
        
        return $default;
    }
}
if(!function_exists('solatec_add_hidden_device_controls')){
    function solatec_add_hidden_device_controls($widget = [], $args = []) {
        $args = wp_parse_args($args, [
            'prefix'    => 'cms',
            'condition' => []
        ]);
        // The 'Hide On X' controls are displayed from largest to smallest, while the method returns smallest to largest.
        $active_devices = \Elementor\Plugin::$instance->breakpoints->get_active_devices_list( [ 'reverse' => true ] );
        $active_breakpoints = \Elementor\Plugin::$instance->breakpoints->get_active_breakpoints();

        foreach ( $active_devices as $breakpoint_key ) {
            $label = 'desktop' === $breakpoint_key ? esc_html__( 'Desktop', 'solatec' ) : $active_breakpoints[ $breakpoint_key ]->get_label();
            $widget->add_control(
                $args['prefix'].'hide_' . $breakpoint_key,
                [
                    /* translators: %s: Device name. */
                    'label'        => sprintf( __( 'Hide On %s', 'solatec' ), $label ),
                    'type'         => \Elementor\Controls_Manager::SWITCHER,
                    'default'      => '',
                    //'prefix_class' => 'elementor-',
                    'label_on'     => esc_html__( 'Hide', 'solatec' ),
                    'label_off'    => esc_html__( 'Show', 'solatec' ),
                    //'return_value' => 'hidden-' . $breakpoint_key,
                    'condition'    => $args['condition']
                ]
            );
        }
    }
}
if(!function_exists('solatec_add_hidden_device_controls_render')){
    function solatec_add_hidden_device_controls_render($settings = [], $prefix = ''){
        $active_devices     = \Elementor\Plugin::$instance->breakpoints->get_active_devices_list( [ 'reverse' => true ] );
        $active_breakpoints = \Elementor\Plugin::$instance->breakpoints->get_active_breakpoints();
        $hidden             = [];
        foreach ($active_devices as $device) {
            $hidden[] = ($settings[$prefix.'hide_'.$device] === 'yes') ? 'cms-hidden-'.$device : '';
        }
        return implode(' ',array_filter($hidden));
    }
}

if(!function_exists('solatec_elementor_responsive_render')){
    function solatec_elementor_responsive_render($settings, $args = []){
        $args = wp_parse_args($args, [
            'prefix' => 'cms'
        ]);
        /*$hidden = [
            $settings[$args['prefix'].'hide_desktop'],
            $settings[$args['prefix'].'hide_tablet'],
            $settings[$args['prefix'].'hide_mobile'],
        ];
        return implode(' ',$hidden);*/

        $active_devices     = \Elementor\Plugin::$instance->breakpoints->get_active_devices_list( [ 'reverse' => true ] );
        $active_breakpoints = \Elementor\Plugin::$instance->breakpoints->get_active_breakpoints();
        $hidden             = [];
        foreach ($active_devices as $device) {
            $hidden[] = ($settings[$args['prefix'].'hide_'.$device] === 'yes') ? 'elementor-hidden-'.$device : ''; 
        }
        return implode(' ',array_filter($hidden));
    }
}

// Button Video Settings
if(!function_exists('solatec_elementor_button_video_settings')){
    function solatec_elementor_button_video_settings ($widget, $args = []){
        $args = wp_parse_args($args, [
            'prefix'    => '',
            'separator' => '',
            'effect'    => false,
            'default'   => true
        ]);
        $url = '';
        if($args['default']) $url = 'https://www.youtube.com/watch?v=iYf3OgEdGmo';
        $widget->add_control(
            $args['prefix'].'video_link',
            [
                'label'       => __( 'Video URL', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::URL,
                'default'     => [
                    'url'         => $url,
                    'is_external' => 'on'
                ],
                'separator' => $args['separator'],
                'description' => 'https://www.youtube.com/watch?v=iYf3OgEdGmo'
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_play_shape',
            [
                'label'       => __( 'Play Button Shape', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => [
                    ''       => __('Default', 'solatec'),
                    'ripple' => __('Cirle with Ripple', 'solatec'),
                    'btn'    => __('Button', 'solatec'),
                ],
                'default'     => '',
                'separator' => 'before'
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_play_btn_size',
            [
                'label'   => esc_html__('Dimensions', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    '' => __('Default','solatec'),
                    '22' => __('Size (22)','solatec'), 
                    '42' => __('Size (42)','solatec'), 
                    '46' => __('Size (46)','solatec'), 
                    '68' => __('Size (68)','solatec'), 
                    '82' => __('Size (82)','solatec'), 
                    '88' => __('Size (88)','solatec'), 
                    '90' => __('Size (90)','solatec'),
                ],
                'default' => '',
                'condition' => [
                    $args['prefix'].'video_play_shape' => ['ripple']
                ]
            ]
        );
        $widget->add_control(
            $args['prefix'].'play_icon_icon',
            [
                'label'   => esc_html__( 'Play Icon', 'solatec' ),
                'type'    => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'library'   => 'cmsi',
                    'value'     => 'cmsi-play'
                ],
                'separator'   => 'before'
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_icon_color',
            [
                'label'       => __( 'Video Icon Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'default'     => ''  
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_icon_color_hover',
            [
                'label'       => __( 'Video Icon Color Hover', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'default'     => ''  
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_text',
            [
                'label'       => __( 'Video Text', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::TEXT,
                'default'     => __('Our Video','solatec'),
                'separator'   => 'before'
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_text_color',
            [
                'label'       => __( 'Text Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'condition'   => [
                     $args['prefix'].'video_text!' => ''
                ],
                'default'     => ''  
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_play_color',
            [
                'label'       => __( 'Play Background Color', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'default'     => '',
                'separator'   => 'before' 
            ]
        );
        $widget->add_control(
            $args['prefix'].'video_play_color_hover',
            [
                'label'       => __( 'Play Background Color Hover', 'solatec' ),
                'type'        => \Elementor\Controls_Manager::SELECT,
                'options'     => solatec_elementor_theme_color_opts(['custom' =>  false]),
                'default'     => ''  
            ]
        );
        if($args['effect'] === true){
            $widget->add_control(
                $args['prefix'].'video_animation',
                [
                    'label'     => esc_html__( 'Button Video Effect', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::ANIMATION,
                    'condition' => [
                        $args['prefix'].'video_link[url]!' => ''
                    ],
                    'separator'   => 'before'
                ]
            );
            $widget->add_control(
                $args['prefix'].'video_animation_duration', 
                [
                    'label'   => __( 'Animation Duration', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'default' => 'normal',
                    'options' => [
                        'slow'   => __( 'Slow', 'solatec' ),
                        'normal' => __( 'Normal', 'solatec' ),
                        'fast'   => __( 'Fast', 'solatec' ),
                    ],
                    'condition' => [
                        $args['prefix'].'video_link[url]!' => '',
                        $args['prefix'].'video_animation!' => '',
                    ]
                ]
            );
            $widget->add_control(
                $args['prefix'].'video_animation_delay',
                [
                    'label'     => esc_html__( 'Animation Delay', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::NUMBER,
                    'min'       => 0,
                    'step'      => 100,
                    'condition' => [
                        $args['prefix'].'video_link[url]!' => '',
                        $args['prefix'].'video_animation!' => ''
                    ]
                ]
            );
        }
    }
}
// Render popup video attrs
if(!function_exists('solatec_elementor_render_lightbox_video_atts')){
    function solatec_elementor_render_lightbox_video_atts($widget, $settings, $args= []){
        $args = wp_parse_args($args, [
            'prefix'    => '',
            'video_url' => '',
            'animation' => 'fadeInUp',
            'ratio'     => '169'
        ]);
        $embed_params = [
            'loop'           => '0',
            'controls'       => '1',
            'mute'           => '0',
            'rel'            => '0',
            'modestbranding' => '0'
        ];
        $embed_options = [];
        $widget->add_render_attribute( 'video_atts', 'data-elementor-open-lightbox', 'yes');
        $widget->add_render_attribute( 'video_atts', 'data-elementor-lightbox', wp_json_encode([
            'type'         => 'video',
            'videoType'    => 'youtube',
            'url'          => \Elementor\Embed::get_embed_url( $args['video_url'], $embed_params, $embed_options ),
            'modalOptions' => [
                'id'                       => 'cms-lightbox-'.$settings['element_id'],
                'entranceAnimation'        => $args['animation'],
                'entranceAnimation_tablet' => '',
                'entranceAnimation_mobile' => '',
                'videoAspectRatio'         => $args['ratio']
            ]
        ]));
        //etc_print_html($widget->get_render_attribute_string( 'video_atts' ));
        $widget->print_render_attribute_string( 'video_atts' );
    }
}
// render popup video html
if(!function_exists('solatec_elementor_render_lightbox_video_button')){
    function solatec_elementor_render_lightbox_video_button($widget, $settings, $args= []){
        $args = wp_parse_args($args, [
            'prefix'                 => '',
            'layout'                 => 'ripple',
            'size'                   => '68',
            'animation'              => 'slideInUp',
            'ratio'                  => '169',
            'class'                  => '',
            'play_icon'              => ['value' => 'cmsi cmsi-play'],  
            'icon_class'             => '',
            'before'                 => '',
            'after'                  => '',
            'outline'                => true,
            'video_animation'        => '',
            'video_animation_delay'  => '',
            'text_class'             => 'col',
            'video_icon_color'       => 'white',
            'video_icon_color_hover' => 'white',
            'video_text_color'       => 'accent',
            'video_play_color'       => 'accent',
            'video_play_color_hover' => 'primary'
        ]);
        if(empty($settings[$args['prefix'].'video_link']['url']) || $settings[$args['prefix'].'video_link']['url'] === null) return;

        $lightbox_id = isset($settings['_id']) ? $settings['_id'] : $settings['element_id'];
        $embed_params = [
            'loop'           => '0',
            'controls'       => '1',
            'mute'           => '0',
            'rel'            => '0',
            'modestbranding' => '0'
        ];
        $video_atts = $embed_options = $animation = [];
        $classes = ['cms-video-lightbox', $args['class']];
        $classes[] = isset($settings[$args['prefix'].'video_animation_duration']) ? 'animated-'.$settings[$args['prefix'].'video_animation_duration'] : '';
        if(!empty($settings[$args['prefix'].'video_animation']) || !empty($args['video_animation'])){
            $classes[] = 'cms-animate cms-invisible';
            $animation  = [
                'animation'       => !empty($settings[$args['prefix'].'video_animation']) ? $settings[$args['prefix'].'video_animation'] : $args['video_animation'],
                'animation_delay' => !empty($settings[$args['prefix'].'video_animation_delay']) ? $settings[$args['prefix'].'video_animation_delay'] : $args['video_animation_delay']
            ];
        }
        $lightbox_options = [
            'type'         => 'video',
            'videoType'    => 'youtube',
            'url'          => \Elementor\Embed::get_embed_url( $settings[$args['prefix'].'video_link']['url'], $embed_params, $embed_options ),
            'modalOptions' => [
                'id'                       => 'cms-lightbox-'.$lightbox_id,
                'entranceAnimation'        => $args['animation'],
                'entranceAnimation_tablet' => '',
                'entranceAnimation_mobile' => '',
                'videoAspectRatio'         => $args['ratio']
            ]
        ];
        //$widget->add_render_attribute('video-atts', [
            $video_atts[] = 'class="'.trim(implode(' ', $classes)).'"';
            $video_atts[] = 'data-settings="'.esc_attr(wp_json_encode($animation)).'"';
            $video_atts[] = 'data-elementor-open-lightbox="yes"';
            $video_atts[] = 'data-elementor-lightbox="'.esc_attr(wp_json_encode( $lightbox_options )).'"';
        //]);
        // play video button
        $video_button = [
            'cms-video-btn',
            'layout-'.$args['layout'],
            'text-center',
            !empty($settings[$args['prefix'].'video_play_color']) ? 'bg-'.$settings[$args['prefix'].'video_play_color'] : 'bg-'.$args['video_play_color'],
            !empty($settings[$args['prefix'].'video_play_color_hover']) ? 'bg-hover-'.$settings[$args['prefix'].'video_play_color_hover'] : 'bg-hover-'.$args['video_play_color_hover'],
            !empty($settings[$args['prefix'].'video_icon_color']) ? 'text-'.$settings[$args['prefix'].'video_icon_color'] : 'text-'.$args['video_icon_color'],
            !empty($settings[$args['prefix'].'video_icon_color_hover']) ? 'text-hover-'.$settings[$args['prefix'].'video_icon_color_hover'] : 'text-hover-'.$args['video_icon_color_hover'],
            !empty($settings[$args['prefix'].'video_play_btn_size']) ? 'size-'.$settings[$args['prefix'].'video_play_btn_size'] : 'size-'.$args['size'],
            $args['icon_class']
        ];
        if($args['outline']) $video_button[] = 'has-outline';
        // play video text 
        $video_text_class = [
            'empty-none font-700 lh-1',
            !empty($settings[$args['prefix'].'video_text_color']) ? 'text-'.$settings[$args['prefix'].'video_text_color'] : 'text-'.$args['video_text_color'],
            $args['text_class']
        ];
        $layout = !empty($settings[$args['prefix'].'video_play_shape']) ? $settings[$args['prefix'].'video_play_shape'] : $args['layout'];
        $play_icon = !empty($settings[$args['prefix'].'play_icon_icon']['value']) ? $settings[$args['prefix'].'play_icon_icon']['value'] : $args['play_icon'];

        printf('%s', $args['before']);
        ?>
        <div <?php echo trim(implode(' ', $video_atts)); ?>>
            <?php switch ($layout) {
                case 'btn':
            ?>
                <div class="<?php echo solatec_nice_class($video_button); ?>"><?php 
                        if($args['outline']) echo  '<div class="cms-video-btn-outline"></div>'; 
                    ?>
                        <span class="<?php echo esc_attr($play_icon);?>"></span>
                        <span class="<?php echo solatec_nice_class($video_text_class); ?>"><?php etc_print_html($settings[$args['prefix'].'video_text']); 
                ?></span>
                </div>
            <?php
                    break;
                default:
                $video_button[] = 'cms-ripple';
            ?>
            <div class="row align-items-center gutters-30">
                <div class="col-auto">
                    <div class="<?php echo solatec_nice_class($video_button); ?>"><?php 
                        if($args['outline']) echo  '<div class="cms-video-btn-outline"></div>'; 
                    ?><span class="<?php echo esc_attr($play_icon);?>"></span></div>
                </div>
                <div class="<?php echo solatec_nice_class($video_text_class); ?>"><?php etc_print_html($settings[$args['prefix'].'video_text']); 
                ?></div>
            </div>
            <?php 
                break;
            } ?>
        </div>
        <?php
        printf('%s', $args['after']);
    }
}
// Swipper Slider 
if(!function_exists('solatec_swiper_slider_arrows')){
    function solatec_swiper_slider_arrows($settings){
        if(in_array($settings['arrows_pos'], ['in-vertical', 'out-vertical'])): ?>
            <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-prev"></div>
            <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-next"></div>
        <?php endif;
    }
}
if(!function_exists('solatec_swiper_slider_arrows_side')){
    function solatec_swiper_slider_arrows_side($settings){
        if(in_array($settings['arrows_pos'], ['left-side', 'right-side'])): 
        ?>
            <div class="cms-swiper-arrows">
                <div class="cms-swiper-arrows-arrow">
                    <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-prev"></div>
                    <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-next"></div>
                </div>
                <div class="cms-swiper-arrows-additional empty-none"><?php
                        // Link
                        if($settings['arrow_link'] === 'button'){
                            // Button
                            solatec_elementor_button_render($settings,[
                                'prefix'     => 'arrow_link',
                                'icon_class' => '',
                                'class'      => ''
                            ]);
                        } elseif($settings['arrow_link'] === 'text_link') {
                            // Custom Link 
                            solatec_elementor_hyperlink_render($settings,[
                                'prefix'           => 'arrow_link', 
                                'link_type'        => $settings['arrow_link'],
                                'wrap_class'       => '',
                                'class'            => '',
                                'link_color'       => '',
                                'link_hover_color' => '',
                                'default_icon'     => [],
                                'icon_class'       => ''
                            ]);
                        }
                ?></div>
            </div>
            <?php
        endif;
    }
}
if(!function_exists('solatec_swiper_slider_arrows_side2')){
    function solatec_swiper_slider_arrows_side2($settings){
        if(in_array($settings['arrows_pos'], ['left-side2', 'right-side2'])): 
        ?>
            <div class="cms-swiper-arrows">
                <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-prev"></div>
                <?php  solatec_swiper_slider_dots_in_nav($settings); ?>
                <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-next"></div>
            </div>
        <?php
        endif;
    }
}
if(!function_exists('solatec_swiper_slider_arrows_top')){
    function solatec_swiper_slider_arrows_top($settings, $args = []){
        $args = wp_parse_args($args, [
            'class'  => '',
            'before' => '',
            'after'  => ''
        ]);
        $classes = solatec_nice_class(['cms-swiper-arrows', $args['class']]);
        if(in_array($settings['arrows_pos'], ['top-left', 'top-right', 'top-center'])): ?>
            <div class="<?php echo esc_attr($classes); ?>">
                <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-prev"></div>
                <?php  solatec_swiper_slider_dots_in_nav($settings); ?>
                <div class="cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-next"></div>
            </div>
        <?php endif;
    }
}
if(!function_exists('solatec_swiper_slider_arrows_bottom')){
    function solatec_swiper_slider_arrows_bottom($settings, $args = []){
        if(!in_array($settings['arrows_pos'], ['bottom-left', 'bottom-right','bottom-center'])) return;
        $args = wp_parse_args($args, [
            'class'     => '',
            'icon_prev' => '',
            'icon_next' => '',
            'before'    => '',
            'after'     => ''
        ]);
        $classes = ['cms-swiper-arrows', $args['class'], str_replace('bottom-', 'order-',$settings['arrows_pos']) ];
        printf('%s', $args['before']);
    ?>
        <div class="<?php echo implode(' ', $classes);?>">
            <div class="<?php echo implode(' ', ['cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-prev', $args['icon_prev']]);?>"></div>
            <?php  solatec_swiper_slider_dots_in_nav($settings); ?>
            <div class="<?php echo implode(' ', ['cms-swiper-arrow cmsi-icon rtl-flip cms-swiper-arrow-next', $args['icon_next']]); ?>"></div>
        </div>
    <?php
        printf('%s', $args['after']);
    }
}
if(!function_exists('solatec_swiper_slider_dots')){
    function solatec_swiper_slider_dots($settings, $args=[]){
        if( $settings['dots_in_nav'] === 'true') return;
        $args = wp_parse_args($args, [
            'prefix'           => '',
            'class'            => '',
            'dots_color'       => '',
            'dots_color_hover' => '',
            'dots_layout'      => 'circle',
            'dots_align'       => ''
        ]); 
        $color = !empty( $settings[$args['prefix'].'dots_color'] ) ? $settings[$args['prefix'].'dots_color'] : $args['dots_color'];
        $color_hover = !empty( $settings[$args['prefix'].'dots_color_hover'] ) ? $settings[$args['prefix'].'dots_color_hover'] : $args['dots_color_hover'];
        $layout = !empty( $settings[$args['prefix'].'dots_layout'] ) ? $settings[$args['prefix'].'dots_layout'] : $args['dots_layout'];
        $align = !empty( $settings[$args['prefix'].'dots_align'] ) ? $settings[$args['prefix'].'dots_align'] : $args['dots_align'];

        $classes = ['cms-swiper-dots', 'cms-swiper-dots-color-'.$color, 'cms-swiper-dots-'.$layout, 'cms-swiper-dots-align-'.$align,  $args['class'],'empty-none'];
        ?>
            <div class="<?php echo implode(' ', $classes)?>"></div>
        <?php
    }
}
if(!function_exists('solatec_swiper_slider_dots_in_nav')){
    function solatec_swiper_slider_dots_in_nav($settings, $args=[]){
        if( $settings['dots_in_nav'] !== 'true') return;
        $args = wp_parse_args($args, [
            'prefix'           => '',
            'class'            => '',
            'dots_color'       => '',
            'dots_color_hover' => '',
            'dots_layout'      => 'circle',
            'dots_align'       => ''
        ]); 
        $color = !empty( $settings[$args['prefix'].'dots_color'] ) ? $settings[$args['prefix'].'dots_color'] : $args['dots_color'];
        $color_hover = !empty( $settings[$args['prefix'].'dots_color_hover'] ) ? $settings[$args['prefix'].'dots_color_hover'] : $args['dots_color_hover'];
        $layout = !empty( $settings[$args['prefix'].'dots_layout'] ) ? $settings[$args['prefix'].'dots_layout'] : $args['dots_layout'];
        $align = !empty( $settings[$args['prefix'].'dots_align'] ) ? $settings[$args['prefix'].'dots_align'] : $args['dots_align'];

        $classes = ['cms-swiper-dots','cms-swiper-dots-in-nav', 'cms-swiper-dots-color-'.$color, 'cms-swiper-dots-'.$layout, 'cms-swiper-dots-align-'.$align,  $args['class'],'empty-none'];
        ?>
            <div class="<?php echo implode(' ', $classes)?>"></div>
        <?php
    }
}
if(!function_exists('solatec_swiper_slider_settings')){

    function solatec_swiper_slider_settings($widget, $args = []){
        $args = wp_parse_args($args, [
            'swiper_container' => 'cms-swiper-container',
            'slide_to_show'        => 3,
            'slide_to_show_tablet' => 2,
            'slide_to_show_mobile' => 1, 
            'class'            => ''
        ]);
        $slide_direction         = $widget->get_setting('slide_direction', 'horizontal');
        $slide_percolumn         = (int) $widget->get_setting('slide_percolumn', '1');
        $slide_percolumnfill     = $widget->get_setting('slide_percolumnfill', 'column');
        $slide_mode              = $widget->get_setting('slide_mode', 'slide');
        
        $slides_to_show          = (int) $widget->get_setting('slide_to_show', $args['slide_to_show']);
        $slides_to_show_tablet   = (int) $widget->get_setting('slide_to_show_tablet', $args['slide_to_show_tablet']);
        $slides_to_show_mobile   = (int) $widget->get_setting('slide_to_show_mobile', $args['slide_to_show_mobile']);
        $slides_to_scroll        = (int) $widget->get_setting('slide_to_scroll', $slides_to_show );
        $slides_to_scroll_tablet = (int) $widget->get_setting('slide_to_scroll_tablet', $slides_to_show_tablet);
        $slides_to_scroll_mobile = (int) $widget->get_setting('slide_to_scroll_mobile', $slides_to_show_mobile);

        // show one item
        if(in_array($slide_mode, ['fade', 'cube', 'flip'])){
            $slides_to_show = $slides_to_show_tablet = $slides_to_show_mobile = $slides_to_scroll = $slides_to_scroll_tablet = $slides_to_scroll_mobile = 1;
        } elseif($slide_mode === 'coverflow'){
            $slides_to_show = $slides_to_show_tablet = $slides_to_show_mobile = $slides_to_scroll = $slides_to_scroll_tablet = $slides_to_scroll_mobile = 'auto';
        }

        $slides_gutter        = $widget->get_setting('gap');
        $arrows               = $widget->get_setting('arrows', 'true');
        $arrows_tablet        = $widget->get_setting('arrows_tablet', $arrows);
        $arrows_mobile        = $widget->get_setting('arrows_mobile', $arrows_tablet);
        $dots                 = $widget->get_setting('dots');
        $dots_tablet          = $widget->get_setting('dots_tablet', $dots);
        $dots_mobile          = $widget->get_setting('dots_mobile', $dots);
        $dots_style           = $widget->get_setting('dots_style', 'bullets');
        $dots_style_custom    = $widget->get_setting('dots_style_custom', 'function (swiper, current, total) { return current + \' of \' + total;}');
        $dots_pos             = $widget->get_setting('dots_pos','out');
        $autoplay             = $widget->get_setting('autoplay', 'false');
        $pause_on_hover       = $widget->get_setting('pause_on_hover', 'true');
        $pause_on_interaction = $widget->get_setting('pause_on_interaction', 'true');
        $autoplay_speed       = $widget->get_setting('autoplay_speed', 500);
        $loop                 = $widget->get_setting('loop', 'false');
        $speed                = $widget->get_setting('speed', 300);
        $titlenext            = $widget->get_setting('nav_title_next', 'Next');
        $titleprev            = $widget->get_setting('nav_title_prev', 'Prev');
        $opts = [
            'slide_direction'         => $slide_direction,
            'slide_percolumn'         => $slide_percolumn, 
            'slide_percolumnfill'     => $slide_percolumnfill, 
            'slide_mode'              => $slide_mode, 
            'slides_to_show'          => $slides_to_show, 
            'slides_to_show_tablet'   => $slides_to_show_tablet, 
            'slides_to_show_mobile'   => $slides_to_show_mobile, 
            'slides_to_scroll'        => $slides_to_scroll, 
            'slides_to_scroll_tablet' => $slides_to_scroll_tablet, 
            'slides_to_scroll_mobile' => $slides_to_scroll_mobile, 
            'slides_gutter'           => (int) $slides_gutter, 
            'arrow'                   => $arrows,
            'arrow_tablet'            => $arrows_tablet,
            'arrow_mobile'            => $arrows_mobile,
            'dots'                    => $dots,
            'dots_tablet'             => $dots_tablet,
            'dots_mobile'             => $dots_mobile,
            'dots_style'              => $dots_style,
            'dots_style_custom'       => $dots_style_custom,
            'autoplay'                => $autoplay,
            'pause_on_hover'          => $pause_on_hover,
            'pause_on_interaction'    => $pause_on_interaction,
            'delay'                   => $autoplay_speed,
            'loop'                    => $loop,
            'speed'                   => $speed,
        ];
        $widget->add_render_attribute( 'cms-swiper-settings', [
            'class'         => implode(' ', [$args['swiper_container'], $args['class']]),
            'dir'           => is_rtl() ? 'rtl' : 'ltr',
            'data-settings' => wp_json_encode($opts),
            'data-customdot' => $dots_style_custom
        ]);
        etc_print_html($widget->get_render_attribute_string( 'cms-swiper-settings' ));
        //echo 'data-settings='.wp_json_encode($opts).'';
    }
}
// Testinomial Rating
if(!function_exists('solatec_star_rating')){
    function solatec_star_rating($args = []){
        $args = wp_parse_args($args, [
            'rated' => '100',
            'text'  => ''    
        ]);
    ?>
        <div class="row align-items-center gutters-15 text-accent">
            <div class="col-auto">
                <div class="cms-star-rating relative">
                    <div class="cms-star-rated absolute" data-width="<?php echo esc_attr($args['rated']);?>"></div>
                </div>
            </div>
            <div class="col empty-none text-16 font-700"><?php
                echo esc_html($args['text']);
            ?></div>
        </div>
    <?php
    }
}

// Scan element (need add to bottom of this file)
$files = scandir(get_template_directory() . '/elementor/core/widgets');
foreach ($files as $file){
    $pos = strrpos($file, ".php");
    if($pos !== false){
        require_once get_template_directory() . '/elementor/core/widgets/' . $file;
    }
}