<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_accordion_register_controls')) {
    add_action('etc_widget_cms_accordion_register_controls', 'solatec_widget_cms_accordion_register_controls', 10, 1);
    function solatec_widget_cms_accordion_register_controls($widget)
    {
        // Layout Tab Start

        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT,
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec'),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_accordion/layout-images/1.jpg'
                    ]
                ],
                'prefix_class' => 'cms-accordion-layout-'
            ]);
        $widget->end_controls_section();
        $widget->start_controls_section(
            'source_section',
            [
                'label' => esc_html__( 'Source Settings', 'solatec' ),
                'tab' => Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'active_section',
                [
                    'label'     => esc_html__( 'Active section', 'solatec' ),
                    'type'      => Controls_Manager::NUMBER,
                    'separator' => 'after',
                ]
            );
            $repeater = new Repeater();
            $repeater->add_control(
                'ac_title',
                [
                    'label' => esc_html__( 'Title', 'solatec' ),
                    'type' => Controls_Manager::TEXT,
                ]
            );
            $repeater->add_control(
                'ac_title_icon',
                [
                    'label' => esc_html__( 'Title Icon', 'solatec' ),
                    'type' => Controls_Manager::ICONS,
                    'default' => [
                        'value' => '',
                        'library' => '',
                    ]
                ]
            );
            $repeater->add_control(
                'ac_content',
                [
                    'label' => esc_html__( 'Content', 'solatec' ),
                    'type' => Controls_Manager::TEXTAREA,
                    'rows' => 10,
                ]
            );
            $widget->add_control(
                'cms_accordion',
                [
                    'label'   => esc_html__( 'Accordion Items', 'solatec' ),
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $repeater->get_controls(),
                    'default' => [
                        [
                            'ac_title' => esc_html__( 'Accordion #1', 'solatec' ),
                            'ac_content' => esc_html__( 'Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                        ],
                        [
                            'ac_title' => esc_html__( 'Accordion #2', 'solatec' ),
                            'ac_content' => esc_html__( 'Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                        ],
                    ],
                    'title_field' => '{{{ ac_title }}}',
                    'separator' => 'after',
                ]
            );
        $widget->end_controls_section();
        $widget->start_controls_section(
            'explain_section',
            [
                'label'    => esc_html__( 'Explain Settings', 'solatec' ),
                'tab'      => Controls_Manager::TAB_LAYOUT,
            ]
        );
            $widget->add_control(
                'explain_icon_pos',
                [
                    'label'   => esc_html__('Explain Icon position','solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        'left' => esc_html__('Left','solatec'),
                        'right' => esc_html__('Right','solatec')
                    ],
                    'default' => 'left'
                ]
            );
            $widget->add_control(
                'main_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'   => 'fas fa-plus',
                        'library' => 'fa-solid',
                    ],
                ]
            );
            $widget->add_control(
                'icon_active',
                [
                    'label'            => esc_html__( 'Active Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'   => 'fas fa-minus',
                        'library' => 'fa-solid',
                    ],
                    'condition' => [
                        'main_icon!' => '',
                    ],
                    'separator' => 'after',
                ]
            );
        $widget->end_controls_section();
    }
}