<?php
use Elementor\Controls_Manager;
if (!function_exists('solatec_widget_cms_breadcrumb_register_controls')) {
    add_action('etc_widget_cms_breadcrumb_register_controls', 'solatec_widget_cms_breadcrumb_register_controls', 10, 1);
    function solatec_widget_cms_breadcrumb_register_controls($widget)
    {
        // Layout Tab Start

        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT,
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec'),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_breadcrumb/layout-images/1.jpg'
                    ]
                ],
                'prefix_class' => 'cms-breadcrumb-layout-'
            ]);
        $widget->end_controls_section();
        $widget->start_controls_section('breadcrumb_section', [
            'label' => esc_html__('Breadcrumb', 'solatec'),
            'tab' => Controls_Manager::TAB_CONTENT,
        ]);
            $widget->add_control(
                'breadcrumb_link_color',
                [
                    'label'       => esc_html__( 'Breadcrumb Link Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'separator'     => 'before'
                ]
            );
            $widget->add_control(
                'breadcrumb_link_custom_color',
                [
                    'label'       => esc_html__( 'Custom Breadcrumb Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'condition'   => [
                        'breadcrumb_link_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'breadcrumb_color',
                [
                    'label'       => esc_html__( 'Breadcrumb Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'separator'     => 'before'
                ]
            );
            $widget->add_control(
                'breadcrumb_custom_color',
                [
                    'label'       => esc_html__( 'Custom Breadcrumb Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'condition'   => [
                        'breadcrumb_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'breadcrumb_separator',
                [
                    'label'            => esc_html__( 'Custom Breadcrumb Separator', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}