<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_careers_register_controls')) {
    add_action('etc_widget_cms_careers_register_controls', 'solatec_widget_cms_careers_register_controls', 10, 1);
    function solatec_widget_cms_careers_register_controls($widget)
    {
        // Layout Tab Start

        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_text_align($widget, ['default' => '']);
            $widget->add_control(
                'hover_effect',
                [
                    'label'   => esc_html__( 'Hover Styles', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        '' => esc_html__('Default','solatec'),
                    ],
                    'default' => ''
                ]
            );
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec'),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_careers/layout-images/1.jpg'
                    ]
                ],
                'prefix_class' => 'cms-careers-layout-'
            ]);
        $widget->end_controls_section();
        // Carousel Settings
        $widget->start_controls_section(
            'carousel_section',
            [
                'label'    => esc_html__( 'Career Items', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $repeater = new Repeater();
            $repeater->add_control(
                'job_type',
                [
                    'label'       => esc_html__( 'Job Type', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXT,
                    'placeholder' => esc_html__( 'Enter your job type', 'solatec' ),
                    'dynamic'   => [
                        'active' => true,
                    ],
                ]
            );
            $repeater->add_control(
                'job_address',
                [
                    'label'       => esc_html__( 'Job Address', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXT,
                    'placeholder' => esc_html__( 'Enter your jon address', 'solatec' ),
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'before'
                ]
            );
            $repeater->add_control(
                'title',
                [
                    'label'       => esc_html__( 'Title', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'before'
                ]
            );
            $repeater->add_control(
                'description',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'after'
                ]
            );
            solatec_elementor_button_settings($repeater, [
                'btn_text'         => 'Read More',
                'btn_type_default' => 'btn btn-outline'
            ]);
            $widget->add_control(
                'career_list',
                [
                    'label'   => esc_html__( 'Add Career', 'solatec' ),
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $repeater->get_controls(),
                    'default' => [
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ],
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ],
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ],
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ],
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ],
                        [
                            'job_type'    => '',
                            'job_address' => '',
                            'title'       => '',
                            'description' => '',
                        ]
                    ],
                    'title_field' => '{{{ title }}}',
                    'separator' => 'after',
                ]
            );
        $widget->end_controls_section();
        solatec_elementor_slick_slider_settings($widget);
    }
}