<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_clients_register_controls')) {
    add_action('etc_widget_cms_clients_register_controls', 'solatec_widget_cms_clients_register_controls', 10, 1);
    function solatec_widget_cms_clients_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_clients/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__('Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_clients/layout-images/2.png'
                    ],
                ],
                'prefix_class' => 'cms-clients-layout-'
            ]);
        $widget->end_controls_section();
        // Slider Settings
        solatec_elementor_slick_slider_settings($widget, [
            'tab'       => \Elementor\Controls_Manager::TAB_LAYOUT,
        ]);
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'    => esc_html__( 'Heading', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ],
                    'condition' => [
                        'layout'    => ['99']                            
                    ],
                ]
            );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => false,
                    'condition'   => [
                        'heading_text!'      => ''
                    ],
                ]
            );
            $widget->add_control(
                'heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'label_block' => false,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'heading_animation',
                [
                    'label'       => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::ANIMATION,
                    'label_block' => false,
                    'condition'   => [
                        'heading_text!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        $widget->start_controls_section(
            'subheading_section',
            [
                'label'    => esc_html__( 'Sub Heading', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'subheading_text',
                [
                    'label'       => esc_html__( 'Sub Heading', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your sub title', 'solatec' ),
                    'label_block' => true,
                    'condition'   => [],
                ]
            );
            $widget->add_control(
                'subheading_color',
                [
                    'label'       => esc_html__( 'Sub Heading Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => false,
                    'condition'   => [
                        'subheading_text!'      => ''
                    ],
                ]
            );
            $widget->add_control(
                'sheading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Sub Heading Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'label_block' => false,
                    'condition'   => [
                        'subheading_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'subheading_animation',
                [
                    'label'       => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::ANIMATION,
                    'label_block' => false,
                    'condition'   => [
                        'subheading_text!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        // Clients
        $widget->start_controls_section(
            'clients_list',
            [
                'label'    => esc_html__('Clients', 'solatec'),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]      
        );
            $repeater = new Repeater();
            $repeater->add_control(
                'name',
                [
                    'label'       => esc_html__('Client Name', 'solatec'),
                    'type'        => \Elementor\Controls_Manager::TEXT,
                    'label_block' => true,
                ]
            );
            $repeater->add_control(
                'description',
                [
                    'label'       => esc_html__('Client Description', 'solatec'),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'label_block' => true,
                ]
            );
            $repeater->add_control(
                'image',
                [
                    'label'       => esc_html__('Client Image', 'solatec'),
                    'type'        => \Elementor\Controls_Manager::MEDIA,
                    'label_block' => true,
                ]
            );
            $repeater->add_control(
                'image_link',
                [
                    'label'       => esc_html__( 'Client Link', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::URL,
                    'placeholder' => esc_html__( 'https://your-link.com', 'solatec' ),
                    'default'     => [
                        'url'         => '#',
                        'is_external' => 'on'
                    ],
                ]
            );
            $widget->add_control(
                'clients',
                [
                    'label'   => esc_html__( 'Add Client', 'solatec' ),
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $repeater->get_controls(),
                    'default' => [
                        [
                            'name'        => 'Name #1',
                            'description' => ''
                        ],
                        [
                            'name'        => 'Name #2',
                            'description' => ''
                        ],
                        [
                            'name'        => 'Name #3',
                            'description' => ''
                        ],
                        [
                            'name'        => 'Name #4',
                            'description' => '',
                        ],
                        [
                            'name'        => 'Name #5',
                            'description' => '',
                        ],
                        [
                            'name'        => 'Name #6',
                            'description' => '',
                        ]
                    ],
                    'title_field' => '{{{ name }}}',
                ]
            );
            $widget->add_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'thumbnail',
                    'label'        => esc_html__('Images Size','solatec'),
                    'control_type' => 'group',
                    'default'      => 'full',
                ]
            );
        $widget->end_controls_section();
        // Hover
        $widget->start_controls_section(
            'hover_section',
            [
                'label'    => esc_html__( 'Hover Settings', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'hover_style',
                [
                    'label'       => esc_html__( 'Hover Style', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::COLOR,
                    'label_block' => true,
                    'options'     => [
                        ''      => esc_html__('Default', 'solatec')
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}