<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_company_history_register_controls')) {
    add_action('etc_widget_cms_company_history_register_controls', 'solatec_widget_cms_company_history_register_controls', 10, 1);
    function solatec_widget_cms_company_history_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_company_history/layout-images/1.png'
                    ]
                ]
            ]);
        $widget->end_controls_section();
        // section_timelines
        $widget->start_controls_section(
            'section_timelines',
            [
                'label'    => esc_html__('Timelines', 'solatec'),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $repeater = new Repeater();
            $repeater->add_control(
                'timeline_year',
                [
                    'label'       => esc_html__('Timeline Year', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true,
                    'default'     => ''
                ]
            );
            $repeater->add_control(
                'timeline_title',
                [
                    'label'       => esc_html__('Content Title', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true,
                    'default'     => ''
                ]
            );
            $repeater->add_control(
                'timeline_content',
                [
                    'label'   => __( 'Content', 'solatec' ),
                    'type'    => Controls_Manager::TEXTAREA,
                    'rows'    => '10',
                    'default' => '',
                ]
            );
            $widget->add_control(
                'timelines',
                [
                    'label'   => esc_html__( 'Add Timelines', 'solatec' ),
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $repeater->get_controls(),
                    'default' => [
                        [
                            'timeline_year'    => '2020',
                            'timeline_title'   => 'Royal College of Surgeons of Harvard',
                            'timeline_content' => 'He then traveled to Philadelphia, Pennsylvania to complete a Fellowship in Intervention Cardiology at Hahnemann Hospital in conjunction with Drexel University, where he received extensive training in coronary as well as peripheral interventions and salvage procedures. ',
                        ],
                        [
                            'timeline_year'    => '2015',
                            'timeline_title'   => 'Fellowship, Royal College of Physicians of Harvard',
                            'timeline_content' => 'After relocating to Louisiana he served as Director of the Cardiac Catheterization Lab at Regional Medical Center of Acadiana. He was honored by the Medical Association for Physician\'s Recognition Award from March of 2015 through May 2016.',
                        ],
                        [
                            'timeline_year'    => '2010',
                            'timeline_title'   => 'Residency, St. Harvard University Hospital',
                            'timeline_content' => 'Dr has also had professional accomplishments at the University of Southern California School of Medicine and Medical Center including Instructor of Medicine, Chief Administrative Fellow, Division of Cardiology University of Southern California.',
                        ],
                    ],
                    'title_field' => '{{{ timeline_year }}}',
                ]
            );
        $widget->end_controls_section();
        // Style
        $widget->start_controls_section(
            'style_section',
            [
                'label'    => esc_html__('Text Style', 'solatec' ),
                'tab'      => Controls_Manager::TAB_STYLE,
            ]
        );
            $widget->add_control(
                'year_color',
                [
                    'label'     => esc_html__('Years Color', 'solatec' ),
                    'type'      => Controls_Manager::COLOR,
                    'selectors' => [
                        '{{WRAPPER}} .cms-company-history .timeline-year' => 'color: {{VALUE}};',
                    ],
                ]
            );
            $widget->add_control(
                'content_color',
                [
                    'label'     => esc_html__('Content Color', 'solatec' ),
                    'type'      => Controls_Manager::COLOR,
                    'selectors' => [
                        '{{WRAPPER}} .cms-company-history .timeline-text' => 'color: {{VALUE}};',
                    ],
                ]
            );
        $widget->end_controls_section();
    }
}