<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_counter_register_controls')) {
    add_action('etc_widget_cms_counter_register_controls', 'solatec_widget_cms_counter_register_controls', 10, 1);
    function solatec_widget_cms_counter_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_counter/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__( 'Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_counter/layout-images/2.png'
                    ],
                    '3' => [
                        'label' => esc_html__( 'Layout 3', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_counter/layout-images/3.png'
                    ],
                    '4' => [
                        'label' => esc_html__( 'Layout 4', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_counter/layout-images/4.png'
                    ]
                ],
                'prefix_class' => 'cms-counter-layout',
            ]);
        $widget->end_controls_section();
        // Counter
        $widget->start_controls_section(
            'section_counter',
            [
                'label'    => esc_html__('Counter', 'solatec'),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'starting_number',
                [
                    'label'   => esc_html__('Starting Number', 'solatec'),
                    'type'    => Controls_Manager::NUMBER,
                    'default' => 1,
                ]
            );
            $widget->add_control(
                'ending_number',
                [
                    'label'   => esc_html__('Ending Number', 'solatec'),
                    'type'    => Controls_Manager::NUMBER,
                    'default' => 100,
                ]
            );
            $widget->add_control(
                'prefix',
                [
                    'label'       => esc_html__('Number Prefix', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '',
                    'placeholder' => '1',
                ]
            );
            $widget->add_control(
                'suffix',
                [
                    'label'       => esc_html__('Number Suffix', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '',
                    'placeholder' => '+',
                ]
            );
            $widget->add_control(
                'number_color',
                [
                    'label'       => esc_html__( 'Number Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'condition'   => [
                        'title!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'number_custom_color',
                [
                    'label'       => esc_html__( 'Custom Number Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'number_color'      => 'custom'
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} .cms-counter-number-wrapper' => 'color:{{VALUE}};',
                        '{{WRAPPER}} .cms-counter-number' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $widget->add_control(
                'duration',
                [
                    'label'   => esc_html__('Animation Duration', 'solatec'),
                    'type'    => Controls_Manager::NUMBER,
                    'default' => 2000,
                    'min'     => 100,
                    'step'    => 100,
                ]
            );
            $widget->add_control(
                'thousand_separator',
                [
                    'label'   => esc_html__('Thousand Separator', 'solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default' => 'yes',
                ]
            );
            $widget->add_control(
                'thousand_separator_char',
                [
                    'label'     => esc_html__('Separator', 'solatec'),
                    'type'      => Controls_Manager::SELECT,
                    'condition' => [
                        'thousand_separator' => 'yes',
                    ],
                    'options' => [
                        ''  => 'Default',
                        '.' => 'Dot',
                        ' ' => 'Space',
                    ],
                    'default' => '',
                ]
            );
        $widget->end_controls_section();
        // Icon
        $widget->start_controls_section(
            'icon_section',
            [
                'label'    => esc_html__( 'Icon', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'show_icon',
                [
                    'label'   => esc_html__('Show Icon', 'solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default' => 'no',
                ]
            );
            $widget->add_control(
                'icon_type',
                [
                    'label'   => esc_html__( 'Icon Type', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        'icon' => esc_html__('Icon', 'solatec'),
                        'image' => esc_html__('Image', 'solatec'),
                    ],
                    'default'   => 'icon',
                    'condition' => [
                        'show_icon' => 'yes'
                    ]
                ]
            );
            $widget->add_control(
                'counter_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'condition'        => [
                        'show_icon' => 'yes',
                        'icon_type' => 'icon'
                    ]
                ]
            );
            $widget->add_control(
                'icon_image',
                [
                    'label'     => esc_html__( 'Icon Image', 'solatec' ),
                    'type'      => Controls_Manager::MEDIA,
                    'default'   => [],
                    'condition' => [
                        'show_icon' => 'yes',
                        'icon_type' => 'image'
                    ]
                ]
            );
        $widget->end_controls_section();
        // Title
        $widget->start_controls_section(
            'title_section',
            [
                'label'    => esc_html__( 'Title', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'title',
                [
                    'label'       => esc_html__('Title', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'label_block' => true,
                    'default'     => esc_html__( 'Counter', 'solatec' ),
                    'placeholder' => esc_html__( 'Counter Title', 'solatec' ),
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'title_text_typo',
                    'control_type' => 'group',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-counter-title'
                ]
            );
            $widget->add_control(
                'title_color',
                [
                    'label'       => esc_html__( 'Title Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'condition'   => [
                        'title!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'title_custom_color',
                [
                    'label'       => esc_html__( 'Custom Title Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'title_color'      => 'custom'
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} .cms-counter-title' => 'color:{{VALUE}};'
                    ]
                ]
            );
        $widget->end_controls_section();
        // Description
        $widget->start_controls_section(
            'desc_section',
            [
                'label'    => esc_html__( 'Description', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['1','4']
                ]
            ]
        );
            $widget->add_control(
                'description_text',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'condition'   => [],
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'description_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} .cms-counter-desc' => 'color:{{VALUE}};'
                    ]
                ]
            );
        $widget->end_controls_section();
        // Link 
        $widget->start_controls_section(
            'link_section',
            [
                'label'    => esc_html__( 'Link', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['1','4']
                ]
            ]
        );
            $repeater_link = new Repeater();
            solatec_elementor_hyperlink_settings($repeater_link);
            $widget->add_control(
                'counter_link',
                [
                    'label'       => esc_html__('Add Link(s)', 'solatec'),
                    'type'        => Controls_Manager::REPEATER,
                    'fields'      => $repeater_link->get_controls(),
                    'title_field' => '{{{ link_text }}}',
                ]
            );
            $widget->add_control(
                'link_color',
                [
                    'label'       => esc_html__( 'Link Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'link_custom_color',
                [
                    'label'       => esc_html__( 'Custom Link Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'link_color'      => 'custom'
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} .cms-counter-link' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $widget->add_control(
                'link_color_hover',
                [
                    'label'       => esc_html__( 'Link Color Hover', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'link_custom_color_hover',
                [
                    'label'       => esc_html__( 'Custom Link Color Hover', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'link_color_hover'      => 'custom'
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} .cms-counter-link:hover' => 'color:{{VALUE}};'
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}