<?php
use Elementor\Controls_Manager;
if (!function_exists('solatec_widget_cms_cta_register_controls')) {
    add_action('etc_widget_cms_cta_register_controls', 'solatec_widget_cms_cta_register_controls', 10, 1);
    function solatec_widget_cms_cta_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_row_align($widget, [
                'condition' => [
                    'layout' => ['1']
                ]
            ]);
            solatec_elementor_text_align($widget, [
                'condition' => [
                    'layout' => ['1']
                ]
            ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_cta/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__( 'Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_cta/layout-images/2.png'
                    ],
                ],
                'prefix_class' => 'cms-cta-layout-',
            ]);
        $widget->end_controls_section();
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'    => esc_html__( 'Heading Settings', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'heading_icon',
                [
                    'label'            => esc_html__( 'Heading Icon', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ]
                ]
            );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading Text', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                ]                        
            );
        $widget->end_controls_section();
        // Button
        $widget->start_controls_section(
            'button_section',
            [
                'label'     => esc_html__( 'Button Settings', 'solatec' ),
                'tab'       => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['1']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'btn_text' => 'Click Me',
            ]);
        $widget->end_controls_section();
        // Button Brochure 1
        $widget->start_controls_section(
            'button_brochure1',
            [
                'label'    => esc_html__( 'Button Brochure 01', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['2']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'prefix'   => 'brochure1',
                'btn_text' => 'Company Report',
                'btn_size' => 'xl',
                'btn_align'       => 'justify',
                'icon_default'    => [
                    'value'     => 'fas fa-download',
                    'library'   => 'fa-solid'
                ],
                'icon_align'    => 'right'
            ]);
        $widget->end_controls_section();
        // Button Brochure 2
        $widget->start_controls_section(
            'button_brochure2',
            [
                'label'    => esc_html__( 'Button Brochure 02', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['2']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'prefix'          => 'brochure2',
                'btn_text'        => 'Company Brochure',
                'btn_size'        => 'xl',
                'btn_color'       => 'primary',
                'btn_hover_color' => 'accent',
                'btn_align'       => 'justify',  
                'icon_default'    => [
                    'value'     => 'fas fa-download',
                    'library'   => 'fa-solid'
                ],
                'icon_align'    => 'right'
            ]);
        $widget->end_controls_section();
    }
}