<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_fancy_box_register_controls')) {
    add_action('etc_widget_cms_fancy_box_register_controls', 'solatec_widget_cms_fancy_box_register_controls', 10, 1);
    function solatec_widget_cms_fancy_box_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control(
                'mode',
                [
                    'label'   => esc_html__( 'Layout Mode', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        'single'   => esc_html__('Default','solatec'),
                        'carousel' => esc_html__('Carousel','solatec'),
                    ],
                    'default' => 'single'
                ]
            );
            solatec_elementor_text_align($widget, ['default' => '']);
            $widget->add_control(
                'hover_effect',
                [
                    'label'   => esc_html__( 'Hover Styles', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        '' => esc_html__('Default','solatec'),
                    ],
                    'default' => ''
                ]
            );
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/1.png'
                    ],
                    '3' => [
                        'label' => esc_html__( 'Layout 3', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/3.png'
                    ],
                    '4' => [
                        'label' => esc_html__( 'Layout 4', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/4.png'
                    ],
                    '8' => [
                        'label' => esc_html__( 'Layout 8', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/8.png'
                    ],
                    '9' => [
                        'label' => esc_html__( 'Layout 9', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/3.png'
                    ],
                    '10' => [
                        'label' => esc_html__( 'Layout 10', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/10.png'
                    ],
                    '11' => [
                        'label' => esc_html__( 'Layout 11', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_fancy_box/layout-images/11.png'
                    ],
                ],
                'prefix_class' => 'cms-icon-box-layout-'
            ]);
        $widget->end_controls_section();
        // COlor
        $widget->start_controls_section(
            'color_section',
            [
                'label'    => esc_html__( 'Colors', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition'   => [
                    'layout' => ['2', '6']
                ]
            ]
        );
            $widget->add_control(
                'bg_color',
                [
                    'label'       => esc_html__( 'Background Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'text_color',
                [
                    'label'       => esc_html__( 'Text Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                ]
            );
        $widget->end_controls_section();
        // IMAGE 
        $widget->start_controls_section(
            'image_section',
            [
                'label'    => esc_html__( 'Image', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['6', '10', '11']
                ]
            ]
        );
            $widget->add_control(
                'background_img',
                [
                    'label'            => esc_html__( 'Image', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::MEDIA,
                    'default'          => [],
                ]
            );
            $widget->add_group_control(
                \Elementor\Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'background_size',
                    'default'      => 'full'
                ]
            );
            $widget->add_control(
                'image_order',
                [
                    'label'       => esc_html__( 'Image Order', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => [
                        'first' => esc_html__('First', 'solatec'),
                        'last'  => esc_html__('Last', 'solatec'),
                    ],
                    'default'     => 'last',
                    'condition' => [
                        'layout' => ['11']
                    ]
                ]
            );
        $widget->end_controls_section();
        // Icon
        $widget->start_controls_section(
            'icon_section',
            [
                'label'    => esc_html__( 'Icons', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout!' => ['10', '11']
                ]
            ]
        );
            $widget->add_control(
                'icon_type',
                [
                    'label'            => esc_html__( 'Icon Type', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::SELECT,
                    'options'          => [
                        'icon' => esc_html__('Icon','solatec'),
                        'img'  => esc_html__('Image','solatec'),
                    ],
                    'default'  => 'icon'
                ]
            );
            $widget->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'   => 'cmsi-hydro-power-2',
                        'library' => 'cmsi',
                    ],
                    'condition' => [
                        'mode'         => 'single',
                        'icon_type'    => 'icon'                            
                    ],
                ]
            );
            $widget->add_control(
                'selected_img',
                [
                    'label'     => esc_html__( 'Image', 'solatec' ),
                    'type'      => \Elementor\Controls_Manager::MEDIA,
                    'default'   => [],
                    'condition' => [
                        'mode'         => 'single',
                        'icon_type'    => 'img'                            
                    ],
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'thumbnail_size',
                    'default'      => 'full',
                    'condition'    => [
                        'icon_type'    => 'img'                            
                    ],
                ]
            );
            $widget->add_control(
                'icon_position',
                [
                    'label'   => esc_html__( 'Icon Position', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::CHOOSE,
                    'options' => [
                        'start' => [
                            'title' => esc_html__( 'Left', 'solatec' ),
                            'icon'  => 'eicon-h-align-left',
                        ],
                        'top' => [
                            'title' => esc_html__( 'Top', 'solatec' ),
                            'icon'  => 'eicon-v-align-top',
                        ],
                        'bottom' => [
                            'title' => esc_html__( 'Left', 'solatec' ),
                            'icon'  => 'eicon-v-align-bottom',
                        ],
                        'end' => [
                            'title' => esc_html__( 'Right', 'solatec' ),
                            'icon'  => 'eicon-h-align-right',
                        ]
                    ],
                    'prefix_class' => 'cms-icon-box-icon-position-',
                    'toggle'       => false,
                ]
            );
            $widget->add_control(
                'icon_position_start',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => \Elementor\Controls_Manager::DIMENSIONS,
                    'control_type'       => 'responsive',
                    'allowed_dimensions' => ['top', 'left'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'start',
                        'layout'           => ['2', '6']                         
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'top: {{TOP}}{{UNIT}};left: {{LEFT}}{{UNIT}}',
                    ],
                ]
            );
            $widget->add_control(
                'icon_position_right',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => \Elementor\Controls_Manager::DIMENSIONS,
                    'control_type'       => 'responsive',
                    'allowed_dimensions' => ['top', 'right'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'top',
                        'layout'           => ['2','6']                          
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'top: {{TOP}}{{UNIT}};right: {{RIGHT}}{{UNIT}}',
                    ],
                ]
            );
            $widget->add_control(
                'icon_position_bottom',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => \Elementor\Controls_Manager::DIMENSIONS,
                    'control_type'       => 'responsive',
                    'allowed_dimensions' => ['bottom', 'left'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'bottom',
                        'layout'           => ['2','6']                            
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'bottom: {{BOTTOM}}{{UNIT}};left: {{LEFT}}{{UNIT}}',
                    ],
                ]
            );
            $widget->add_control(
                'icon_position_end',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => \Elementor\Controls_Manager::DIMENSIONS,
                    'control_type'       => 'responsive',
                    'allowed_dimensions' => ['bottom', 'right'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'end',
                        'layout'           => ['2','6']                           
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'bottom: {{BOTTOM}}{{UNIT}};right: {{RIGHT}}{{UNIT}}',
                    ],
                ]
            );
            $widget->add_control(
                'icon_size',
                [
                    'label' => esc_html__( 'Icon Size', 'solatec' ),
                    'type'  => \Elementor\Controls_Manager::SLIDER,
                    'range' => [
                        'px' => [
                            'min' => 15,
                            'max' => 300,
                        ],
                    ],
                    'condition'    => [
                        'icon_type' => 'icon'                          
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .cms-icon:not(.cms-link-icon)' => 'font-size: {{SIZE}}{{UNIT}};',
                    ]
                ]
            );
            $widget->add_control(
                'icon_color',
                [
                    'label'       => esc_html__( 'Icon Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                    'condition'    => [
                        'icon_type'    => 'icon'                            
                    ],
                ]
            );
        $widget->end_controls_section();
        // Text
        $widget->start_controls_section(
            'text_section',
            [
                'label'    => esc_html__( 'Title', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'small_title',
                [
                    'label'       => esc_html__( 'Small Text', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
                    'label_block' => true,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'condition' => [
                        'mode'   => 'single',
                        'layout' => ['11']
                    ]
                ]
            );
            $widget->add_control(
                'title',
                [
                    'label'       => esc_html__( 'Title', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'condition' => [
                        'mode' => 'single'
                    ]
                ]
            );
            $widget->add_control(
                'title_color',
                [
                    'label'       => esc_html__( 'Title Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'description',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'before',
                    'condition' => [
                        'mode' => 'single'
                    ]
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                ]
            );
        $widget->end_controls_section();
        // Link
        $widget->start_controls_section(
            'link_section',
            [
                'label'    => esc_html__( 'Hyperlink', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'mode'   => 'single',
                    'layout' => ['1', '3','4','5','7','8','9']
                ]
            ]
        );
            $widget->add_control(
                'hyperlink',
                [
                    'label'   => esc_html__('Hyperlink As','solatec'),
                    'type'    => \Elementor\Controls_Manager::SELECT,
                    'options' => [
                        ''          => esc_html__('Default','solatec'),
                        'button'    => esc_html__('Button','solatec'),
                    ],
                    'default' => '',
                ]
            );
            solatec_elementor_hyperlink_settings($widget, [
                'condition' => [
                    'hyperlink' => '',                           
                ],
            ]);
            solatec_elementor_button_settings($widget, [
                'condition' => [
                    'hyperlink'    => 'button'                            
                ],
                'prefix'           => 'button',
                'btn_text'         => 'Read More',
            ]);
        $widget->end_controls_section();
        // Mode Carousel
        $widget->start_controls_section(
            'carousel_section',
            [
                'label'    => esc_html__( 'Fancy Items', 'solatec' ),
                'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'mode' => ['carousel']
                ]
            ]
        );
            $repeater = new Repeater();
            $repeater->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'   => 'cmsi-hydro-power-2',
                        'library' => 'cmsi',
                    ]
                ]
            );
            $repeater->add_control(
                'selected_img',
                [
                    'label'            => esc_html__( 'Image', 'solatec' ),
                    'type'             => \Elementor\Controls_Manager::MEDIA,
                    'default'          => [],
                    'condition' => [
                        'icon_type'    => 'img'                            
                    ]
                ]
            );
            $repeater->add_control(
                'title',
                [
                    'label'       => esc_html__( 'Title', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'before'
                ]
            );
            $repeater->add_control(
                'description',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'after'
                ]
            );
            solatec_elementor_hyperlink_settings($repeater);

            $widget->add_control(
                'fancy_list',
                [
                    'label'    => esc_html__('Add Item', 'solatec'),
                    'type'     => \Elementor\Controls_Manager::REPEATER,
                    'fields'   => $repeater->get_controls(), 
                    'title_field' => '{{{ title }}}',
                ]
            );

        $widget->end_controls_section();
    }
}