<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_heading_register_controls')) {
    add_action('etc_widget_cms_heading_register_controls', 'solatec_widget_cms_heading_register_controls', 10, 1);
    function solatec_widget_cms_heading_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_text_align($widget, ['default' => '']);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label'      => esc_html__( 'Layout 1', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout1.png',
                    ],
                    '4' => [
                        'label'      => esc_html__( 'Layout 4', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout4.png',
                    ],
                    '5' => [
                        'label'      => esc_html__( 'Layout 5', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout5.png',
                    ],
                    '6' => [
                        'label'      => esc_html__( 'Layout 6', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout6.png',
                    ],
                    '7' => [
                        'label'      => esc_html__( 'Layout 7', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout7.png',
                    ],
                    '8' => [
                        'label'      => esc_html__( 'Layout 8', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout8.png',
                    ],
                    '9' => [
                        'label'      => esc_html__( 'Layout 9', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout9.png',
                    ],
                    '10' => [
                        'label'      => esc_html__( 'Layout 10', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout4.png',
                    ],
                    '11' => [
                        'label'      => esc_html__( 'Layout 11', 'solatec' ),
                        'image'      => get_template_directory_uri() . '/elementor/templates/widgets/cms_heading/layout-images/layout11.png',
                    ],
                ],
                'prefix_class' => 'cms-heading-layout-',
                //'return_value'   => 'cms-heading-layout-%s'
            ]);
        $widget->end_controls_section();
        // Image
        $widget->start_controls_section(
            'image_section',
            [
                'label'    => esc_html__( 'Image', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['7']
                ]
            ]
        );
            $widget->add_control(
                'selected_img',
                [
                    'label'            => esc_html__( 'Image', 'solatec' ),
                    'type'             => Controls_Manager::MEDIA,
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'    => 'thumbnail_size',
                    'default' => 'large'
                ]
            );
            $widget->add_control(
                'thumbnail_pos',
                [
                    'type'    => Controls_Manager::SELECT,
                    'label'   => esc_html__('Image Position', 'solatec'),
                    'options' => [
                        'order-last' => esc_html__('Left','solatec'),
                        'order-first'  => esc_html__('Right','solatec'),
                    ],
                    'default' => 'order-first'
                ]
            );
        $widget->end_controls_section();
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'    => esc_html__( 'Heading', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $widget->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ]
                ]
            );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => esc_html__( 'This is the heading', 'solatec' ),
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'heading_tag',
                [
                    'label'       => esc_html__( 'HTML Tag', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options' => [
                        ''     => esc_html__('Default', 'solatec'), 
                        'h1'   => 'H1',
                        'h2'   => 'H2',
                        'h3'   => 'H3',
                        'h4'   => 'H4',
                        'h5'   => 'H5',
                        'h6'   => 'H6',
                        'div'  => 'div',
                        'span' => 'span',
                        'p'    => 'p',
                    ]
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'heading_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-mainheading'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'heading_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-mainheading'
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                ]
            );
            $widget->add_control(
                'heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'heading_extra_space',
                [
                    'label' => esc_html__( 'Extra bottom Space', 'solatec' ),
                    'type' => Controls_Manager::NUMBER,
                    'condition'   => [
                        'heading_text!' => '',
                        'layout'        => ['1']
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .cms-heading-extra-space' => 'height: {{SIZE}}px;',
                    ]
                ]
            );
            $widget->add_control(
                'heading_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'heading_text!' => ''
                    ],  
                ]
            );
        $widget->end_controls_section();
        // Sub Heading
        $widget->start_controls_section(
            'subheading_section',
            [
                'label'    => esc_html__( 'Sub Heading', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8','9','10','11']
                ]
            ]
        );
            $widget->add_control(
                'subheading_text',
                [
                    'label'       => esc_html__( 'Sub Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your sub title', 'solatec' ),
                    'label_block' => true,
                    'condition'   => [],
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'subheading_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-subheading'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'subheading_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-subheading'
                ]
            );
            $widget->add_control(
                'subheading_color',
                [
                    'label'       => esc_html__( 'Sub Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'sheading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Sub Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'subheading_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'subheading_extra_space',
                [
                    'label' => esc_html__( 'Extra bottom Space', 'solatec' ),
                    'type' => Controls_Manager::NUMBER,
                    'condition'   => [
                        'subheading_text!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'subheading_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION,
                    'condition' => [
                        'subheading_text!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        // Description
        $widget->start_controls_section(
            'desc_section',
            [
                'label'    => esc_html__( 'Description', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['1','4','5','6','7','8', '9','10','11']
                ]
            ]
        );
            $widget->add_control(
                'description_text',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '',
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'condition'   => [],
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'description_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading-desc'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'description_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading-desc'
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'description_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'description_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'description_text!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        // Description 2
        $widget->start_controls_section(
            'desc2_section',
            [
                'label'     => esc_html__( 'Description 2', 'solatec' ),
                'tab'       => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','8','10']
                ]
            ]
        );
            $widget->add_control(
                'description2_text',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '',
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'condition'   => [],
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'description2_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading-desc2'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'description2_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading-desc2'
                ]
            );
            $widget->add_control(
                'description2_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'description2_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'description2_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'description2_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION,
                    'condition' => [
                        'description_text2!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        // Features List
        $widget->start_controls_section(
            'features_section',
            [
                'label'    => esc_html__( 'Features List', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8','10']
                ]
            ]
        );
            $widget->add_control(
                'feature_icon',
                [
                    'label'            => esc_html__( 'Feture Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ]
                ]
            );
            $widget->add_control(
                'feature_icon_size',
                [
                    'label' => esc_html__( 'Icon Size', 'solatec' ),
                    'type'  => Controls_Manager::SLIDER,
                    'range' => [
                        'px' => [
                            'min' => 0,
                            'max' => 200,
                        ],
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .cms-heading-feature-item .cms-icon' => 'font-size: {{SIZE}}{{UNIT}};',
                    ]
                ]
            );
            $widget->add_control(
                'icon_bg_color',
                [
                    'label'       => esc_html__( 'Icon Background Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                    'label_block' => true,
                    'condition'   => [
                        'feature_icon[value]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'icon_color',
                [
                    'label'       => esc_html__( 'Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'condition'   => [
                        'feature_icon[value]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'icon_custom_color',
                [
                    'label'       => esc_html__( 'Custom Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'icon_color'      => 'custom'
                    ]
                ]
            );
                $features_list = new Repeater();
                $features_list->add_control(
                    'feature',
                    [
                        'label'       => esc_html__('Feature Title', 'solatec'),
                        'type'        => Controls_Manager::TEXTAREA,
                        'label_block' => true,
                    ]
                );
            $widget->add_control(
                'features_list',
                [
                    'label'    => esc_html__('Features List', 'solatec'),
                    'type'     => Controls_Manager::REPEATER,
                    'default'  => [],
                    'fields'   => $features_list->get_controls(),
                    'title_field' => '{{{ feature }}}',
                    'separator'   => 'before'
                ]
            );
            $widget->add_control(
                'features_color',
                [
                    'label'       => esc_html__( 'Text Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $widget->add_control(
                'features_custom_color',
                [
                    'label'       => esc_html__( 'Custom Text Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'features_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'features_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'features_list!' => ''
                    ],
                    'separator'   => 'before'
                ]
            );
        $widget->end_controls_section();
        // Button
        $widget->start_controls_section(
            'button_section1',
            [
                'label'    => esc_html__( 'Buttons 01', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8','9','10','11']
                ]
            ]
        );
            solatec_elementor_button_settings($widget);
            $widget->add_control(
                'button_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'btn_text!' => ''
                    ],
                ]
            );
        $widget->end_controls_section();
        // Button 2
        $widget->start_controls_section(
            'button_section2',
            [
                'label'    => esc_html__( 'Buttons 02', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'prefix'           => 'heading_btn2'
            ]);
            $widget->add_control(
                'button2_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'heading_btn2btn_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Button Video
        $widget->start_controls_section(
            'button_video',
            [
                'label'    => esc_html__( 'Buttons Video', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8','10']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'prefix'    => 'heading_btn_video',
            ]);
            $widget->add_group_control(
                Group_Control_Box_Shadow::get_type(),
                [
                    'name'         => 'button_video_box_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .heading_btn_video'
                ]
            );
            $widget->add_control(
                'button_video_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'heading_btn_videobtn_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Signature 
        $widget->start_controls_section(
            'signature_section',
            [
                'label'    => esc_html__( 'Singnature', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4','5','6','7','8','9','10','11']
                ]
            ]
        );
            $widget->add_control(
                'singnature_image',
                [
                    'label'       => esc_html__( 'Singnature Image', 'solatec' ),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'singnature_name',
                [
                    'label'       => esc_html__( 'Singnature Name', 'solatec' ),
                    'type'        => Controls_Manager::TEXT,
                    'placeholder' => esc_html__( 'Enter your name', 'solatec' ),
                    'label_block' => true,
                    'condition'   => []
                ]
            );
            $widget->add_control(
                'singnature_color',
                [
                    'label'       => esc_html__( 'Singnature Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'condition'   => [
                        'singnature_name!' => ''
                    ],
                ]
            );
            $widget->add_control(
                'singnature_custom_color',
                [
                    'label'       => esc_html__( 'Custom Singnature Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'singnature_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'singnature_job',
                [
                    'label'       => esc_html__( 'Job', 'solatec' ),
                    'type'        => Controls_Manager::TEXT,
                    'placeholder' => esc_html__( 'Enter your job', 'solatec' ),
                    'condition'   => [
                        'singnature_name!' => ''
                    ],
                ]
            );
            $widget->add_control(
                'singnature_job_color',
                [
                    'label'       => esc_html__( 'Job Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'condition'   => [
                        'singnature_name!' => '',
                        'singnature_job!' => ''
                    ],
                ]
            );
            $widget->add_control(
                'singnature_job_custom_color',
                [
                    'label'       => esc_html__( 'Job Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'singnature_job_color'      => 'custom'
                    ],
                ]
            );
            $widget->add_control(
                'singnature_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION,
                    'condition' => [
                        'singnature_name!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}