<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_howitwork_register_controls')) {
    add_action('etc_widget_cms_howitwork_register_controls', 'solatec_widget_cms_howitwork_register_controls', 10, 1);
    function solatec_widget_cms_howitwork_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_text_align($widget, ['default' => '']);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_howitwork/layout-images/1.png'
                    ]
                ]
            ]);
        $widget->end_controls_section();
        // Image
        $widget->start_controls_section(
            'image',
            [
                'label' => esc_html__('Images', 'solatec'),
                'tab'   => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'image_l',
                [
                    'label'       => esc_html__('Image Left', 'solatec'),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'image_r',
                [
                    'label'       => esc_html__('Image Right', 'solatec'),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true,
                ]
            );
        $widget->end_controls_section();
        // Content
        $widget->start_controls_section(
            'content_list',
            [
                'label'    => esc_html__('Steps', 'solatec'),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $steps = new Repeater();
            $steps->add_control(
                'title',
                [
                    'label'       => esc_html__('Title', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true,
                ]
            );
            $steps->add_control(
                'sub_title',
                [
                    'label'       => esc_html__('Sub Title', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true,
                ]
            );
            $steps->add_control(
                'description',
                [
                    'label'       => esc_html__('Description', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'label_block' => true
                ]
            );
            $steps->add_control(
                'image',
                [
                    'label'       => esc_html__('Image', 'solatec'),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'step',
                [
                    'label'    => esc_html__('Add Step', 'solatec'),
                    'type'     => Controls_Manager::REPEATER,
                    'fields'   => $steps->get_controls(),
                    'default' => [
                        [
                            'title'       => 'How It Works, Step One:',
                            'sub_title'   => 'We Design & Ship.',
                            'description' => 'We collaborate with you to design and deliver a system that meets your utility usage and needs, We also selecting equipment from 66+ manufacturers so you do not have to be worried or compromise with your money or with your effort.',
                        ],
                        [
                            'title'       => 'How It Works, Step Two:',
                            'sub_title'   => 'Contract Or Install',
                            'description' => 'Whether you want to install the system or hire local contractors, managing installation yourself ensures the fastest return on your solar investment.We deliver a system that meets your utility usage and needs, We also selecting equipment from.',
                        ],
                        [
                            'title'       => 'How It Works, Step Three:',
                            'sub_title'   => 'Power Your Home',
                            'description' => 'Even after your system is installed and operating, you can always count on Wholesale Solar to provide the support you need, just contact us at any time, and we will be there for you. Whether you want to install the system or hire local contractors.',
                        ],
                        
                    ],
                    'title_field' => '{{{ title }}}',
                ]
            );
        $widget->end_controls_section();
        // Rating
        $widget->start_controls_section(
            'rating',
            [
                'label' => esc_html__('Rating', 'solatec'),
                'tab'   => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'rating_rated',
                [
                    'label'       => esc_html__('Rating', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '99.9% Customer Satisfaction',
                    'label_block' => true,
                ]
            );
            $widget->add_control(
                'rating_text',
                [
                    'label'       => esc_html__('Rating Text', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => 'based on 750+ reviews and 6,154 Completed Projects.',  
                    'label_block' => true
                ]
            );
        $widget->end_controls_section();
    }
}