<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
// register element
if (!function_exists('solatec_widget_cms_icon_box_register_controls')) {
    add_action('etc_widget_cms_icon_box_register_controls', 'solatec_widget_cms_icon_box_register_controls', 10, 1);
    function solatec_widget_cms_icon_box_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_text_align($widget, ['default' => '']);
            $widget->add_control(
                'hover_effect',
                [
                    'label'   => esc_html__( 'Hover Styles', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        '' => esc_html__('Default','solatec'),
                    ],
                    'default' => ''
                ]
            );
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__( 'Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/2.png'
                    ],
                    '3' => [
                        'label' => esc_html__( 'Layout 3', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/3.png'
                    ],
                    '4' => [
                        'label' => esc_html__( 'Layout 4', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/4.png'
                    ],
                    '5' => [
                        'label' => esc_html__( 'Layout 5', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/5.png'
                    ],
                    '6' => [
                        'label' => esc_html__( 'Layout 6', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/6.png'
                    ],
                    '7' => [
                        'label' => esc_html__( 'Layout 7', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/7.png'
                    ],
                    '11' => [
                        'label' => esc_html__( 'Layout 11', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/11.png'
                    ],
                    '12' => [
                        'label' => esc_html__( 'Layout 12', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_icon_box/layout-images/12.png'
                    ]
                ],
                //'prefix_class' => 'cms-icon-box-layout-',
                //'return_value' => 'cms-icon-box-layout-'
            ]);
        $widget->end_controls_section();
        // COlor
        $widget->start_controls_section(
            'color_section',
            [
                'label'    => esc_html__( 'Colors', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition'   => [
                    'layout' => ['2', '6', '12']
                ]
            ]
        );
            $widget->add_control(
                'bg_color',
                [
                    'label'       => esc_html__( 'Background Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => ''
                ]
            );
            $widget->add_control(
                'text_color',
                [
                    'label'       => esc_html__( 'Text Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => ''
                ]
            );
        $widget->end_controls_section();
        // Image
        $widget->start_controls_section(
            'image_section',
            [
                'label'    => esc_html__( 'Image', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['6']
                ]
            ]
        );
            $widget->add_control(
                'background_img',
                [
                    'label' => esc_html__( 'Image', 'solatec' ),
                    'type'  => Controls_Manager::MEDIA
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'background_size',
                    'default'      => 'full'
                ]
            );
        $widget->end_controls_section();
        // Icon
        $widget->start_controls_section(
            'icon_section',
            [
                'label'    => esc_html__( 'Icons', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'icon_type',
                [
                    'label'   => esc_html__( 'Icon Type', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        'icon' => esc_html__('Icon','solatec'),
                        'img'  => esc_html__('Image','solatec'),
                    ],
                    'default'  => 'icon'
                ]
            );
            $widget->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__( 'Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'   => 'cmsi-hydro-power-2',
                        'library' => 'cmsi',
                    ],
                    'condition' => [
                        'icon_type'    => 'icon'                            
                    ],
                ]
            );
            $widget->add_control(
                'selected_img',
                [
                    'label'     => esc_html__( 'Image', 'solatec' ),
                    'type'      => Controls_Manager::MEDIA,
                    'condition' => [
                        'icon_type'    => 'img'                            
                    ]
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'thumbnail_size',
                    'default'      => 'full',
                    'condition'    => [
                        'icon_type'    => 'img'                            
                    ]
                ]
            );
            $widget->add_control(
                'icon_position',
                [
                    'label'   => esc_html__( 'Icon Position', 'solatec' ),
                    'type'    => Controls_Manager::CHOOSE,
                    'options' => [
                        'start' => [
                            'title' => esc_html__( 'Left', 'solatec' ),
                            'icon'  => 'eicon-h-align-left',
                        ],
                        'top' => [
                            'title' => esc_html__( 'Top', 'solatec' ),
                            'icon'  => 'eicon-v-align-top',
                        ],
                        'bottom' => [
                            'title' => esc_html__( 'Bottom', 'solatec' ),
                            'icon'  => 'eicon-v-align-bottom',
                        ],
                        'end' => [
                            'title' => esc_html__( 'Right', 'solatec' ),
                            'icon'  => 'eicon-h-align-right',
                        ]
                    ],
                    'prefix_class' => 'cms-icon-box-icon-position-',
                    'toggle'       => false,
                ]
            );
            $widget->add_responsive_control(
                'icon_position_start',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => Controls_Manager::DIMENSIONS,
                    'allowed_dimensions' => ['top', 'left'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'start',
                        'layout'           => ['2', '6','12']                         
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'top: {{TOP}}{{UNIT}};left: {{LEFT}}{{UNIT}}',
                    ]
                ]
            );
            $widget->add_responsive_control(
                'icon_position_right',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => Controls_Manager::DIMENSIONS,
                    'allowed_dimensions' => ['top', 'right'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'top',
                        'layout'           => ['2','6','12']                          
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'top: {{TOP}}{{UNIT}};right: {{RIGHT}}{{UNIT}}',
                    ]
                ]
            );
            $widget->add_responsive_control(
                'icon_position_bottom',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => Controls_Manager::DIMENSIONS,
                    'allowed_dimensions' => ['bottom', 'left'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'bottom',
                        'layout'           => ['2','6','12']                            
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'bottom: {{BOTTOM}}{{UNIT}};left: {{LEFT}}{{UNIT}}',
                    ]
                ]
            );
            $widget->add_responsive_control(
                'icon_position_end',
                [
                    'label'              => esc_html__('Custom Postion', 'solatec' ),
                    'type'               => Controls_Manager::DIMENSIONS,
                    'allowed_dimensions' => ['bottom', 'right'],
                    'size_units'         => [ 'px', '%' ],
                    'range' => [
                        '%' => [
                            'min' => 0,
                            'max' => 100,
                        ],
                    ],
                    'default' => [
                        'top' => '',
                        'left' => ''
                    ],
                    'condition'    => [
                        'icon_position'    => 'end',
                        'layout'           => ['2','6','12']                           
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .icon-position' => 'bottom: {{BOTTOM}}{{UNIT}};right: {{RIGHT}}{{UNIT}}',
                    ]
                ]
            );
            $widget->add_control(
                'icon_size',
                [
                    'label' => esc_html__( 'Icon Size', 'solatec' ),
                    'type'  => Controls_Manager::SLIDER,
                    'range' => [
                        'px' => [
                            'min' => 15,
                            'max' => 300,
                        ],
                    ],
                    'condition'    => [
                        'icon_type' => 'icon'                          
                    ],
                    'selectors' => [
                        '{{WRAPPER}} .cms-icon' => 'font-size: {{SIZE}}{{UNIT}};',
                    ]
                ]
            );
            $widget->add_control(
                'icon_color',
                [
                    'label'       => esc_html__( 'Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                    'condition'    => [
                        'icon_type'    => 'icon'                            
                    ]
                ]
            );
        $widget->end_controls_section();
        // Title
        $widget->start_controls_section(
            'text_section',
            [
                'label'    => esc_html__( 'Title', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'title',
                [
                    'label'       => esc_html__( 'Title', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true,
                    'dynamic'   => [
                        'active' => true,
                    ]
                ]
            );
            $widget->add_control(
                'title_color',
                [
                    'label'       => esc_html__( 'Title Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => ''
                ]
            );
            $widget->add_control(
                'description',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'dynamic'   => [
                        'active' => true,
                    ],
                    'separator' => 'before',
                    'condition' => [
                        'layout!' => ['12']
                    ]
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                    'condition' => [
                        'layout!' => ['12']
                    ]
                ]
            );
        $widget->end_controls_section();
        // Hyper link
        $widget->start_controls_section(
            'link_section',
            [
                'label'    => esc_html__( 'Hyperlink', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['3','4','5','7','11']
                ]
            ]
        );
            $widget->add_control(
                'hyperlink',
                [
                    'label'   => esc_html__('Hyperlink As','solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        ''          => esc_html__('Default','solatec'),
                        'button'    => esc_html__('Button','solatec'),
                    ],
                    'default' => ''
                ]
            );
            solatec_elementor_hyperlink_settings($widget, [
                'condition' => [
                    'hyperlink' => '',                           
                ],
            ]);
            solatec_elementor_button_settings($widget, [
                'condition' => [
                    'hyperlink'    => 'button'                            
                ],
                'prefix'           => 'button',
                'btn_text'         => 'Read More',
            ]);
        $widget->end_controls_section();
        // Hyper link 2
        $widget->start_controls_section(
            'link2_section',
            [
                'label'     => esc_html__( 'Hyperlink', 'solatec' ),
                'tab'       => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['2']
                ]
            ]
        );
            solatec_elementor_hyperlink_settings($widget, [
                'prefix' => 'layout2'                            
            ]);
        $widget->end_controls_section();
    }
}