<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_pricing_table_register_controls')) {
    add_action('etc_widget_cms_pricing_table_register_controls', 'solatec_widget_cms_pricing_table_register_controls', 10, 1);
    function solatec_widget_cms_pricing_table_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_pricing_table/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__( 'Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_pricing_table/layout-images/2.png'
                    ],
                    '3' => [
                        'label' => esc_html__( 'Layout 3', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_pricing_table/layout-images/3.png'
                    ],
                    '4' => [
                        'label' => esc_html__( 'Layout 4', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_pricing_table/layout-images/4.png'
                    ]
                ],
                'prefix_class' => 'cms-pricing-layout-'
            ]);
        $widget->end_controls_section();
        // Icon
        $widget->start_controls_section(
            'icon_section',
            [
                'tab'       => Controls_Manager::TAB_CONTENT,
                'label'     => esc_html__('Icon Settings', 'solatec')
            ]
        );
            $widget->add_control(
                'selected_icon',
                [
                    'label'            => esc_html__('Select an Icon', 'solatec'),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => []
                ]
            );
        $widget->end_controls_section();
        // Badge
        $widget->start_controls_section(
            'badge_section',
            [
                'label'     => esc_html__('Badge Settings', 'solatec'),
                'tab'       => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'show_badge',
                [
                    'label'       => esc_html__('Show Badge', 'solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'      => [
                        'yes' => esc_html__('Yes', 'solatec'),
                        'no'  => esc_html__('No','solatec')
                    ],
                    'default'     => 'no',
                ]
            );
            $widget->add_control(
                'badge_text',
                [
                    'label'       => esc_html__('Text', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '',
                    'condition'   => [
                        'show_badge' => 'true'
                    ]
                ]
            );
        $widget->end_controls_section();
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'     => esc_html__('Heading Settings', 'solatec'),
                'tab'       => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => 'Starter Plan',
                    'placeholder' => esc_html__( 'Enter your heading', 'solatec' ),
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'heading_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'heading_text!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'subheading_text',
                [
                    'label'       => esc_html__( 'Sub Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => 'The perfect plan for small business',  
                    'placeholder' => esc_html__( 'Enter your sub heading', 'solatec' ),
                    'label_block' => true
                ]
            );
        $widget->end_controls_section();
        // Description
        $widget->start_controls_section(
            'desc_section',
            [
                'label'    => esc_html__( 'Description', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'description_text',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'description_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'description_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'description_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Price
        $widget->start_controls_section(
            'price_section',
            [
                'label'     => esc_html__('Price Settings', 'solatec'),
                'tab'       => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'slashed_price_value',
                [
                    'label'       => esc_html__('Slashed Price', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'price_currency',
                [
                    'label'       => esc_html__('Currency', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '$',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'price_value',
                [
                    'label'       => esc_html__('Price', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '29',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'price_separator',
                [
                    'label'       => esc_html__('Divider', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'price_duration',
                [
                    'label'       => esc_html__('Duration', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'default'     => 'Month',
                    'label_block' => true
                ]
            );
        $widget->end_controls_section();
        // Features
        $widget->start_controls_section(
            'features_section',
            [
                'label'    => esc_html__( 'Features List', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'feature_icon',
                [
                    'label'            => esc_html__( 'Feture Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ]
                ]
            );
            $widget->add_control(
                'icon_bg_color',
                [
                    'label'       => esc_html__( 'Icon Background Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => '',
                    'label_block' => true,
                    'condition'   => [
                        'feature_icon[value]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'icon_color',
                [
                    'label'       => esc_html__( 'Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'condition'   => [
                        'feature_icon[value]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'icon_custom_color',
                [
                    'label'       => esc_html__( 'Custom Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'icon_color'      => 'custom'
                    ]
                ]
            );
            $feature_lists = new Repeater();
            $feature_lists->add_control(
                'feature_icon',
                [
                    'label'            => esc_html__('Icon', 'solatec'),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon'
                ]
            );
            $feature_lists->add_control(
                'feature_text',
                [
                    'label'       => esc_html__('Text', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $feature_lists->add_control(
                'feature_price',
                [
                    'label'       => esc_html__('Price', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'feature_lists',
                [
                    'label'   => '',
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $feature_lists->get_controls(),
                    'default' => [
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #1', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #2', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #3', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #4', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #5', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #6', 'solatec' ),
                        ],
                    ],
                    'title_field' => '<i class="{{{ feature_icon }}}" aria-hidden="true"></i> {{{ feature_text }}}',
                    'separator'   => 'before',
                    'empty'       => true
                ]
            );
            $widget->add_control(
                'features_color',
                [
                    'label'       => esc_html__( 'Text Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'separator'   => 'before',
                    'condition'   => [
                        'feature_lists!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'features_custom_color',
                [
                    'label'       => esc_html__( 'Custom Text Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'features_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'features_price_bg_color',
                [
                    'label'       => esc_html__( 'Price Background Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true,
                    'separator'   => 'before',
                    'condition'   => [
                        'feature_lists!' => '',
                        'layout'    => ['2']
                    ]
                ]
            );
            $widget->add_control(
                'features_price_bg_custom_color',
                [
                    'label'       => esc_html__( 'Custom Price Background Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'features_price_bg_color'      => 'custom',
                        'layout'    => ['2']
                    ]
                ]
            );
            $widget->add_control(
                'features_height',
                [
                    'label' => esc_html__( 'Min Height?', 'solatec' ),
                    'type'  => Controls_Manager::NUMBER,
                    'condition'   => [
                        'feature_lists!' => '',
                        'layout'         => ['1']
                    ]
                ]
            );
            $widget->add_control(
                'features_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'  => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'feature_lists!' => ''
                    ],
                    'separator'   => 'before'
                ]
            );
        $widget->end_controls_section();
        // Feature 2
        $widget->start_controls_section(
            'features2_section',
            [
                'label'    => esc_html__( 'Features List 2', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['4']
                ]
            ]
        );
            $feature_lists2 = new Repeater();
            $feature_lists2->add_control(
                'feature_icon',
                [
                    'label'            => esc_html__('Icon', 'solatec'),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon'
                ]
            );
            $feature_lists2->add_control(
                'feature_text',
                [
                    'label'       => esc_html__('Text', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $feature_lists2->add_control(
                'feature_price',
                [
                    'label'       => esc_html__('Price', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'feature2_lists',
                [
                    'label'   => '',
                    'type'    => Controls_Manager::REPEATER,
                    'fields'  => $feature_lists2->get_controls(),
                    'default' => [
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #7', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #8', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #9', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #10', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #11', 'solatec' ),
                        ],
                        [
                            'feature_icon' => '',
                            'feature_text' => esc_html__( 'Your feature text #12', 'solatec' ),
                        ],
                    ],
                    'title_field' => '<i class="{{{ feature_icon }}}" aria-hidden="true"></i> {{{ feature_text }}}',
                    'separator'   => 'before',
                    'empty'       => true
                ]
            );
        $widget->end_controls_section();
        // Button
        $widget->start_controls_section(
            'button_section',
            [
                'label'     => esc_html__('Button Settings', 'solatec'),
                'tab'       => Controls_Manager::TAB_CONTENT
            ]
        );
            solatec_elementor_button_settings($widget, [
                'condition' => [],
                'btn_text'  => 'Read More'
            ]);
        $widget->end_controls_section();
    }
}