<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_progressbar_register_controls')) {
    add_action('etc_widget_cms_progressbar_register_controls', 'solatec_widget_cms_progressbar_register_controls', 10, 1);
    function solatec_widget_cms_progressbar_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_progressbar/layout-images/1.png'
                    ]
                ]
            ]);
        $widget->end_controls_section();
        // Source 
        $widget->start_controls_section(
            'source_section',
            [
                'label' => esc_html__( 'Source Settings', 'solatec' ),
                'tab' => \Elementor\Controls_Manager::TAB_CONTENT
            ]
        );
            $progress = new Repeater();
            $progress->add_control(
                'title',
                [
                    'label'       => esc_html__( 'Title', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::TEXT,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'default'     => esc_html__( 'My Skill', 'solatec' ),
                    'label_block' => true
                ]
            );
            $progress->add_control(
                'percent',
                [
                    'label'   => esc_html__( 'Percentage', 'solatec' ),
                    'type'    => \Elementor\Controls_Manager::SLIDER,
                    'default' => [
                        'size' => 50,
                        'unit' => '%',
                    ],
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'progressbar_list',
                [
                    'label'       => esc_html__( 'Progress Bar Lists', 'solatec' ),
                    'type'        => \Elementor\Controls_Manager::REPEATER,
                    'fields'      => $progress->get_controls(),
                    'title_field' => '{{{ title }}}',
                    'default' => [
                        [
                            'title'   => 'My Skill #1',
                            'percent' => [
                                'size' => '75',
                                'unit' => '%'
                            ]
                        ],
                        [
                            'title'   => 'My Skill #2',
                            'percent' => [
                                'size' => '85',
                                'unit' => '%'
                            ]
                        ],
                        [
                            'title'   => 'My Skill #3',
                            'percent' => [
                                'size' => '95',
                                'unit' => '%'
                            ]
                        ]
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}