<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Text_Shadow;
if (!function_exists('solatec_widget_cms_quickcontact_register_controls')) {
    add_action('etc_widget_cms_quickcontact_register_controls', 'solatec_widget_cms_quickcontact_register_controls', 10, 1);
    function solatec_widget_cms_quickcontact_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
        	solatec_elementor_row_align($widget, [
				'condition' => [
					'layout' => ['1']
				]
			]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__( 'Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_quickcontact/layout-image/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__( 'Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_quickcontact/layout-image/2.png'
                    ],
                    '9' => [
                        'label' => esc_html__( 'Layout 9', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_quickcontact/layout-image/9.png'
                    ],
                    '10' => [
                        'label' => esc_html__( 'Layout 10', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_quickcontact/layout-image/10.png'
                    ],
                ],
                'prefix_class' => 'cms-quick-contact-layout-'	
            ]);
        $widget->end_controls_section();
        // Contact Settings
        $widget->start_controls_section(
        	'contact_section',
			[
				'label'     => esc_html__( 'Contact Settings', 'solatec' ),
				'tab'       => Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['1','10']
				]
			]
        );
        	$contact_list = new Repeater();
        	$contact_list->add_control(
        		'contact_list_title_1',
				[
					'label'       => esc_html__( 'Title 1', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
					'default'     => esc_html__( 'Enter your text', 'solatec' ),
					'label_block' => true
				]
        	);
        	$contact_list->add_control(
        		'contact_list_text_1',
				[
					'label'       => esc_html__( 'Text 1', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
					'default'     => esc_html__( 'Enter your text', 'solatec' ),
					'label_block' => true
				]
        	);
        	$contact_list->add_control(
        		'contact_list_title_2',
				[
					'label'       => esc_html__( 'Title 2', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
					'default'     => esc_html__( 'Enter your text', 'solatec' ),
					'label_block' => true
				]
        	);
        	$contact_list->add_control(
        		'contact_list_text_2',
				[
					'label'       => esc_html__( 'Text 2', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
					'default'     => esc_html__( 'Enter your text', 'solatec' ),
					'label_block' => true
				]
        	);
        	$contact_list->add_control(
        		'contact_list_text_link',
				[
					'label'       => esc_html__( 'Link', 'solatec' ),
					'type'        => Controls_Manager::URL,
					'placeholder' => esc_html__('https://your-link.com', 'solatec' ),
					'label_block' => true
				]
        	);
        	$contact_list->add_control(
        		'contact_list_icon',
				[
					'label'            => esc_html__( 'Icon', 'solatec' ),
					'type'             => Controls_Manager::ICONS,
					'fa4compatibility' => 'icon',
					'default'          => []
				]
        	);
        	solatec_elementor_theme_colors($contact_list, [
				'name'            => 'contact_list_text_color',
				'label'           => esc_html__('Text Color','solatec'),
				'custom_name'     => 'contact_list_text_color_custom',
				'custom_label'    => esc_html__('Custom Text Color','solatec'),
				'custom_selector' => '.cms-qc-list'
			]);
			solatec_elementor_theme_colors($contact_list, [
				'name'            => 'contact_list_text_icon_color',
				'label'           => esc_html__('Icon Color','solatec'),
				'custom_name'     => 'contact_list_text_icon_color_custom',
				'custom_label'    => esc_html__('Custom Icon Color','solatec'),
				'custom_selector' => '.cms-qc-wrap .cms-qc-list .cms-icon'
			]);
        	$widget->add_control(
        		'contact_list',
				[
					'label'    => esc_html__( 'Contact Lists', 'solatec' ),
					'type'     => Controls_Manager::REPEATER,
					'fields'   => $contact_list->get_controls(),	
					'default' => [
                        [
							'contact_list_title_1' => 'Emergency Line:',
							'contact_list_text_1'  => '(002) 01061245741',
							'contact_list_title_2' => '',
							'contact_list_text_2'  => '',
							'contact_list_icon'    => [
								'value'   => 'fas fa-phone-alt',
								'library' => 'fa-solid',
							]
                        ],
                        [
                            'contact_list_title_1' => 'Location:',
                            'contact_list_text_1' => 'Brooklyn, New York',
                            'contact_list_title_2' => '',
                            'contact_list_text_2' => '',
                            'contact_list_icon'  => [
								'value'   => 'fas fa-map-marker-alt',
								'library' => 'fa-solid',
							]
                        ],
                        [
                            'contact_list_title_1' => 'Mon - Fri:',
                            'contact_list_text_1' => '8.00am - 7.00pm',
                            'contact_list_title_2' => '',
                            'contact_list_text_2' => '',
                            'contact_list_icon'  => [
								'value'   => 'fas fa-clock',
								'library' => 'fa-solid',
							]
                        ]
                    ],
                    'title_field' => '{{{ elementor.helpers.renderIcon( this, contact_list_icon, {}, "i", "panel" ) || \'<i class="{{ icon }}" aria-hidden="true"></i>\' }}} {{{ contact_list_title_1 }}} {{{ contact_list_text_1 }}}'
				]
        	);
        	solatec_elementor_theme_colors($widget, [
				'name'            => 'text_color',
				'label'           => esc_html__('Text Color','solatec'),
				'custom_name'     => 'text_color_custom',
				'custom_label'    => esc_html__('Custom Text Color','solatec'),
				'custom_selector' => '.cms-qc-inner > .row'
			]);
			$widget->add_control(
				'contact_list_icon_size',
	            [
	            	'label' => esc_html__( 'Icon Size', 'solatec' ),
	                'type'  => Controls_Manager::SLIDER,
	                'range' => [
	                    'px' => [
	                        'min' => 10,
	                        'max' => 200,
	                    ],
	                ],
	                'selectors' => [
	                    '{{WRAPPER}} .cms-qc-list .cms-icon' => 'font-size: {{SIZE}}{{UNIT}};',
	                ]
	            ]
			);
			solatec_elementor_theme_colors($widget, [
				'name'            => 'contact_list_icon_color',
				'label'           => esc_html__('Icon Color','solatec'),
				'custom_name'     => 'contact_list_icon_color_custom',
				'custom_label'    => esc_html__('Custom Icon Color','solatec'),
				'custom_selector' => '.cms-qc-list .cms-icon'
			]);
        $widget->end_controls_section();
        
        // Background
        $widget->start_controls_section(
        	'background_section',
			[
				'label'     => esc_html__( 'Background Settings', 'solatec' ),
				'tab'       => Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['2']
				]
			]
        );
        	$widget->add_control(
        		'background_image',
				[
					'label'       => esc_html__( 'Background Image', 'solatec' ),
					'type'        => Controls_Manager::MEDIA,	
					'label_block' => true
				]
        	);
        	$widget->add_control(
        		'background_overlay',
				[
					'label'       => esc_html__( 'Background Overlay', 'solatec' ),
					'type'        => Controls_Manager::SELECT,
					'options'	  => [
						''     => esc_html__('Default', 'solatec'),
						'none' => esc_html__('None', 'solatec'),
						'1'    => esc_html__('Gradient 1', 'solatec'),
						'2'    => esc_html__('Gradient 2', 'solatec'),
						'3'    => esc_html__('Gradient 3', 'solatec'),
						'4'    => esc_html__('Gradient 4', 'solatec'),
					],
					'default' => ''
				]
        	);
        	$widget->add_control(
        		'gradient_bg_color',
                [
                	'label'       => esc_html__( 'Background Color', 'solatec' ),
	                'type'        => Controls_Manager::COLOR,
	                'options'     => '',  
	                'default'     => ''
                ]
        	);
        $widget->end_controls_section();
        
        // Heading
        $widget->start_controls_section(
        	'heading_section',
			[
				'label'     => esc_html__( 'Heading Settings', 'solatec' ),
				'tab'       => Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['2','9']
				]
			]
        );
        	$widget->add_control(
        		'heading_text',
				[
					'label'       => esc_html__( 'Heading', 'solatec' ),
					'type'        => Controls_Manager::TEXTAREA,
					'default'     => '',
					'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
					'label_block' => true
				]
        	);
        	$widget->add_group_control(
        		Group_Control_Typography::get_type(),
                [
                	'name'         => 'heading_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading',
                    'condition'    => [
                        'heading_text!' => ''
                    ]
                ]
        	);
        	$widget->add_group_control(
        		Group_Control_Text_Shadow::get_type(),
                [
                	'name'         => 'heading_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-heading',
                    'condition'    => [
                        'heading_text!' => ''
                    ]
                ]
        	);
        	$widget->add_control(
        		'heading_extra_space',
				[
					'label'     => esc_html__( 'Extra bottom Space', 'solatec' ),
					'type'      => Controls_Manager::NUMBER,
					'condition' => [
                        'heading_text!' => '',
                    ]
				]
        	);
        	$widget->add_control(
        		'heading_color',
                [
                	'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'condition'   => [
                        'heading_text!' => ''
                    ]
                ]
        	);
        	$widget->add_control(
        		'heading_custom_color',
                [
                	'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ]
                ]
        	);
        	$widget->add_control(
        		'heading_animation',
				[
					'label'     => esc_html__( 'Motion Effect', 'solatec' ),
					'type'      => Controls_Manager::ANIMATION,
					'condition' => [
	                    'heading_text!' => ''
	                ]
				]
        	);
        $widget->end_controls_section();
        // Description
        $widget->start_controls_section(
        	'desc_section',
			[
				'label'     => esc_html__( 'Description Settings', 'solatec' ),
				'tab'       => Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['2','9']
				]
			]
        );
        	$widget->add_control(
        		'description_text',
				[
					'label'       => esc_html__( 'Description', 'solatec' ),
					'type'        => Controls_Manager::TEXTAREA,
					'default'     => '',
					'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
					'show_label'  => false
				]
        	);
        	$widget->add_control(
        		'description_color',
                [
                	'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => ''
                ]
        	);
        	$widget->add_control(
        		'description_custom_color',
	            [
	            	'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
	                'type'        => Controls_Manager::COLOR,
	                'condition'   => [
	                    'description_color'      => 'custom'
	                ]
	            ]
        	);
        	$widget->add_control(
        		'description_animation',
                [
                	'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'description_text!' => ''
                    ]
                ]
        	);
        $widget->end_controls_section();
        
        // Phone
        $widget->start_controls_section(
        	'phone_section',
			[
				'label'    => esc_html__( 'Phone Settings', 'solatec' ),
				'tab'      => Controls_Manager::TAB_CONTENT,
				'condition'   => [
					'layout' => ['2','9']
				]
			]
        );
        	$widget->add_control(
        		'phone_icon',
				[
					'label'            => esc_html__( 'Phone Icon', 'solatec' ),
					'type'             => Controls_Manager::ICONS,
					'fa4compatibility' => 'icon',
					'default'          => [],
					'placeholder'      => esc_html__( 'Choose phone icon', 'solatec' )
				]
        	);
        	$widget->add_control(
        		'phone_number',
				[
					'label'       => esc_html__( 'Phone Number', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'default'     => '',
					'placeholder' => esc_html__( 'Enter your phone number', 'solatec' ),
					'label_block' => true
				]
        	);
        	$widget->add_control(
        		'phone_bg',
				[
					'label'       => esc_html__( 'Icon Phone Background', 'solatec' ),
					'type'        => Controls_Manager::COLOR,
					'default'     => '',
					'selectors'	  => [
						'{{WRAPPER}} .cms-phone-icon' => 'background-color: {{VALUE}};',
					]
				]
        	);
        	$widget->add_control(
        		'phone_text_color',
                [
                	'label'       => esc_html__( 'Text Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => 'white',
                    'label_block' => true
                ]
        	);
        	$widget->add_control(
        		'phone_text_color_hover',
                [
                	'label'       => esc_html__( 'Text Hover Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),  
                    'default'     => 'white',
                    'label_block' => true
                ]
        	);
        $widget->end_controls_section();
        // Button2
        $widget->start_controls_section(
        	'button_section2',
			[
				'label'    => esc_html__( 'Button Settings', 'solatec' ),
				'tab'      => Controls_Manager::TAB_CONTENT,
				'condition'   => [
					'layout' => ['2']
				]
			]
        );
        	solatec_elementor_button_settings($widget, [
				'prefix' 		   => 'btn2',
				'btn_text'         => 'Schedule An Appointment',
				'btn_type_default' => 'btn btn-outline',
				'btn_color'		   => 'white',
				'btn_hover_color'  => 'white',
				'btn_size'		   => 'lg'		 
			]);
        $widget->end_controls_section();
        // Map
        $widget->start_controls_section(
        	'map_section',
			[
				'label'     => esc_html__( 'Map Settings', 'solatec' ),
				'tab'       => Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['9']
				]
			]
        );
        	$widget->add_control(
        		'map_address',
				[
					'label'       => esc_html__( 'Map Address', 'solatec' ),
					'type'        => Controls_Manager::TEXTAREA,
					'default'	  => '',		
					'label_block' => true,
				]
        	);
        	$widget->add_control(
        		'map_link',
				[
					'label'       => esc_html__( 'Map Link', 'solatec' ),
					'type'        => Controls_Manager::TEXT,
					'default'	  => 'https://maps.google.com',		
					'label_block' => true,
					'condition'   => [
						'map_address!' => ''
					]
				]
        	);
        	$widget->add_control(
        		'map_link_color',
                [
                	'label'       => esc_html__( 'Map Link Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),
                    'label_block' => true,
                    'condition' => [
                    	'map_link!' => ''
                    ]
                ]
        	);
        	$widget->add_control(
        		'map_link_color_hover',
                [
                	'label'       => esc_html__( 'Map Link Hover Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(['custom' => false]),
                    'label_block' => true,
                    'condition' => [
                    	'map_link!' => ''
                    ]
                ]
        	);
        $widget->end_controls_section();
        // Button on layout 10
        $widget->start_controls_section(
        	'button_section10',
			[
				'label'    => esc_html__( 'Button Settings', 'solatec' ),
				'tab'      => \Elementor\Controls_Manager::TAB_CONTENT,
				'condition' => [
					'layout' => ['10']
				]
			]
        );
        	solatec_elementor_button_settings($widget, [
				'prefix'           => 'layout10',
				'btn_text'         => 'Request A Quote',
				'btn_type_default' => 'btn btn-fill'
            ]);
        $widget->end_controls_section();  
    }
}