<?php
use Elementor\Controls_Manager;
if (!function_exists('solatec_widget_cms_rating_register_controls')) {
    add_action('etc_widget_cms_rating_register_controls', 'solatec_widget_cms_rating_register_controls', 10, 1);
    function solatec_widget_cms_rating_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_rating/layout-images/1.png'
                    ],
                ],
                'prefix_class' => 'cms-rating-layout-'
            ]);
        $widget->end_controls_section();
        // Rating
        $widget->start_controls_section(
            'rating',
            [
                'label' => esc_html__('Rating', 'solatec'),
                'tab'   => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'rating_rated',
                [
                    'label'       => esc_html__('Rating', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '99.9% Customer Satisfaction',
                    'label_block' => true
                ]  
            );
            $widget->add_control(
                'rating_text',
                [
                    'label'       => esc_html__('Rating Text', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => 'based on 750+ reviews and 6,154 Completed Projects.',  
                    'label_block' => true
                ]
            );
        $widget->end_controls_section();
    }
}