<?php
use Elementor\Controls_Manager;
if (!function_exists('solatec_widget_cms_search_register_controls')) {
    add_action('etc_widget_cms_search_register_controls', 'solatec_widget_cms_search_register_controls', 10, 1);
    function solatec_widget_cms_search_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
	                '1' => [
	                    'label' => esc_html__( 'Layout 1', 'solatec' ),
	                    'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_search/layout-images/1.png'
	                ]
	            ],
	            'prefix_class' => 'cms-e-search-layout-'
            ]);
        $widget->end_controls_section();
        //Content
        $widget->start_controls_section(
        	'settings_section',
			[
				'label'    => esc_html__( 'Settings', 'solatec' ),
				'tab'      => Controls_Manager::TAB_CONTENT
			]
        );
        	$widget->add_control(
        		'search_text',
                [
                	'label'       => esc_html__( 'Placeholder Text', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true
                ]
        	);
        	$widget->add_control(
        		'selected_icon',
				[
					'label'            => esc_html__( 'Main Icon', 'solatec' ),
					'type'             => Controls_Manager::ICONS,
					'fa4compatibility' => 'icon',
					'default'          => [
						'value'   => 'cmsi-search',
						'library' => 'cmsi'
					]
				]
        	);
        	solatec_elementor_theme_colors($widget, [
				'name'            => 'search_icon_color',
				'label'           => esc_html__('Search Color','solatec'),
				'custom_name'     => 'search_icon_custom',
				'custom_label'    => esc_html__('Custom Search Color','solatec'),
				'custom_selector' => '.cms-e-search-button .cms-icon'
			]);
        $widget->end_controls_section();
    }
}