<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Group_Control_Image_Size;
use Elementor\Utils;
use Elementor\Repeater;

if (!function_exists('solatec_widget_cms_slider_register_controls')) {
    add_action('etc_widget_cms_slider_register_controls', 'solatec_widget_cms_slider_register_controls', 10, 1);
    function solatec_widget_cms_slider_register_controls($widget)
    {
        // Layout Tab Start

        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT,
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec'),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_slider/layout-images/1.jpg'
                    ]
                ]
            ]);
        $widget->end_controls_section();
        // Small Heading
        $widget->start_controls_section('small_heading_section', [
            'label' => esc_html__('Small Heading', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'     => 'small_heading_typo',
                    'selector' => '{{WRAPPER}} .small-heading'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'     => 'small_heading_shadow',
                    'selector' => '{{WRAPPER}} .small-heading'
                ]
            );
            $widget->add_control(
                'small_heading_responsive_description',
                [ 
                    'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                    'type'            => Controls_Manager::RAW_HTML,
                    'content_classes' => 'elementor-descriptor',
                ]
            );
            solatec_add_hidden_device_controls($widget, ['prefix' => 'small_heading']);
        $widget->end_controls_section();
        // Large Heading
        $widget->start_controls_section('large_heading_section', [
            'label' => esc_html__('Large Heading', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'     => 'large_heading_typo',
                    'selector' => '{{WRAPPER}} .large-heading'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'     => 'large_heading_shadow',
                    'selector' => '{{WRAPPER}} .large-heading'
                ]
            );
            $widget->add_control(
                'large_heading_responsive_description',
                [ 
                    'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                    'type'            => Controls_Manager::RAW_HTML,
                    'content_classes' => 'elementor-descriptor',
                ]
            );
            solatec_add_hidden_device_controls($widget, ['prefix' => 'large_heading']);
        $widget->end_controls_section();
        // Description
        $widget->start_controls_section('description_section', [
            'label' => esc_html__('Description', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'     => 'description_typo',
                    'selector' => '{{WRAPPER}} .description'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'     => 'description_shadow',
                    'selector' => '{{WRAPPER}} .description'
                ]
            );
            $widget->add_control(
                'description_responsive_description',
                [ 
                    'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                    'type'            => Controls_Manager::RAW_HTML,
                    'content_classes' => 'elementor-descriptor',
                ]
            );
            solatec_add_hidden_device_controls($widget, ['prefix' => 'description_heading']);
        $widget->end_controls_section();
        // Description #2
        $widget->start_controls_section('description2_section', [
            'label' => esc_html__('Description #2', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'     => 'description2_typo',
                    'selector' => '{{WRAPPER}} .description2'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'     => 'description2_shadow',
                    'selector' => '{{WRAPPER}} .description2'
                ]
            );
            $widget->add_control(
                'description2_responsive_description',
                [ 
                    'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                    'type'            => Controls_Manager::RAW_HTML,
                    'content_classes' => 'elementor-descriptor',
                ]
            );
            solatec_add_hidden_device_controls($widget, ['prefix' => 'description2_heading']);
        $widget->end_controls_section();
        // Icon
        $widget->start_controls_section('icons_section', [
            'label' => esc_html__('Icons', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'     => 'icons_typo',
                    'selector' => '{{WRAPPER}} ..cms-slide-icon'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'     => 'icons_shadow',
                    'selector' => '{{WRAPPER}} ..cms-slide-icon'
                ]
            );
            $widget->add_control(
                'icons_responsive_description',
                [ 
                    'raw'             => __( 'Responsive visibility will take effect only on preview or live page, and not while editing in Elementor.', 'solatec' ),
                    'type'            => Controls_Manager::RAW_HTML,
                    'content_classes' => 'elementor-descriptor',
                ]
            );
            solatec_add_hidden_device_controls($widget, ['prefix' => 'icons']);
        $widget->end_controls_section();
        // Static Layer
        $widget->start_controls_section('static_section', [
            'label' => esc_html__('Static Layer', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            solatec_add_hidden_device_controls($widget, ['prefix' => 'static_layer']);
        $widget->end_controls_section();
        // Slider Settings
        $widget->start_controls_section('slider_settings', [
            'label' => esc_html__('Slider Settings', 'solatec'),
            'tab' => Controls_Manager::TAB_STYLE,
        ]);
            $widget->add_responsive_control(
                'slider_height',
                [
                    'type'         => Controls_Manager::NUMBER,
                    'selectors'    => [
                        '{{WRAPPER}} .cms-slider-container' => 'height:{{VALUE}}px'
                    ],
                    'default'      => '645' 
                ]
            );
            $widget->add_control(
                'content_width',
                [
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        ''                => esc_html__('Default','solatec'),
                        'container'       => esc_html__('Boxed','solatec'),
                        'container-wide'  => esc_html__('Wide','solatec'),
                        'container-fluid' => esc_html__('Full Width','solatec')
                    ] 
                ]
            );
            $widget->add_control(
                'slide_direction',
                [
                    'label'       => esc_html__('Slides Direction', 'solatec'),
                    'description' => esc_html__('Defines how slides Direction, \'horizontal\' | \'vertical\'', 'solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        'horizontal' => __('Horizontal', 'solatec'),
                        'vertical'   => __('Vertical', 'solatec')
                    ],
                    'default'      => 'horizontal'
                ]
            );
            $widget->add_control(
                'slide_mode',
                [
                    'label'   => esc_html__('Slide Effect', 'solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        'slide'     => esc_html__('Slide', 'solatec'),
                        'fade'      => esc_html__('Fade', 'solatec'),
                        'cube'      => esc_html__('Cube', 'solatec'),
                        'flip'      => esc_html__('Flip', 'solatec')
                    ],
                    'default'      => 'slide',
                    'prefix_class' => 'cms-swiper-effect-'
                ]
            );
            $widget->add_control(
                'autoplay',
                [
                    'label'     => esc_html__('Autoplay', 'solatec'),
                    'type'      => Controls_Manager::SELECT,
                    'options'   => [
                        'true' => __('Yes','solatec'),
                        'false' => __('No', 'solatec')
                    ],
                    'default'   => 'false',
                    'separator' => 'before'
                ]
            );
            $widget->add_control(
                'pause_on_hover',
                [
                    'label'   => esc_html__('Pause on Hover', 'solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options'   => [
                        'true' => __('Yes','solatec'),
                        'false' => __('No', 'solatec')
                    ],
                    'default' => 'true',
                    'condition' => [
                        'autoplay' => 'true'
                    ]
                ]
            );
            $widget->add_control(
                'pause_on_interaction',
                [
                    'label'     => esc_html__('Pause on Interaction', 'solatec'),
                    'type'      => Controls_Manager::SELECT,
                    'options'   => [
                        'true' => __('Yes','solatec'),
                        'false' => __('No', 'solatec')
                    ],
                    'default'   => 'true',
                    'condition' => [
                        'autoplay' => 'true'
                    ]
                ]
            );
            $widget->add_control(
                'autoplay_speed',
                [
                    'label'     => esc_html__('Autoplay Speed', 'solatec'),
                    'type'      => Controls_Manager::NUMBER,
                    'default'   => 5000,
                    'condition' => [
                        'autoplay' => 'true'
                    ]
                ]
            );
            $widget->add_control(
                'loop',
                [
                    'label'   => esc_html__('Infinite Loop', 'solatec'),
                    'type'    => Controls_Manager::SELECT,
                    'options'   => [
                        'true'  => __('Yes','solatec'),
                        'false' => __('No', 'solatec')
                    ],
                    'default' => 'false',
                ]
            );
            $widget->add_control(
                'speed',
                [
                    'label'   => esc_html__('Animation Speed', 'solatec'),
                    'type'    => Controls_Manager::NUMBER,
                    'default' => 300,
                ]
            );
        $widget->end_controls_section();
        // Slider arrows
        $widget->start_controls_section(
            'slider_arrow_settings',
            [
                'label' => esc_html__('Arrows', 'solatec'),
                'tab' => Controls_Manager::TAB_STYLE,
            ]
        );
            $widget->add_responsive_control(
                'arrows',
                [
                    'label'        => esc_html__('Show Arrows', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'true'  => __('Yes', 'solatec'),
                        'false' => __('No','solatec')
                    ], 
                    'default'      => 'true',
                    'separator'    => 'before',
                    'prefix_class' => 'cms-swiper-arrows%s-'
                ]
            );
            $widget->add_control(
                'arrows_pos',
                [
                    'label'        => esc_html__('Arrows Position', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'in-vertical',
                    'options'      => [
                        'in-vertical'   => esc_html__('Inside Vertical','solatec'),
                        'out-vertical'  => esc_html__('Outside Vertical','solatec'),
                        'top-left'      => esc_html__('Top Start','solatec'),
                        'top-right'     => esc_html__('Top End','solatec'),
                        'top-center'    => esc_html__('Top Center','solatec'),
                        'bottom-left'   => esc_html__('Bottom Start','solatec'),
                        'bottom-right'  => esc_html__('Bottom End','solatec'),
                        'bottom-center' => esc_html__('Bottom Center','solatec'),
                        'custom'        => esc_html__('Custom','solatec'),
                    ],
                    'prefix_class' => 'cms-swiper-nav-'
                ]
            );
            $widget->add_control(
                'arrows_poscustom',
                [
                    'label'        => esc_html__('Arrows Position Custom', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'inside',
                    'options'      => [
                        'inside'   => esc_html__('Inside','solatec'),
                        'outside'  => esc_html__('Outside','solatec')
                    ],
                    'prefix_class' => 'cms-swiper-nav-pos-',
                    'condition' => [
                        'arrows_pos' => [ 
                            'top-left', 
                            'top-right',
                            'top-center',
                            'bottom-left',
                            'bottom-right',
                            'bottom-center' 
                        ]
                    ]
                ]
            );
            $widget->add_responsive_control(
                'arrows_ypos',   
                [
                    'label'        => __( 'Arrow Y Position', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => [ 'px', '%' ],
                    'default'      => [
                        'unit' => '%',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        'unit' => '%',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        'unit' => '%',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' => -800,
                            'max' => 800,
                        ],
                        '%' => [
                            'min' => -100,
                            'max' => 100,
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}}.cms-swiper-nav-in-vertical .cms-swiper-arrow' => 'top: {{SIZE}}{{UNIT}}',
                    ],
                    'condition' => [
                        'arrows_pos' => [ 'in-vertical' ]
                    ]
                ]
            );
            $widget->add_control(
                'arrows_style',
                [
                    'label'        => esc_html__('Arrows Styles', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'default',
                    'options'      => [
                        'default'  => esc_html__('Default','solatec'),
                    ],
                    'prefix_class' => 'cms-swiper-nav-style-',
                ]
            );
            solatec_elementor_theme_colors($widget, [
                'name'                => 'arrows_color',
                'label'               => esc_html__('Arrows Color', 'solatec'),
                'custom_label'        => esc_html__('Custom Arrows Color', 'solatec'),
                'custom_selector'     => '.cms-swiper-nav-color-custom .cms-swiper-arrow:not(:hover)',
                'custom_selector_tag' => 'color',
                'prefix_class'        => 'cms-swiper-nav-color-',
                'relation'            => 'and'
            ]);
            solatec_elementor_theme_colors($widget, [
                'name'                => 'arrows_color_hover',
                'label'               => esc_html__('Arrows Color Hover', 'solatec'),
                'custom_label'        => esc_html__('Custom Arrows Color Hover', 'solatec'),
                'custom_selector'     => '.cms-swiper-nav-color-hover-custom .cms-swiper-arrow:hover',
                'custom_selector_tag' => 'color',
                'prefix_class'        => 'cms-swiper-nav-color-hover-',
                'relation'            => 'and'
            ]);
        $widget->end_controls_section();
        // Dots Settings
        $widget->start_controls_section(
            'slider_dots_settings',
            [
                'label'    => esc_html__('Dots Navigation', 'solatec'),
                'tab'      => Controls_Manager::TAB_STYLE,
            ]
        );
            $widget->add_responsive_control(
                'dots',
                [
                    'label'        => esc_html__('Show Dots', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'true'  => __('Yes', 'solatec'),
                        'false' => __('No','solatec')
                    ],
                    'default'      => 'true',
                    'separator'    => 'before',
                    'prefix_class' => 'cms-swiper-dots%s-'
                ]
            );
            $widget->add_control(
                'dots_style',
                [
                    'label'        => esc_html__('Dots Style', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'bullets',
                    'options'      => [
                        'bullets'     => __('Bullets','solatec'),
                        //'dynamic'   => __('Dynamic','solatec'),
                        'progressbar' => __('Progressbar','solatec'),
                        'fraction'    => __('Fraction','solatec'),
                        //'custom'    => __('Custom','solatec')
                    ]
                ]
            );
            $widget->add_control(
                'dots_layout',
                [
                    'label'        => esc_html__('Dots Layout', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'circle',
                    'options'      => [
                        'circle'   => __('Circle','solatec'),
                        'divider'  => __('Divider','solatec'),
                        'custom'   => __('Custom','solatec'),
                    ],
                    'prefix_class' => 'cms-swiper-dots-',
                    'condition' => [
                        'dots_style'  => 'bullets'
                    ]
                ]
            );
            $widget->add_control(
                'dots_style_notice',
                [
                    'type'      => Controls_Manager::RAW_HTML,
                    'raw'       => sprintf( __( 'How to custom pagination, readmore at <a href="%s" target="_blank">swiper.js</a>', 'solatec' ), 'https://swiperjs.com/swiper-api#pagination' ),
                    'condition' => [
                        'dots_style'  => 'custom'
                    ],
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $widget->add_control(
                'dots_style_custom',
                [
                    'type'      => Controls_Manager::TEXTAREA,
                    'label'     => esc_html__('Enter your code here','solatec'),
                    'condition' => [
                        'dots_style'  => 'custom'
                    ],
                    'description' => __('Default','solatec').': function (swiper, current, total) { return current + \' of \' + total;}'
                ]
            );
            $widget->add_control(
                'dots_in_nav',
                [
                    'label'        => esc_html__('Dots In Nav', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        'true' => esc_html__('Yes', 'solatec'),
                        'false'  => esc_html__('No','solatec')
                    ],
                    'default'      => '',
                    'separator'    => 'before',
                    'condition'    => [
                        'arrows'     => 'true',
                        'arrows_pos' => ['top-left', 'top-right', 'top-center','bottom-left', 'bottom-right', 'bottom-center']
                    ] 
                ]
            );
            $widget->add_control(
                'dots_pos',
                [
                    'label'        => esc_html__('Dots Position', 'solatec'),
                    'type'         => Controls_Manager::SELECT,
                    'default'      => 'out',
                    'options'      => [
                        'in'  => esc_html__('Inside','solatec'),
                        'out' => esc_html__('Outside','solatec')
                    ],
                    'condition' => [
                        'dots_in_nav' => 'false'
                    ],
                    'prefix_class' => 'cms-swiper-dots-'
                ]
            );
            solatec_elementor_theme_colors($widget, [
                'name'                => 'dots_color',
                'label'               => esc_html__('Dots Color', 'solatec'),
                'custom_label'        => esc_html__('Custom Dots Color', 'solatec'),
                'custom_selector'     => '.cms-swiper-dots-color-custom ul.cms-swiper-dot li:not(.slick-active):not(:hover) button:before',
                'custom_selector_tag' => 'background',
                'prefix_class'        => 'cms-swiper-dots-color-',
                'relation'            => 'and'
            ]);
            solatec_elementor_theme_colors($widget, [
                'name'                => 'dots_color_hover',
                'label'               => esc_html__('Dots Color Hover', 'solatec'),
                'custom_label'        => esc_html__('Custom Dots Color Hover', 'solatec'),
                'custom_selector'     => '.cms-swiper-dots-color-hover-custom ul.cms-swiper-dot li.slick-active button:before, .cms-swiper-dots-color-hover-custom ul.cms-swiper-dot li:hover button:before',
                'custom_selector_tag' => 'background',
                'prefix_class'        => 'cms-swiper-dots-color-hover-',
                'relation'            => 'and'
            ]);
        $widget->end_controls_section();
        // Sider Lists
        $widget->start_controls_section(
            'cms_slides_list',
            [
                'label'    => esc_html__('Slides List', 'solatec'),
                'tab'      => Controls_Manager::TAB_CONTENT,
            ]
        );
            $repeater = new Repeater();
            $repeater->add_control(
                'image',
                [
                    'label'       => esc_html__('Slide Image', 'wastia'),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true,
                    'default'     => [
                        'url' => Utils::get_placeholder_image_src(),
                    ],
                ]
            );
            $repeater->add_responsive_control(
                'image_position_x',
                [
                    'label'        => __( 'Image Position X (%)', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => ['%'],
                    'default'      => [
                        'unit' => '%'
                    ],
                    'range' => [
                        '%' => [
                            'min' =>  -100,
                            'max' =>  100
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slide-img'     => 'background-position-x:{{SIZE}}%;'
                    ]
                ]
            );
            $repeater->add_responsive_control(
                'image_position',
                [
                    'label'        => __( 'Image Position Y (%)', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => ['%'],
                    'default'      => [
                        'unit' => '%'
                    ],
                    'range' => [
                        '%' => [
                            'min' =>  -100,
                            'max' =>  100
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slide-img'     => 'background-position-y:{{SIZE}}%;',
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slide-img img' => 'opacity:0;'
                    ]
                ]
            );
            $repeater->add_responsive_control(
                'content_text_horz_align',
                [
                    'label'        => __( 'Content Horizontal Align', 'solatec' ),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        ''       => __('Default','solatec'),
                        'start'  => __('Start','solatec'),
                        'center' => __('Center','solatec'),
                        'end'    => __('End','solatec')
                    ],
                    'separator' => 'before'     
                ]
            );
            $repeater->add_responsive_control(
                'content_text_vert_align',
                [
                    'label'        => __( 'Content Vertical Align', 'solatec' ),
                    'type'         => Controls_Manager::SELECT,
                    'options'      => [
                        ''       => __('Default','solatec'),
                        'start'  => __('Start','solatec'),
                        'center' => __('Center','solatec'),
                        'end'    => __('End','solatec')
                    ],
                    'separator'      => 'before',
                    'default'        => '',
                    'default_tablet' => '',
                    'default_mobile' => '',
                ]
            );
            $repeater->add_responsive_control(
                'content_text_width',
                [
                    'label'        => __( 'Content Text Width (%)', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => ['%'],
                    'default'      => [
                        'unit' => '%',
                        'size' => 60
                    ],
                    'tablet_default' => [
                        'unit' => '%',
                        'size' => 100,
                    ],
                    'mobile_default' => [
                        'unit' => '%',
                        'size' => 100,
                    ],
                    'range' => [
                        '%' => [
                            'min' =>  0,
                            'max' =>  100
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slider-content-text' => 'flex: 0 0 {{SIZE}}%; max-width: {{SIZE}}%;'
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slider-content-text' => 'flex: 0 0 {{SIZE}}%; max-width: {{SIZE}}%;'
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slider-content-text' => 'flex: 0 0 {{SIZE}}%; max-width: {{SIZE}}%;'
                            ]
                        ]
                    ],
                    'separator' => 'before'
                ]
            );
            $repeater->add_responsive_control(
                'content_text_top_space',
                [
                    'label'        => __( 'Content Text Top Space', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => ['%','px'],
                    'default'      => [
                        'unit' => '%',
                    ],
                    'range' => [
                        '%' => [
                            'min' =>  0,
                            'max' =>  100,
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slider-content-text' => 'margin-top: {{SIZE}}{{UNIT}};',
                    ],
                    'separator' => 'before'
                ]
            );
            $repeater->add_control(
                'content_text_bg',
                [
                    'type'         => Controls_Manager::SELECT,
                    'label'        => __('Content Background', 'solatec'),
                    'options'      => solatec_elementor_theme_color_opts(['custom' => false]),
                    'default'      => ''
                ]
            );
            $repeater->add_responsive_control(
                'content_text_inner_space',
                [
                    'type'         => Controls_Manager::SLIDER,
                    'label'        => __('Content Inner Space', 'solatec'),
                    'size_units'   => [ 'px'],
                    'default'      => [
                        'unit' => 'px',
                        //'size' => 80,
                    ],
                    'tablet_default' => [
                        'unit' => 'px',
                        //'size' => 40,
                    ],
                    'mobile_default' => [
                        'unit' => 'px',
                        //'size' => 20,
                    ],
                    'range' => [
                        'px' => [
                            'min' => 0,
                            'max' => 200,
                        ]
                    ],
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}}.cms-slider-content-text-inner' => 'padding: {{SIZE}}{{UNIT}}',
                    ]
                ]
            );
            $repeater->add_control(
                'small_heading',
                [
                    'label'       => esc_html__('Small Heading','solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $repeater->add_control(
                'small_heading_color',
                [
                    'label'       => esc_html__( 'Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts()
                ]
            );
            $repeater->add_control(
                'small_heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'small_heading_color'      => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .small-heading' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'small_heading_animation',
                [
                    'label'       => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'        => Controls_Manager::ANIMATION,
                    'label_block' => false,
                ]
            );
            $repeater->add_control(
                'small_heading_animation_delay',
                [
                    'label'     => esc_html__( 'Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            $repeater->add_control(
                'large_heading',
                [
                    'label'       => esc_html__('Large Heading','solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $repeater->add_control(
                'large_heading_color',
                [
                    'label'       => esc_html__( 'Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts()
                ]
            );
            $repeater->add_control(
                'large_heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'large_heading_color'      => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .large-heading' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'large_heading_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'large_heading_animation_delay',
                [
                    'label'     => esc_html__( 'Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            $repeater->add_control(
                'description',
                [
                    'label'       => esc_html__('Description','solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $repeater->add_responsive_control(
                'description_custom_width',
                [
                    'label'        => __( 'Custom width (%)', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'tablet_default' => [
                        'size' => 100,
                    ],
                    'mobile_default' => [
                        'size' => 100,
                    ],
                    'selectors'    => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .description' => 'width:{{SIZE}}%;'
                    ],
                    'condition' => [
                        'description!' => ['','-1']
                    ]
                ]
            );
            $repeater->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),
                    'condition'   => [
                        'description!' => ['','-1'],
                    ]
                ]
            );
            $repeater->add_control(
                'description_custom_color',
                [
                     'label'       => esc_html__( 'Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .description' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'description_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'description_animation_delay',
                [
                    'label'     => esc_html__( 'Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT,
                    'separator' => 'after'
                ]
            );
            $repeater->add_control(
                'description2_icon',
                [
                    'label'       => esc_html__('Description2 Icon','solatec'),
                    'type'        => Controls_Manager::ICONS,
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $repeater->add_control(
                'description2',
                [
                    'label'       => esc_html__('Description2','solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your text', 'solatec' ),
                    'label_block' => true,
                    'separator'   => 'before'
                ]
            );
            $repeater->add_control(
                'description2_color',
                [
                    'label'       => esc_html__( 'Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),
                    'condition'   => [
                        'description2!' => ''
                    ]
                ]
            );
            $repeater->add_control(
                'description2_custom_color',
                [
                    'label'       => esc_html__( 'Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'description2_color' => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} .description2' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'description2_animation',
                [
                    'label'     => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'description2!' => ''
                    ]
                ]
            );
            $repeater->add_control(
                'description2_animation_delay',
                [
                    'label'     => esc_html__( 'Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT,
                    'separator' => 'after',
                    'condition'   => [
                        'description2!' => ''
                    ]
                ]
            );
            // Button 1
            $repeater->add_control(
                'button1_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Button 01', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            solatec_elementor_button_settings($repeater, [
                'effect'       => true,
                'separator'    => ''
            ]);
            // Button 2
            $repeater->add_control(
                'button2_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Button 02', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            solatec_elementor_button_settings($repeater, [
                'prefix'    => 'btn2',
                'effect'    => true,
                'separator' => ''
            ]);
            // Video
            $repeater->add_control(
                'button_video_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Button Video', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            solatec_elementor_button_video_settings($repeater, [
                'default'   => false,
                'separator' => '',
                'effect'    => true
            ]);
            $repeater->add_control(
                'text_before_icon_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __('Text before icon list','solatec'),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'text_before_icon',
                [
                    'type'      => Controls_Manager::TEXTAREA,
                    'label'     => '',
                    'separator' => 'after'
                ]
            );
            // Icon 1
            $repeater->add_control(
                'icon1_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Icon 01', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'icon1_type',
                [
                    'label'       => __('Icon Type','solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        'icon' => __('Icon','solatec'),
                        'img'  => __('Image','solatec') 
                    ],
                    'default' => 'icon'
                ]
            );
            $repeater->add_control(
                'icon1_img',
                [
                    'type'        => Controls_Manager::MEDIA,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon1_type' => 'img'
                    ]
                ]
            );
            $repeater->add_control(
                'icon1',
                [
                    'type'        => Controls_Manager::ICONS,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon1_type' => 'icon'
                    ]
                ]
            );
            $repeater->add_control(
                'icon1_animation',
                [
                    'label'     => esc_html__( 'Icon 01 Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'icon1_animation_delay',
                [
                    'label'     => esc_html__( 'Icon 01 Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            // Icon 2
            $repeater->add_control(
                'icon2_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Icon 02', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'icon2_type',
                [
                    'label'       => __('Icon Type','solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        'icon' => __('Icon','solatec'),
                        'img'  => __('Image','solatec') 
                    ],
                    'default' => 'icon'
                ]
            );
            $repeater->add_control(
                'icon2_img',
                [
                    'type'        => Controls_Manager::MEDIA,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon2_type' => 'img'
                    ]
                ]
            );
            $repeater->add_control(
                'icon2',
                [
                    'type'        => Controls_Manager::ICONS,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon2_type' => 'icon'
                    ]
                ]
            );
            $repeater->add_control(
                'icon2_animation',
                [
                    'label'     => esc_html__( 'Icon 02 Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'icon2_animation_delay',
                [
                    'label'     => esc_html__( 'Icon 02 Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            // Icon 3
            $repeater->add_control(
                'icon3_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Icon 03', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'icon3_type',
                [
                    'label'       => __('Icon Type','solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        'icon' => __('Icon','solatec'),
                        'img'  => __('Image','solatec') 
                    ],
                    'default' => 'icon'
                ]
            );
            $repeater->add_control(
                'icon3_img',
                [
                    'type'        => Controls_Manager::MEDIA,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon3_type' => 'img'
                    ]
                ]
            );
            $repeater->add_control(
                'icon3',
                [
                    'type'        => Controls_Manager::ICONS,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon3_type' => 'icon'
                    ]
                ]
            );
            $repeater->add_control(
                'icon3_animation',
                [
                    'label'     => esc_html__( 'Icon 03 Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'icon3_animation_delay',
                [
                    'label'     => esc_html__( 'Icon 03 Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            // Icon 4
            $repeater->add_control(
                'icon4_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Icon 04', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'icon4_type',
                [
                    'label'       => __('Icon Type','solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        'icon' => __('Icon','solatec'),
                        'img'  => __('Image','solatec') 
                    ],
                    'default' => 'icon'
                ]
            );
            $repeater->add_control(
                'icon4_img',
                [
                    'type'        => Controls_Manager::MEDIA,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon4_type' => 'img'
                    ]
                ]
            );
            $repeater->add_control(
                'icon4',
                [
                    'type'        => Controls_Manager::ICONS,
                    'skin'        => 'inline',
                    'label_block' => false,
                    'condition'   => [
                        'icon4_type' => 'icon'
                    ]
                ]
            );
            $repeater->add_control(
                'icon4_animation',
                [
                    'label'     => esc_html__( 'Icon 04 Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION
                ]
            );
            $repeater->add_control(
                'icon4_animation_delay',
                [
                    'label'     => esc_html__( 'Icon 04 Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::TEXT
                ]
            );
            // Icon Settings
            $repeater->add_control(
                'icons_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Icons Settings', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning'
                ]
            );
            $repeater->add_control(
                'icons_color',
                [
                    'label'       => esc_html__( 'Icon Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),
                    'default'     => 'primary'
                ]
            );
            $repeater->add_control(
                'icons_custom_color',
                [
                    'label'       => esc_html__( 'Icons Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'icons_color'      => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .cms-slide-icon' => 'color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'icons_background',
                [
                    'label'       => esc_html__( 'Icon Background Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),
                    'default'     => 'white'
                ]
            );
            $repeater->add_control(
                'icons_background_custom_color',
                [
                    'label'       => esc_html__( 'Icons Background Custom Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'condition'   => [
                        'icons_background'      => 'custom'
                    ],
                    'selectors'  => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .cms-slide-icon' => 'background-color:{{VALUE}};'
                    ]
                ]
            );
            $repeater->add_control(
                'icons_dimensions',
                [
                    'label'       => esc_html__( 'Icons Demensions', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        ''       => __('Default','solatec'),
                        'custom' => __('Custom','solatec')
                    ]
                ]
            );
            $repeater->add_responsive_control(
                'icons_dimensions_custom',
                [
                    'label'       => esc_html__( 'Icons Demensions Custom', 'solatec' ),
                    'type'        => Controls_Manager::SLIDER,
                    'size_units'   => [ 'px'],
                    'default'      => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' =>  40,
                            'max' => 200,
                        ]
                    ],
                    'required' => true,
                    'selectors' => [
                        '{{WRAPPER}} {{CURRENT_ITEM}} .cms-slide-icon' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}}; line-height: {{SIZE}}{{UNIT}};',
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} {{CURRENT_ITEM}} .cms-slide-icon' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}}; line-height: {{SIZE}}{{UNIT}};',
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} {{CURRENT_ITEM}} .cms-slide-icon' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}}; line-height: {{SIZE}}{{UNIT}};',
                            ]
                        ]
                    ],
                    'condition'    => [
                        'icons_dimensions!' => ['']
                    ]
                ]
            );
            $widget->add_control(
                'cms_slides',
                [
                    'label'    => esc_html__('Add Slide', 'solatec'),
                    'type'     => Controls_Manager::REPEATER,
                    'fields'   => $repeater->get_controls(),
                    'default' => [
                        [
                            'small_heading' => 'Complete Commercial, Residential & Industrial Solar Systems',
                            'large_heading' => 'We Invest In The Future Of Planet!',
                            'description'   => 'As a world wide distributor of solar supplies we endeavor to provide fast and knowledgeable service, we can get you materials by sea or air.',
                            'image'         => [
                                'url' => get_template_directory_uri().'/elementor/templates/widgets/cms_slider/sliders/slider-h1-1.webp'
                            ],
                            'btn_text'        => 'More About Us!',
                            'btn_size'        => 'btn-lg',
                            'btn_color'       => 'accent',
                            'btn_hover_color' => 'primary',
                            'btn_size'        => 'lg',
                            // button 2  
                            'btn2btn_text'        => 'Our Services',
                            'btn2btn_size'        => 'btn-lg',
                            'btn2btn_color'       => 'white',
                            'btn2btn_hover_color' => 'accent',
                            'btn2btn_size'        => 'lg' 
                        ],
                        [
                            'small_heading' => 'Complete Commercial, Residential & Industrial Solar Systems',
                            'large_heading' => 'Energize Society By Reliable Energy!',
                            'description'   => 'As a world wide distributor of solar supplies we endeavor to provide fast and knowledgeable service, we can get you materials by sea or air.',
                            'image'         => [
                                'url' => get_template_directory_uri().'/elementor/templates/widgets/cms_slider/sliders/slider-h1-2.webp'
                            ],
                            'btn_text'        => 'More About Us!',
                            'btn_size'        => 'btn-lg',
                            'btn_color'       => 'accent',
                            'btn_hover_color' => 'primary',
                            'btn_size'        => 'lg',
                            // button 2  
                            'btn2btn_text'        => 'Our Services',
                            'btn2btn_size'        => 'btn-lg',
                            'btn2btn_color'       => 'white',
                            'btn2btn_hover_color' => 'accent',
                            'btn2btn_size'        => 'lg'
                        ]
                    ],
                    'title_field' => '{{{ large_heading }}}',
                ]
            );
        $widget->end_controls_section();
        // Static Layer
        $widget->start_controls_section(
            'static_section_settings',
            [
                'label'     => esc_html__('Static Layer', 'solatec'),
                'tab'       => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout' => ['3']
                ]
            ]
        );
            $widget->add_control(
                'static_layer',
                [
                    'type'    => Controls_Manager::MEDIA,
                    'label'   => esc_html__( 'Static layer', 'solatec' ),
                    'default' => []
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'thumbnail',
                    'control_type' => 'group',
                    'default'      => 'full',
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'static_layer_animation',
                [
                    'label'     => __( 'Motion Effect', 'solatec' ),
                    'type'      => Controls_Manager::ANIMATION,
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'static_layer_animation_delay',
                [
                    'label'     => __( 'Transition Delay', 'solatec' ),
                    'type'      => Controls_Manager::NUMBER,
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'static_layer_note',
                [
                    'type'            => Controls_Manager::RAW_HTML,
                    'raw'             => __( 'Make position for static layer', 'solatec' ),
                    'content_classes' => 'elementor-panel-alert elementor-panel-alert-warning',
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_responsive_control(
                'static_layer_pos_top',
                [
                    'label'        => __( 'Top', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => [ 'px', 'em', '%', 'vw' ],
                    'default'      => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' =>  -2000,
                            'max' => 2000,
                        ],
                        'em' => [
                            'min' =>  -100,
                            'max' =>  100,
                        ],
                        '%' => [
                            'min' =>  -100,
                            'max' =>  100,
                        ],
                        'vw' => [
                            'min' =>  -100,
                            'max' =>  100,
                        ],
                    ],
                    'required' => true,
                    'selectors' => [
                        '{{WRAPPER}} .cms-slide-static-layer' => 'top: {{SIZE}}{{UNIT}};',
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'top: {{SIZE}}{{UNIT}};',
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'top: {{SIZE}}{{UNIT}};',
                            ]
                        ]
                    ],
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_responsive_control(
                'static_layer_pos_right',
                [
                    'label'      => __( 'Right', 'solatec' ),
                    'type'       => Controls_Manager::SLIDER,
                    'size_units' => [ 'px', 'em', '%', 'vw' ],
                    'default'    => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' => -2000,
                            'max' => 2000,
                        ],
                        'em' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        '%' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        'vw' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                    ],
                    'required' => true,
                    'selectors' => [
                        '{{WRAPPER}} .cms-slide-static-layer' => 'right: {{SIZE}}{{UNIT}};',
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'right: {{SIZE}}{{UNIT}};',
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'right: {{SIZE}}{{UNIT}};',
                            ]
                        ]
                    ],
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_responsive_control(
                'static_layer_pos_bottom',
                [
                    'label'        => __( 'Bottom', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => [ 'px', 'em', '%', 'vw' ],
                    'default'      => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' => -2000,
                            'max' => 2000,
                        ],
                        'em' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        '%' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        'vw' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                    ],
                    'required' => true,
                    'selectors' => [
                        '{{WRAPPER}} .cms-slide-static-layer' => 'bottom: {{SIZE}}{{UNIT}};',
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'bottom: {{SIZE}}{{UNIT}};',
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'bottom: {{SIZE}}{{UNIT}};',
                            ]
                        ]
                    ],
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
            $widget->add_responsive_control(
                'static_layer_pos_left',
                [
                    'label'        => __( 'Left', 'solatec' ),
                    'type'         => Controls_Manager::SLIDER,
                    'size_units'   => [ 'px', 'em', '%', 'vw' ],
                    'default'      => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'tablet_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'mobile_default' => [
                        //'unit' => 'px',
                        //'size' => 0,
                    ],
                    'range' => [
                        'px' => [
                            'min' => -2000,
                            'max' =>2000,
                        ],
                        'em' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        '%' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                        'vw' => [
                            'min' => -100,
                            'max' => 100,
                        ],
                    ],
                    'required' => true,
                    'selectors' => [
                        '{{WRAPPER}} .cms-slide-static-layer' => 'left: {{SIZE}}{{UNIT}};',
                    ],
                    'device_args' => [
                        \Elementor\Controls_Stack::RESPONSIVE_TABLET => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'left: {{SIZE}}{{UNIT}};',
                            ]
                        ],
                        \Elementor\Controls_Stack::RESPONSIVE_MOBILE => [
                            'selectors' => [
                                '{{WRAPPER}} .cms-slide-static-layer' => 'left: {{SIZE}}{{UNIT}};',
                            ]
                        ]
                    ],
                    'condition'    => [
                        'static_layer[url]!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}