<?php
use Elementor\Controls_Manager;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_testimonial_register_controls')) {
    add_action('etc_widget_cms_testimonial_register_controls', 'solatec_widget_cms_testimonial_register_controls', 10, 1);
    function solatec_widget_cms_testimonial_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            solatec_elementor_row_align($widget);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_testimonial/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__('Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_testimonial/layout-images/2.png'
                    ],
                ],
                'prefix_class' => 'cms-testimonial-layout-'
            ]);
        $widget->end_controls_section();
        // Slider Settings
        solatec_elementor_slick_slider_settings($widget, [
            'tab' => Controls_Manager::TAB_LAYOUT,
        ]);
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'    => esc_html__( 'Heading', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => false,
                    'condition'   => [
                        'heading_text!'      => ''
                    ]
                ]
            );
            $widget->add_control(
                'heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => false,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'heading_animation',
                [
                    'label'       => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'        => Controls_Manager::ANIMATION,
                    'label_block' => false,
                    'condition'   => [
                        'heading_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Sub Heading
        $widget->start_controls_section(
            'subheading_section',
            [
                'label'    => esc_html__( 'Sub Heading', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'subheading_text',
                [
                    'label'       => esc_html__( 'Sub Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'placeholder' => esc_html__( 'Enter your sub title', 'solatec' ),
                    'label_block' => true,
                    'condition'   => []
                ]
            );
            $widget->add_control(
                'subheading_color',
                [
                    'label'       => esc_html__( 'Sub Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => false,
                    'condition'   => [
                        'subheading_text!'      => ''
                    ]
                ]
            );
            $widget->add_control(
                'sheading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Sub Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => false,
                    'condition'   => [
                        'subheading_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'subheading_animation',
                [
                    'label'       => esc_html__( 'Motion Effect', 'solatec' ),
                    'type'        => Controls_Manager::ANIMATION,
                    'label_block' => false,
                    'condition'   => [
                        'subheading_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Content list
        $widget->start_controls_section(
            'content_list',
            [
                'label'    => esc_html__('Testimonial', 'solatec'),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $ttms = new Repeater();
            $ttms->add_control(
                'title',
                [
                    'label'       => esc_html__('Title', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'sub_title',
                [
                    'label'       => esc_html__('Sub Title', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'position',
                [
                    'label'       => esc_html__('Position', 'solatec'),
                    'type'        => Controls_Manager::TEXT,
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'description',
                [
                    'label'       => esc_html__('Description', 'solatec'),
                    'type'        => Controls_Manager::TEXTAREA,
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'star',
                [
                    'label'       => esc_html__('Star', 'solatec'),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => [
                        '100' => esc_html__('5 Star','solatec'),
                        '80'  => esc_html__('4 Star','solatec'),
                        '60'  => esc_html__('3 Star','solatec'),
                        '40'  => esc_html__('2 Star','solatec'),
                        '20'  => esc_html__('1 Star','solatec'),                                    
                    ],  
                    'default' => '100',
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'star_text',
                [
                    'label'       => esc_html__('Star Text', 'solatec'),
                    'type'        => Controls_Manager::TEXT,  
                    'default'     => 'Execellent!!',
                    'label_block' => true
                ]
            );
            $ttms->add_control(
                'image',
                [
                    'label'       => esc_html__('Image', 'solatec'),
                    'type'        => Controls_Manager::MEDIA,
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'testimonial',
                [
                    'label'    => esc_html__('Add Item', 'solatec'),
                    'type'     => Controls_Manager::REPEATER,
                    'fields'   => $ttms->get_controls(), 
                    'default' => [
                        [
                            'title'       => esc_html__( 'Name #1', 'solatec' ),
                            'sub_title'   => '',
                            'position'    => 'Manager #1',
                            'description' => esc_html__( '#1 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                            'image'       => get_template_directory_uri() . '/images/assets/placeholder/no-image.jpg' 
                        ],
                        [
                            'title'       => esc_html__( 'Name #2', 'solatec' ),
                            'sub_title'   => '',
                            'position'    => 'Manager #2',
                            'description' => esc_html__( '#2 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                            'image'       => get_template_directory_uri() . '/images/assets/placeholder/no-image.jpg'
                        ],
                        [
                            'title'       => esc_html__( 'Name #3', 'solatec' ),
                            'sub_title'   => '',
                            'position'    => 'Manager #3',
                            'description' => esc_html__( '#3 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.', 'solatec' ),
                            'image'       => get_template_directory_uri() . '/images/assets/placeholder/no-image.jpg'
                        ]
                    ],
                    'title_field' => '{{{ title }}}'
                ]
            );
        $widget->end_controls_section();
        // Text Settings
        $widget->start_controls_section(
            'desc_section',
            [
                'label'    => esc_html__( 'Testimonial Text Settings', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'description_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ]
                ]
            );
        $widget->end_controls_section();
    }
}