<?php
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Repeater;
if (!function_exists('solatec_widget_cms_video_register_controls')) {
    add_action('etc_widget_cms_video_register_controls', 'solatec_widget_cms_video_register_controls', 10, 1);
    function solatec_widget_cms_video_register_controls($widget)
    {
        // Layout Section Start
        $widget->start_controls_section('layout_section', [
            'label' => esc_html__('Layout', 'solatec'),
            'tab' => Controls_Manager::TAB_LAYOUT
        ]);
            $widget->add_control('layout', [
                'label'   => esc_html__('Templates', 'solatec'),
                'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                'default' => '1',
                'options' => [
                    '1' => [
                        'label' => esc_html__('Layout 1', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/1.png'
                    ],
                    '2' => [
                        'label' => esc_html__('Layout 2', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/2.png'
                    ],
                    '3' => [
                        'label' => esc_html__('Layout 3', 'solatec' ),
                        'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/3.png'
                    ],
                ],
                'prefix_class' => 'cms-video-layout-'
            ]);
        $widget->end_controls_section();
        // Video
        $widget->start_controls_section(
            'video_section',
            [
                'label'    => esc_html__('Video', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'video_link',
                [
                    'label' => esc_html__('Link', 'solatec' ),
                    'type'  => Controls_Manager::TEXT,
                    'default' => ''
                ]
            );
        $widget->end_controls_section();
        // Image
        $widget->start_controls_section(
            'image_section',
            [
                'label'    => esc_html__('Image Overlay', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'video_image_overlay',
                [
                    'label'   => esc_html__( 'Choose Image', 'solatec' ),
                    'type'    => Controls_Manager::MEDIA,
                    'dynamic' => [
                        'active' => true,
                    ]
                ]
            );
            $widget->add_group_control(
                Group_Control_Image_Size::get_type(),
                [
                    'name'         => 'video_image_overlay_size',
                    'default'      => 'full',
                    'separator'    => 'none'
                ]
            );
            $widget->add_control(
                'video_image_as_background',
                [
                    'label'   => esc_html__( 'Make Image as Background', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'default' => 'false',
                    'options' => [
                        'true'  => esc_html__('Yes','solatec'),
                        'false' => esc_html__('No', 'solatec')
                    ]
                ]
            );
            $widget->add_control(
                'gradient_overlay',
                [
                    'label'       => esc_html__( 'Gradient Overlay', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'label_block' => true,
                    'options'     => [
                        '' => esc_html__('Default', 'solatec'),
                        '1' => esc_html__('Gradient 1', 'solatec'),
                        '2' => esc_html__('Gradient 2', 'solatec'),
                        '3' => esc_html__('Gradient 3', 'solatec'),
                        '4' => esc_html__('Gradient 4', 'solatec'),
                        '5' => esc_html__('Gradient 5', 'solatec'),
                    ],
                    'default' => ''
                ]
            );
            $widget->add_control(
                'gradient_bg_color',
                [
                    'label'       => esc_html__( 'Gradient Overlay Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'options'     => '',  
                    'default'     => '',
                    'label_block' => true,
                    'condition'   => [
                        'gradient_overlay!' => ''
                    ]
                ]
            );
            $widget->add_control(
                'border_radius',
                [
                    'label'      => esc_html__( 'Border Radius', 'solatec' ),
                    'type'       => Controls_Manager::DIMENSIONS,
                    'size_units' => [ 'px', '%' ],
                    'selectors'  => [
                        '{{WRAPPER}} .cms-video-player' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                        '{{WRAPPER}} .cms-video-player .video-bg.cms-img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    ]
                ]
            );
        $widget->end_controls_section();
        // Play
        $widget->start_controls_section(
            'play_section',
            [
                'label'    => esc_html__('Play Button', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'video_play_btn_style',
                [
                    'label'   => esc_html__('Style', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        'icon'       => esc_html__('Play Icon','solatec'),
                        'custom-btn' => esc_html__('Custom Button','solatec'),
                    ],
                    'default' => 'icon'
                ]
            );
            $widget->add_control(
                'play_icon_style',
                [
                    'label'   => esc_html__('Play Icon Style', 'solatec' ),
                    'type'    => Elementor_Theme_Core::LAYOUT_CONTROL,
                    'default' => '2',
                    'options' => [
                        '1' => [
                            'label' => esc_html__('Play Icon 1', 'solatec' ),
                            'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/play-icon1.png'
                        ],
                        '2' => [
                            'label' => esc_html__('Play Icon 2', 'solatec' ),
                            'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/play-icon2.png'
                        ],
                        '3' => [
                            'label' => esc_html__('Play Icon 3', 'solatec' ),
                            'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/play-icon3.png'
                        ],
                        '4' => [
                            'label' => esc_html__('Play Icon 4', 'solatec' ),
                            'image' => get_template_directory_uri() . '/elementor/templates/widgets/cms_video/layout-images/play-icon4.png'
                        ],
                    ],
                    'condition'    => [
                        'video_play_btn_style' => 'icon'
                    ],
                    'prefix_class' => 'cms-video-play-icon-style-'
                ]
            );
            $widget->add_control(
                'play_icon_icon',
                [
                    'label'            => esc_html__( 'Play Icon', 'solatec' ),
                    'type'             => Controls_Manager::ICONS,
                    'fa4compatibility' => 'icon',
                    'default'          => [
                        'value'     => '',
                        'library'   => '',
                    ],
                    'condition' => [
                        'video_play_btn_style'    => ['icon']                            
                    ]
                ]
            );
            $widget->add_control(
                'play_icon_img',
                [
                    'label'   => esc_html__( 'Choose Play Image', 'solatec' ),
                    'type'    => Controls_Manager::MEDIA,
                    'default' => [
                        'url' => \Elementor\Utils::get_placeholder_image_src(),
                    ],
                    'dynamic' => [
                        'active' => true,
                    ],
                    'condition'    => [
                        'play_icon_style' => ['2']
                    ]
                ]
            );
            $widget->add_control(
                'play_icon_text',
                [
                    'label'     => esc_html__('Play Text', 'solatec' ),
                    'type'      => Controls_Manager::TEXT,
                    'condition' => [
                        'play_icon_style' => ['2','3']
                    ]
                ]
            );
            $widget->add_control(
                'video_play_btn_position',
                [
                    'label'   => esc_html__('Position', 'solatec' ),
                    'type'    => Controls_Manager::SELECT,
                    'options' => [
                        ''              => esc_html__('Default','solatec'),
                        'top-left'      => esc_html__('Top Left','solatec'),
                        'top-center'    => esc_html__('Top Center','solatec'),
                        'top-right'     => esc_html__('Top Right','solatec'),
                        'center-left'   => esc_html__('Center Left','solatec'),
                        'center-center' => esc_html__('Center Center','solatec'),
                        'center-right'  => esc_html__('Center Right','solatec'),
                        'bottom-left'   => esc_html__('Bottom Left','solatec'),
                        'bottom-center' => esc_html__('Bottom Center','solatec'),
                        'bottom-right'  => esc_html__('Bottom Right','solatec')
                    ],
                    'default'      => '',
                ]
            );
            solatec_elementor_button_settings($widget, [
                'prefix'    => 'video_',
                'btn_link_type' => [
                    'video' => esc_html__('Open Video','solatec')
                ],
                'btn_type'   => [
                    'btn-video2' => esc_html__('Video 2', 'solatec')
                ],
                'condition' => [
                    'video_play_btn_style' => 'custom-btn'
                ]
            ]);
            $widget->add_control(
                'btn_margin',
                [
                    'label'      => esc_html__( 'Margin', 'solatec' ),
                    'type'       => Controls_Manager::DIMENSIONS,
                    'size_units' => ['px'],
                    'selectors'  => [
                        '{{WRAPPER}} .btn-video-wrap' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    ]
                ]
            );
            $widget->add_control(
                'btn_padding',
                [
                    'label'      => esc_html__( 'Padding', 'solatec' ),
                    'type'       => Controls_Manager::DIMENSIONS,
                    'size_units' => ['px'],
                    'selectors'  => [
                        '{{WRAPPER}} .btn-video-wrap' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    ]
                ]
            );
        $widget->end_controls_section();
        // Heading
        $widget->start_controls_section(
            'heading_section',
            [
                'label'    => esc_html__( 'Heading', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'heading_text',
                [
                    'label'       => esc_html__( 'Heading', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '',
                    'placeholder' => esc_html__( 'Enter your title', 'solatec' ),
                    'label_block' => true
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'heading_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-video-title'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'heading_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-video-title'
                ]
            );
            $widget->add_control(
                'heading_color',
                [
                    'label'       => esc_html__( 'Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'heading_custom_color',
                [
                    'label'       => esc_html__( 'Custom Heading Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'heading_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'heading_extra_space',
                [
                    'label' => esc_html__( 'Extra bottom Space', 'solatec' ),
                    'type' => Controls_Manager::NUMBER,
                    'condition'   => [
                        'heading_text!' => '',
                        'layout'        => ['1']
                    ]
                ]
            );
            $widget->add_control(
                'heading_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'heading_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Description 
        $widget->start_controls_section(
            'desc_section',
            [
                'label'    => esc_html__( 'Description', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT
            ]
        );
            $widget->add_control(
                'description_text',
                [
                    'label'       => esc_html__( 'Description', 'solatec' ),
                    'type'        => Controls_Manager::TEXTAREA,
                    'default'     => '',
                    'placeholder' => esc_html__( 'Enter your description', 'solatec' ),
                    'rows'        => 10,
                    'show_label'  => false,
                    'condition'   => []
                ]
            );
            $widget->add_group_control(
                Group_Control_Typography::get_type(),
                [
                    'name'         => 'description_text_typo',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-video-sub-title'
                ]
            );
            $widget->add_group_control(
                Group_Control_Text_Shadow::get_type(),
                [
                    'name'         => 'description_text_shadow',
                    'default'      => '',
                    'selector'     => '{{WRAPPER}} .cms-video-sub-title'
                ]
            );
            $widget->add_control(
                'description_color',
                [
                    'label'       => esc_html__( 'Description Color', 'solatec' ),
                    'type'        => Controls_Manager::SELECT,
                    'options'     => solatec_elementor_theme_color_opts(),  
                    'default'     => '',
                    'label_block' => true
                ]
            );
            $widget->add_control(
                'description_custom_color',
                [
                    'label'       => esc_html__( 'Custom Description Color', 'solatec' ),
                    'type'        => Controls_Manager::COLOR,
                    'label_block' => true,
                    'condition'   => [
                        'description_color'      => 'custom'
                    ]
                ]
            );
            $widget->add_control(
                'description_animation',
                [
                    'label' => esc_html__( 'Motion Effect', 'solatec' ),
                    'type' => Controls_Manager::ANIMATION,
                    'condition'   => [
                        'description_text!' => ''
                    ]
                ]
            );
        $widget->end_controls_section();
        // Button 1
        $widget->start_controls_section(
            'button_section1',
            [
                'label'    => esc_html__( 'Buttons 01', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout!' => ['3']
                ]
            ]
        );
            solatec_elementor_button_settings($widget);
        $widget->end_controls_section();
        // Button 1
        $widget->start_controls_section(
            'button_section2',
            [
                'label'    => esc_html__( 'Buttons 02', 'solatec' ),
                'tab'      => Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'layout!' => ['3']
                ]
            ]
        );
            solatec_elementor_button_settings($widget, [
                'prefix'           => 'heading_btn2'
            ]);
        $widget->end_controls_section();
    }
}