( function( $ ) {
    var CMSSliderHandler = function( $scope, $ ) {
        var breakpoints = elementorFrontend.config.breakpoints,
            carousel = $scope.find(".cms-slider-container");
        if(carousel.length == 0){
            return false;
        }
        var data = carousel.data(), 
            settings = data.settings,
            custom_dots = data.customdot;
            settings['pause_on_hover'] === 'true';
            carousel_settings = {
                direction: settings['slide_direction'],
                effect: settings['slide_mode'],
                wrapperClass : 'cms-swiper-slider',
                slideClass: 'cms-slider-item',
                slidesPerView: 1,
                slidesPerGroup: 1,
                slidesPerColumn: 1,
                spaceBetween: 0,
                navigation: {
                  nextEl: ".cms-swiper-arrow-next",
                  prevEl: ".cms-swiper-arrow-prev",
                },
                speed: settings['speed'],
                on: {
                    init : function (swiper){
                        var activeIndex = this.activeIndex;
                        var current = this.slides.eq(activeIndex);
                        $('.swiper-slide .cms-animate').each(function(){
                            var data = $(this).data('settings');
                            $(this).removeClass('animated '+data['animation']).addClass('cms-invisible');
                        });
                        current.find('.cms-animate').each(function(){
                            var  $item = $(this), 
                                 data = $item.data('settings');
                            setTimeout(function () {
                                $item.removeClass('cms-invisible').addClass('animated ' + data['animation']);
                            }, data['animation_delay']);
                        });  
                    },
                    slideChangeTransitionStart : function (swiper){
                        var activeIndex = this.activeIndex;
                        var current = this.slides.eq(activeIndex);
                        $('.swiper-slide .cms-animate').each(function(){
                            var data = $(this).data('settings');
                            $(this).removeClass('animated '+data['animation']).addClass('cms-invisible');
                        });
                        current.find('.cms-animate').each(function(){
                            var  $item = $(this), 
                                 data = $item.data('settings');
                            setTimeout(function () {
                                $item.removeClass('cms-invisible').addClass('animated ' + data['animation']);
                            }, data['animation_delay']);
                        });
                    },
                    slideChange: function (swiper) {
                        var activeIndex = this.activeIndex;
                        var current = this.slides.eq(activeIndex);
                        $('.swiper-slide .cms-animate').each(function(){
                            var data = $(this).data('settings');

                            $(this).removeClass('animated '+data['animation']).addClass('cms-invisible');
                        });
                        current.find('.cms-animate').each(function(){
                            var  $item = $(this), 
                                 data = $item.data('settings');
                            setTimeout(function () {
                                $item.removeClass('cms-invisible').addClass('animated ' + data['animation']);
                            }, data['animation_delay']);
                        });
                    }
                },
                autoHeight: false
            };
            // loop
            if(settings['loop'] === 'true'){
                carousel_settings['loop'] = true;
            }
            // auto play
            if(settings['autoplay'] === 'true'){
                carousel_settings['autoplay'] = {
                    delay : settings['delay'],
                    disableOnInteraction : settings['pause_on_interaction']
                };
            } else {
                carousel_settings['autoplay'] = false;
            }
            // custom dots style
            if(settings['dots_style'] === 'custom' && settings['dots_style_custom'] === 'number'){
                carousel_settings['pagination'] = {
                    el: '.cms-swiper-dots',
                    clickable : true,
                    modifierClass: 'cms-swiper-pagination-',
                    bulletClass : 'cms-swiper-pagination-number',
                    renderBullet:  function (index, className) {
                        number = index + 1;
                        if(number < 10 ) number = '0'+number;
                        return '<span class="' + className + '">' + number + "</span>";
                    }
                }
            } else {
                 carousel_settings['pagination'] = {
                    type: settings['dots_style'],
                    el: '.cms-swiper-dots',
                    clickable : true,
                    modifierClass: 'cms-swiper-pagination-',
                    bulletClass : 'cms-swiper-pagination-bullet'
                }
            }
            // Effect
            if(settings['slide_mode'] === 'cube'){
                carousel_settings['cubeEffect'] = {
                  shadow: true,
                  slideShadows: true,
                  shadowOffset: 20,
                  shadowScale: 0.94,
                };
            }
        carousel.each(function(index, element) {
            var swiper = new Swiper(carousel, carousel_settings);
            if(settings['autoplay'] === 'true' && settings['pause_on_hover'] === 'true'){
                $(this).on({
                  mouseenter: function mouseenter() {
                    this.swiper.autoplay.stop();
                  },
                  mouseleave: function mouseleave() {
                    this.swiper.autoplay.start();
                  }
                });
            }
        });     
    };
    // Make sure you run this code under Elementor.
    $( window ).on( 'elementor/frontend/init', function() {
        // Sliders
        elementorFrontend.hooks.addAction( 'frontend/element_ready/cms_slider.default', CMSSliderHandler );
    } );
} )( jQuery );