(function($) {
    "use strict";
    $( window ).on( 'elementor/frontend/init', function() {
    	var _elementor = typeof elementor != 'undefined' ? elementor : elementorFrontend;
    	
		_elementor.hooks.addFilter( 'etc-custom-section-classes', function( settings ) {
			let custom_classes = [];
			if(typeof settings.custom_style != 'undefined' && settings.custom_style != ''){
				custom_classes.push('style-' + settings.custom_style);
			}

        	return custom_classes;
		} );

		_elementor.hooks.addFilter( 'etc-custom-column-classes', function( settings ) {
			let custom_classes = [];
			if(typeof settings.custom_style != 'undefined' && settings.custom_style != ''){
				custom_classes.push('style-' + settings.custom_style);
			}

        	return custom_classes;
		} );
		
		// lazy load image
		elementorFrontend.hooks.addAction( 'frontend/element_ready/global', function() {
			// lazy load
            $('.cms-lazy').each(function() {
                var $src = $(this).data('src');
                $(this).attr('src', $src).removeClass('lazy-loading');
            });
		});
		// Animate
		var GlobalWidgetAnimateHandler = function( $scope, $ ) {
	        elementorFrontend.waypoint($scope.find('.elementor-invisible'), function () {
	            var $heading = $(this),
	                data = $heading.data('settings');

	            if(typeof data['_animation'] != 'undefined'){
	                //$heading.addClass(data['_animation']+' animated').removeClass('elementor-invisible');
	                setTimeout(function () {
	                    $heading.removeClass('elementor-invisible').addClass('animated ' + data['_animation']);
	                }, data['animation_delay']);
	            }
	        });
	    };
	    elementorFrontend.hooks.addAction( 'frontend/element_ready/global', GlobalWidgetAnimateHandler);
    });
}(jQuery));