<?php
// Wrap
$widget->add_render_attribute('wrap', [
    'class' => 'cms-counter-wrap '.solatec_elementor_align_class($settings)
]);
// Counter Number
$widget->add_render_attribute( 'counter', [
    'class' => 'cms-counter-number cms-heading font-400 text-60 lh-60 text-'.$widget->get_setting('number_color','accent'),
    'data-duration' => $widget->get_settings('duration', '300'),
    'data-to-value' => $widget->get_settings('ending_number', 999),
] );

if ( ! empty( $settings['thousand_separator'] ) ) {
    $delimiter = empty( $settings['thousand_separator_char'] ) ? ',' : $settings['thousand_separator_char'];
    $widget->add_render_attribute( 'counter', 'data-delimiter', $delimiter );
}

// Title
$widget->add_render_attribute( 'title', [
    'class' => 'cms-counter-title cms-heading text-16 lh-26 pt-15 text-'.$widget->get_setting('title_color','')
] );
// Description 
$widget->add_render_attribute( 'description', [
    'class' => 'cms-counter-desc pt-25 text-'.$widget->get_setting('description_color','')
] );
?>
<div <?php etc_print_html($widget->get_render_attribute_string( 'wrap' ));?>>
    <div class="row gutters-15 justify-content-center align-items-center">
        <?php if($settings['icon_type'] === 'icon'): ?>
            <div class="cms-counter-icon mb-5 text-40 text-accent col-12"><?php 
                solatec_elementor_icon_render($settings, [
                    'id' => 'counter_icon'
                ] ); 
            ?></div>
        <?php elseif($settings['icon_type'] == 'image'): ?>
            <div class="cms-counter-image mb-5 col-12"><?php
                solatec_elementor_image_render($settings, [
                    'id' => 'icon_image'
                ]);
            ?></div>
        <?php endif; ?>
        <div class="cms-counter-number-wrapper cms-heading col-12">
            <span class="cms-counter-number-prefix"><?php echo esc_html($settings['prefix']); ?></span>
            <span <?php etc_print_html($widget->get_render_attribute_string( 'counter' )); ?>><?php echo esc_html($settings['starting_number']); ?></span>
            <span class="cms-counter-number-suffix"><?php echo esc_html($settings['suffix']); ?></span>
        </div>
    </div>
    <?php if ( $settings['title'] ) : ?>
        <div <?php etc_print_html($widget->get_render_attribute_string( 'title' )); ?>><?php etc_print_html($settings['title']); ?></div>
    <?php endif; ?>
    <?php if ( $settings['description_text'] ) : ?>
        <div <?php etc_print_html($widget->get_render_attribute_string( 'description' )); ?>><?php etc_print_html($settings['description_text']); ?></div>
    <?php endif; ?>
    <div class="cms-counter-links pt-15 empty-none"><?php 
        foreach ($settings['counter_link'] as $value) {
            solatec_elementor_hyperlink_render($value,[
                'class'        => 'cms-counter-link font-700 text-'.$settings['link_color'].' text-hover-'.$settings['link_color_hover'],
                'link_type'    => $value['link_type'],
                'default_icon' => [
                    'value'   => 'cmsi-long-arrow-right-1',
                    'library' => 'cmsi'
                ],
            ]);
        }
    ?></div>
</div>