<?php
$title = $widget->get_setting('title', 'Save Your Money');
$desc = $widget->get_setting('description', '');

$icon_color = $widget->get_setting('icon_color', 'accent');
$title_color = $widget->get_setting('title_color', '');
$desc_color = $widget->get_setting('description_color', '');

switch ($settings['mode']) {
    case 'carousel':
    ?>
    <div class="cms-slick-slider-data-settings <?php echo solatec_elementor_align_class($settings);?>">
        <?php foreach ($settings['fancy_list'] as $value) { ?>
        <div class="cms-fancy-box-item slick-item slick-slide p-lr-15">
            <?php  
                solatec_elementor_icon_render($value,[
                    'class' => 'text-64 mb-10 text-'.$icon_color
                ]);
                solatec_elementor_image_render($value,[
                    'class' => 'text-64 mb-10 text-'.$icon_color
                ]);
            ?>
            <div class="cms-heading text-18 text-<?php echo esc_attr($title_color);?>"><?php
                etc_print_html($value['title']);
            ?></div> 
            <?php if(!empty($value['description'])) { ?>
                <div class="pt-15 text-<?php echo esc_attr($desc_color);?>"><?php
                    etc_print_html($value['description']);
                ?></div>
            <?php } 
                solatec_elementor_hyperlink_render($value, [
                    'class'     => 'pt-10',
                    'link_type' => $value['link_type']
                ]);
            ?>
        </div>
        <?php } ?>
    </div>
    <?php
        break;
    
    default:
?>
<div class="cms-fancybox-1 <?php echo solatec_elementor_align_class($settings);?>">
    <?php  
        solatec_elementor_icon_render($settings,[
            'class' => 'text-64 mb-10 text-'.$widget->get_setting('icon_color', 'accent')
        ]);
        solatec_elementor_image_render($settings,[
            'class' => 'text-64 mb-10 text-'.$widget->get_setting('icon_color', 'accent')
        ]);
    ?>
    <div class="cms-heading text-18 text-<?php echo esc_attr($widget->get_setting('title_color', ''));?>"><?php
        etc_print_html($title);
    ?></div> 
    <?php if(!empty($desc)) { ?>
        <div class="pt-15 text-<?php echo esc_attr($widget->get_setting('description_color', ''));?>"><?php
            etc_print_html($desc);
        ?></div>
    <?php } ?>
    <?php 
        if($settings['hyperlink'] === ''){
        solatec_elementor_hyperlink_render($settings, [
            'class' => 'pt-10',
            'link_type' => $settings['link_type']
        ]);
    } else {
        solatec_elementor_button_render($settings, [
            'prefix' => 'button',
            'class'  => 'd-inline-block mt-10'
        ]);
    }
    ?>
</div>
<?php
        break;
}



