<?php 
// Wrap 
$widget->add_render_attribute( 'wrap', 'class', 'cms-ptitle-wrapper cms-bg-cover');
$widget->add_render_attribute( 'wrap', 'class', solatec_elementor_align_class($settings));
// Wrap Background 
$background = '';
if(!empty($settings['background']['url'])){
    $widget->add_render_attribute( 'wrap', 'style', 'background-image:url('.$settings['background']['url'].');');
} elseif( has_post_thumbnail()) {
    $widget->add_render_attribute( 'wrap', 'style', 'background-image:url('.get_the_post_thumbnail_url(null, 'full').');');
}
// Overlay 
$widget->add_render_attribute( 'overlay', 'class', 'cms-page-title-gradient');
$widget->add_render_attribute( 'overlay', 'class', 'cms-gradient-'.$widget->get_setting('bg_overlay', '3'));
// Heading
$heading_text = $widget->get_setting('heading_text', get_the_title());
$widget->add_render_attribute( 'heading', 'class', 'cms-heading text-40 pb-20');
$widget->add_render_attribute( 'heading', 'class', 'text-'.$widget->get_setting('heading_color', 'white'));
if ( $settings['heading_animation'] ) {
    $widget->add_render_attribute( 'heading', 'class', 'animated ' . $settings['heading_animation'] );
}
if($settings['heading_color'] === 'custom' && !empty($settings['heading_custom_color'])){
    $widget->add_render_attribute( 'heading', 'style', 'color:'.$settings['heading_custom_color']);
}
// Sub Heading
$subheading_text = $widget->get_setting('subheading_text', wp_trim_words(get_the_excerpt(), '18', ''));
$widget->add_render_attribute( 'subheading', 'class', 'cms-subheading text-17 lh-27 pr-xl-100 font-700 pb-30');
$widget->add_render_attribute( 'subheading', 'class', 'text-'.$widget->get_setting('subheading_color','white'));
if ( $settings['subheading_animation'] ) {
    $widget->add_render_attribute( 'subheading', 'class', 'animated ' . $settings['subheading_animation'] );
}
if($settings['subheading_color'] === 'custom' && !empty($settings['subheading_custom_color'])){
    $widget->add_render_attribute( 'subheading', 'style', 'color:'.$settings['subheading_custom_color']);
}
?>

<div <?php etc_print_html($widget->get_render_attribute_string( 'wrap' )); ?>>
    <div <?php etc_print_html($widget->get_render_attribute_string( 'overlay' )); ?>>
        <div class="container">
            <div class="row">
                <div class="col-xl-<?php echo esc_attr($widget->get_setting('content_width', '6'));?>">
                    <div <?php etc_print_html($widget->get_render_attribute_string( 'heading' )); ?>><?php
                        solatec_elementor_icon_render($settings, [
                            'wrap_class' => 'mb-20 empty-none',
                            'class'      => 'cms-icon-50 text-50'
                        ]);
                        etc_print_html($heading_text);
                    ?></div>
                    <div <?php etc_print_html($widget->get_render_attribute_string( 'subheading' )); ?>><?php
                        etc_print_html($subheading_text);
                    ?></div>
                    <div class="row empty-none gutters-grid"><?php
                        solatec_elementor_button_render($settings, [
                            'prefix'    => 'btn1',
                            'class'     => 'col-auto', 
                            'btn_class' => ''
                        ]);
                        solatec_elementor_button_render($settings, [
                            'prefix'    => 'btn2',
                            'class'     => 'col-auto', 
                            'btn_class' => ''
                        ]);
                    ?></div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="cms-breadcrumb-wrap">
    <div class="container">
        <?php
            solatec_breadcrumb([
                'show_breadcrumb' => $settings['show_breadcrumb'],
                'class'           => 'text-14 pt-15',
                'link_class'      => 'text-'.$settings['breadcrumb_link_color'],
                'text_class'      => 'text-'.$settings['breadcrumb_color'],
                'divider'         => '<span class="breadcrumb-divider fa fa-angle-right flip-rtl text-'.$settings['breadcrumb_color'].'"></span>'
            ]);
        ?>
    </div>
</div>
