 <?php 
$slider_settings_class = ['cms-slider-container', 'overflow-hidden'];
//if($widget->get_setting('slide_direction') === 'vertical') $slider_settings_class[] = 'overflow-hidden';
$slider_settings_class = implode(' ', $slider_settings_class);
// Slides list
$cms_slides = $settings['cms_slides'];

// Slide content
$widget->add_render_attribute( 'item-content', 'class', 'cms-slide-content cms-overlay');
$widget->add_render_attribute( 'item-content', 'class', $widget->get_setting('content_width', 'container'));
// Slide content inner 
$widget->add_render_attribute( 'item-content-inner', 'class','cms-slide-content-inner h-100');
// Rate star
$widget->add_render_attribute( 'rate_star', 'class', 'cms-rate-star text-center'); 
$widget->add_render_attribute( 'rate_star', 'style', 'background-color:'.$widget->get_setting('rate_star_bg', '#ff830c'));

// repeat attributes
foreach ($cms_slides as $key => $slide) {
	$data_id = $slide['_id'];
	// item attrs
	$item_key = $widget->get_repeater_setting_key( 'item_key', 'cms_slides', $key );
	$widget->add_render_attribute( $item_key, 'class', 'cms-slider-item swiper-slide elementor-repeater-item-'.$data_id);
}

?>
<div class="cms-sliders-wrap">
	<div <?php solatec_swiper_slider_settings($widget, ['swiper_container' => $slider_settings_class]); ?>>
		<?php solatec_swiper_slider_arrows_top($settings); ?>
        <div class="cms-swiper-slider swiper-wrapper h-100">
			<?php
				foreach ($cms_slides as $key => $slide) {
					$data_id = $slide['_id'];
					
					$item_key = $widget->get_repeater_setting_key( 'item_key', 'cms_slides', $key );
					//item_content_img
					$item_content_img = $widget->get_repeater_setting_key('item_content_img','slides', $key);
					$widget->add_render_attribute( $item_content_img, [
						'class'	=> ['cms-slide-img h-100', 'elementor-repeater-item-'.$data_id ],
			            'style' => [
			            	'background-image:url('.$slide['image']['url'].')'
			            ]
			        ] );
			        //item_content_img_attrs
			        $item_content_img_attrs = $widget->get_repeater_setting_key('item_content_img_attrs','slides', $key);
					$widget->add_render_attribute( $item_content_img_attrs, [
						'class'    => ['cms-lazy lazy-loading img-cover'],
						'data-src' => $slide['image']['url'],
						'alt'      => get_bloginfo('name'),
						'width'	   => '10',
						'height'   => '10'	
			        ] );
			        if(!empty($slide['image_position']['size'])){
			        	$widget->add_render_attribute( $item_content_img_attrs, [
							'class'	=> []
				        ] );
			        }
			        //item_content__inner
					$item_content__inner = $widget->get_repeater_setting_key( 'item_content__inner', 'slides', $key );
					$widget->add_render_attribute( $item_content__inner, [
			            'class' => [
			            	'row gutters-30 gutters-grid h-100',
			            	!empty($slide['content_text_horz_align']) ? 'text-'.$slide['content_text_horz_align'] : 'align-items-start',
			            	!empty($slide['content_text_horz_align_tablet']) ? 'text-lg-'.$slide['content_text_horz_align_tablet'] : '',
			            	!empty($slide['content_text_horz_align_mobile']) ? 'text-md-'.$slide['content_text_horz_align_mobile'] : '',
			            	!empty($slide['content_text_horz_align']) ? 'justify-content-'.$slide['content_text_horz_align'] : 'align-items-start',
			            	!empty($slide['content_text_horz_align_tablet']) ? 'justify-content-lg-'.$slide['content_text_horz_align_tablet'] : '',
			            	!empty($slide['content_text_horz_align_mobile']) ? 'justify-content-md-'.$slide['content_text_horz_align_mobile'] : '',
			            	!empty($slide['content_text_vert_align']) ? 'align-items-'.$slide['content_text_vert_align'] : 'align-items-center',
			            	!empty($slide['content_text_vert_align_tablet']) ? 'align-items-lg-'.$slide['content_text_vert_align_tablet'] : '',
			            	!empty($slide['content_text_vert_align_mobile']) ? 'align-items-md-'.$slide['content_text_vert_align_mobile'] : ''
			            ]
			        ] );
					// Buttons 
					$item_content_buttons = $widget->get_repeater_setting_key( 'item_content_buttons', 'slides', $key );
					$widget->add_render_attribute( $item_content_buttons, [
			            'class' => [
			            	'cms-slider-buttons row gutters-30 gutters-grid pt-35 align-items-center empty-none',
			            	!empty($slide['content_text_horz_align']) ? 'justify-content-'.$slide['content_text_horz_align'] : 'align-items-start',
			            	!empty($slide['content_text_horz_align']) ? 'justify-content-lg-'.$slide['content_text_horz_align_tablet'] : '',
			            	!empty($slide['content_text_horz_align']) ? 'justify-content-md-'.$slide['content_text_horz_align_mobile'] : '',
			            ]
			        ] );
					// small heading 
					$small_heading_animation = !empty($slide['small_heading_animation']) ? $slide['small_heading_animation'] : 'fadeInRight';
					$small_heading_animation_delay = !empty($slide['small_heading_animation_delay']) ? $slide['small_heading_animation_delay'] : 300;
					$small_heading_color = !empty($slide['small_heading_color']) ? $slide['small_heading_color'] : 'white';
					$small_heading_reponsive = solatec_elementor_responsive_render($settings, ['prefix' => 'small_heading']);
					// large heading
					$large_heading_animation = !empty($slide['large_heading_animation']) ? $slide['large_heading_animation'] : 'fadeInRight';
					$large_heading_animation_delay = !empty($slide['large_heading_animation_delay']) ? $slide['large_heading_animation_delay'] : 600;
					$large_heading_color = !empty($slide['large_heading_color']) ? $slide['large_heading_color'] : 'white';
					$large_heading_reponsive = solatec_elementor_responsive_render($settings, ['prefix' => 'large_heading']);
					// Description
					$description_animation = !empty($slide['description_animation']) ? $slide['description_animation'] : 'fadeInRight';
					$description_animation_delay = !empty($slide['description_animation_delay']) ? $slide['description_animation_delay'] : 900;
					$description_color = !empty($slide['description_color']) ? $slide['description_color'] : 'white';
					$description_heading_reponsive = solatec_elementor_responsive_render($settings, ['prefix' => 'description_heading']);
					// Description2
					$description2_animation = !empty($slide['description2_animation']) ? $slide['description2_animation'] : 'fadeInRight';
					$description2_animation_delay = !empty($slide['description2_animation_delay']) ? $slide['description2_animation_delay'] : 900;
					$description2_color = !empty($slide['description2_color']) ? $slide['description2_color'] : 'white';
					$description2_heading_reponsive = solatec_elementor_responsive_render($settings, ['prefix' => 'description2_heading']);
					// Button Video
					$btn_video_animation = !empty($slide['btn_video_animation']) ? $slide['btn_video_animation'] : 'fadeInUp';
					$btn_video_animation_delay = !empty($slide['btn_video_animation_delay']) ? $slide['btn_video_animation_delay'] : 1200;
					// Build Attributes
					$small_heading_attrs = [
						'class' => 'small-heading text-16 lh-1 font-700 mb-15 text-'.$small_heading_color.' '.$small_heading_reponsive.' cms-animate cms-invisible',
						'data-settings' => json_encode([
					        'animation'      => $small_heading_animation,
					        'animation_delay' => $small_heading_animation_delay
					    ])
					];
					$large_heading_attrs = [
						'class' => 'large-heading text-40 text-md-55 text-lg-65 text-xl-75 lh-1 font-500 heading text-'.$large_heading_color.' '.$large_heading_reponsive.' cms-animate cms-invisible',
						'data-settings' => json_encode([
					        'animation'      => $large_heading_animation,
					        'animation_delay' => $large_heading_animation_delay
					    ])
					];
					$description_attrs = [
						'class' => 'description text-md-17 lh-27 font-700 pt-20 text-'.$description_color.' '.$description_heading_reponsive.' cms-animate cms-invisible',
						'data-settings' => json_encode([
					        'animation'      => $description_animation,
					        'animation_delay' => $description_animation_delay
					    ])
					];
					$description2_attrs = [
						'class' => 'description2 text-md-17 lh-27 font-700 pt-35 text-'.$description2_color.' '.$description2_heading_reponsive.' cms-animate cms-invisible',
						'data-settings' => json_encode([
					        'animation'      => $description2_animation,
					        'animation_delay' => $description2_animation_delay
					    ])
					];
					// icons 
					$icon_attrs = [
						'class' => [
							'cms-slide-icon',
							'text-'.$slide['icons_color'],
							'text-68'
						]
					];
					$icon1_attr = [
						'data-settings' => json_encode([
							'animation'       => $slide['icon1_animation'],
							'animation_delay' => $slide['icon1_animation_delay']
						])
					];
					$icon2_attr = [
						'data-settings' => json_encode([
							'animation'       => $slide['icon2_animation'],
							'animation_delay' => $slide['icon2_animation_delay']
						])
					];
					$icon3_attr = [
						'data-settings' => json_encode([
							'animation'       => $slide['icon3_animation'],
							'animation_delay' => $slide['icon3_animation_delay']
						])
					];
					$icon4_attr = [
						'data-settings' => json_encode([
							'animation'       => $slide['icon4_animation'],
							'animation_delay' => $slide['icon4_animation_delay']
						])
					];
				?>
					<div <?php etc_print_html($widget->get_render_attribute_string($item_key)); ?>>
						<img <?php etc_print_html($widget->get_render_attribute_string($item_content_img_attrs)); ?> />
						<div class="cms-slide-img-overlay cms-overlay"></div>
						<div <?php etc_print_html($widget->get_render_attribute_string( 'item-content' )); ?>>
							<div <?php etc_print_html($widget->get_render_attribute_string( 'item-content-inner' )); ?>>
								<div <?php etc_print_html($widget->get_render_attribute_string( $item_content__inner )); ?>>
									<div class="col cms-slider-content-text elementor-repeater-item-<?php echo esc_attr($data_id);?>">
										<div class="<?php echo esc_attr($small_heading_attrs['class']); ?>" data-settings="<?php echo esc_attr($small_heading_attrs['data-settings']);?>"><?php
											etc_print_html($slide['small_heading']);
										?></div>
										<div class="<?php echo esc_attr($large_heading_attrs['class']); ?>" data-settings="<?php echo esc_attr($large_heading_attrs['data-settings']);?>"><?php 
											etc_print_html($slide['large_heading']);
										 ?></div>
										<div class="<?php echo esc_attr($description_attrs['class']); ?>" data-settings="<?php echo esc_attr($description_attrs['data-settings']);?>"><?php 
											etc_print_html($slide['description']);
										?></div>
										<div <?php etc_print_html($widget->get_render_attribute_string( $item_content_buttons )); ?>><?php 
								            solatec_elementor_button_render($slide, [
								                'class'        => 'col-auto',
								                'icon_class'   => 'text-10',
								                'btn_animation' => 'fadeInUp',
								                'btn_animation_delay' => '1200'
								            ]);
								            solatec_elementor_button_render($slide, [
								            	'prefix'	   => 'btn2',
								                'class'        => 'col-auto',
								                'icon_class'   => 'text-10',
								                'btn_animation' => 'fadeInUp',
								                'btn_animation_delay' => '1300'
								            ]);
								            // video
								            solatec_elementor_render_lightbox_video_button($widget, $slide , [
								            	//'prefix'	 => 'btn_',
												'class'                 => 'col-auto',
												'layout'				=> 'ripple',
												'size'					=> '68',
												'outline'		        => true,
												'icon_class'            => '',
												'video_animation'       => 'fadeInRight',
												'video_animation_delay' => '1400'
								            ]);
									    ?></div>
									    <div class="cms-slider-icons row gutters-20 gutters-grid pt-30 align-items-center jusity-content-start empty-none <?php echo solatec_elementor_responsive_render($settings, ['prefix' => 'icons']); ?>"><?php 
									    	// Text Before
									    	if(!empty($slide['text_before_icon'])) etc_print_html('<div class="col-12 text-white font-700 mb-n8 cms-animate" data-settings='.$icon1_attr['data-settings'].'>'.$slide['text_before_icon'].'</div>');
									    	// icons 
								            solatec_elementor_icon_render($slide,[
												'id'    => 'icon1',
												'loop'  => false,
												'class' => implode(' ', $icon_attrs['class']),
												'atts'  => $icon1_attr,
												'wrap_class' => 'col-auto cms-animate cms-invisible'
											]);
											solatec_elementor_image_render($settings,[
												'id'          => 'icon1_img',
												'class'       => implode(' ', $icon_attrs['class']),
												'atts'        => $icon1_attr,
												'size'		  => 'custom',		
												'custom_size' => '90x90',
												'before' 	  => '<div class="'.implode(' ', array_merge($icon_attrs['class'],['col-auto cms-animate cms-invisible'])).'" data-settings='.$icon1_attr['data-settings'].'>',
												'after'		  => '</div>' 		
											], $slide);
											solatec_elementor_icon_render($slide,[
												'id'    => 'icon2',
												'loop'  => false,
												'class' => implode(' ', $icon_attrs['class']),
												'atts'  => $icon2_attr,
												'wrap_class' => 'col-auto cms-animate cms-invisible'
											]);
											solatec_elementor_image_render($settings,[
												'id'          => 'icon2_img',
												'class'       => implode(' ', $icon_attrs['class']),
												'atts'        => $icon2_attr,
												'size'		  => 'custom',
												'custom_size' => '90x90',
												'before' 	  => '<div class="'.implode(' ', array_merge($icon_attrs['class'],['col-auto cms-animate cms-invisible'])).'" data-settings='.$icon2_attr['data-settings'].'>',
												'after'		  => '</div>'		
											], $slide);
											solatec_elementor_icon_render($slide,[
												'id'    => 'icon3',
												'loop'  => false,
												'class' => implode(' ', $icon_attrs['class']),
												'atts'  => $icon3_attr,
												'wrap_class' => 'col-auto cms-animate cms-invisible'
											]);
											solatec_elementor_image_render($settings,[
												'id'          => 'icon3_img',
												'class'       => implode(' ', $icon_attrs['class']),
												'atts'        => $icon3_attr,
												'size'		  => 'custom',
												'custom_size' => '90x90',
												'before' 	  => '<div class="'.implode(' ', array_merge($icon_attrs['class'],['col-auto cms-animate cms-invisible'])).'" data-settings='.$icon3_attr['data-settings'].'>',
												'after'		  => '</div>'		
											], $slide);
											solatec_elementor_icon_render($slide,[
												'id'    => 'icon4',
												'loop'  => false,
												'class' => implode(' ', $icon_attrs['class']),
												'atts'  => $icon4_attr,
												'wrap_class' => 'col-auto cms-animate cms-invisible'
											]);
											solatec_elementor_image_render($settings,[
												'id'          => 'icon4_img',
												'class'       => implode(' ', $icon_attrs['class']),
												'atts'        => $icon4_attr,
												'size'		  => 'custom',
												'custom_size' => '90x90',
												'before' 	  => '<div class="'.implode(' ', array_merge($icon_attrs['class'],['col-auto cms-animate cms-invisible'])).'" data-settings='.$icon4_attr['data-settings'].'>',
												'after'		  => '</div>'		
											], $slide);
									    ?></div>
									</div>
									<?php if(!empty($slide['description2_icon']['value']) || !empty($slide['description2']) || $widget->get_setting('show_rate') === 'true') : ?>
										<div class="col-lg-4 col-xl-4 align-self-lg-end mb-lg-35">
											<div class="<?php echo esc_attr($description2_attrs['class']); ?>" data-settings="<?php echo esc_attr($description2_attrs['data-settings']);?>">
												<div class="row gutters-30 gutters-grid">
													<?php 
														solatec_elementor_icon_render($slide,[
															'id'    => $slide['description2_icon'],
															'loop'  => true,
															'class' => 'col-auto text-64'
														]);
													?>
													<div class="col"><?php 
														etc_print_html($slide['description2']);
													?></div>
													<?php if($widget->get_setting('show_rate') === 'true') { ?>
											            <div class="cms-slide-rating absolute">
											                <div <?php etc_print_html($widget->get_render_attribute_string( 'rate_star' )); ?>><?php
											                    solatec_elementor_image_render($settings, [
																	'id'          => 'rate_star',
																	'default_img' => get_template_directory_uri().'/assets/images/icons/star-three.png',
																	'class'       => 'cms-rate-star'
											                    ]);
											                ?></div>
											                <div class="cms-badge-3">
											                    <div class="cms-heading text-white text-22"><?php 
											                        echo esc_html($widget->get_setting('rate_value')['size'].$widget->get_setting('rate_value')['unit']);
											                    ?></div>
											                    <div class=""><?php 
											                        echo esc_html($widget->get_setting('rate_text', 'Customer Rating'));
											                    ?></div>
											                </div>
											            </div>
											        <?php } ?>
											    </div>
											</div>
										</div>
									<?php endif; ?>
								</div>
							</div>
						</div>
					</div>
				<?php
				}
			?>
        </div>
        <?php 
            solatec_swiper_slider_dots($settings, ['class' => 'cms-dots-main']); 
            solatec_swiper_slider_arrows($settings);
            solatec_swiper_slider_arrows_bottom($settings);
        ?>
    </div>
</div>