<?php
if(!function_exists('solatec_cpt_project')){
	add_filter( 'cms_extra_post_types', 'solatec_cpt_project' );
	function solatec_cpt_project( $postypes ) {
		$project_slug = solatec_get_opt( 'project_slug', 'projects' );
		$postypes['cms-project'] = array(
			'status'     => true,
			'item_name'  => esc_html__( 'Project', 'solatec' ),
			'items_name' => esc_html__( 'Projects', 'solatec' ),
			'args'       => array(
				'menu_icon'          => 'dashicons-hammer',
				'supports'           => array(
					'title',
					'thumbnail',
					'editor', 
					'excerpt',
					'author'
				),
				'public'             => true,
				'publicly_queryable' => true,
				'rewrite'            => array(
	                'slug'  => $project_slug
	 		 	),
			),
			'labels'     => array()
		);
		return $postypes;
	}
}

if(!function_exists('solatec_add_tax_project')){
	add_filter( 'cms_extra_taxonomies', 'solatec_add_tax_project' );
	function solatec_add_tax_project( $taxonomies ) {
		$taxonomies['project-category'] = array(
			'status'     => true,
			'post_type'  => array( 'cms-project' ),
			'taxonomy'   => esc_html__( 'Project Category', 'solatec' ),
			'taxonomies' => esc_html__( 'Project Categories', 'solatec' ),
			'args'       => array(),
			'labels'     => array()
		);
		return $taxonomies;
	}
}