<?php
if(!function_exists('solatec_cpt_service')){
	add_filter( 'cms_extra_post_types', 'solatec_cpt_service' );
	function solatec_cpt_service( $postypes ) {
		$service_slug = solatec_get_opt( 'service_slug', 'services' );
		$postypes['cms-service'] = array(
			'status'     => true,
			'item_name'  => esc_html__( 'Service', 'solatec' ),
			'items_name' => esc_html__( 'Services', 'solatec' ),
			'args'       => array(
				'menu_icon'          => 'dashicons-hammer',
				'supports'           => array(
					'title',
					'thumbnail',
					'editor', 
					'excerpt',
					'page-attributes',
					'author'
				),
				'public'             => true,
				'publicly_queryable' => true,
				'rewrite'            => array(
	                'slug'  => $service_slug
	 		 	),
	 		 	'has_archive' => false
			),
			'labels'     => array()
		);
		return $postypes;
	}
}

if(!function_exists('solatec_add_tax_service')){
	add_filter( 'cms_extra_taxonomies', 'solatec_add_tax_service' );
	function solatec_add_tax_service( $taxonomies ) {
		$taxonomies['service-category'] = array(
			'status'     => true,
			'post_type'  => array( 'cms-service' ),
			'taxonomy'   => esc_html__( 'Service Category', 'solatec' ),
			'taxonomies' => esc_html__( 'Service Categories', 'solatec' ),
			'args'       => array(),
			'labels'     => array()
		);
		return $taxonomies;
	}
}