<?php
/* Create Demo Data */
if(!function_exists('solatec_enable_export_mode')){
	add_filter('swa_ie_export_mode', 'solatec_enable_export_mode');
	function solatec_enable_export_mode() {
	    return defined('DEV_MODE') && DEV_MODE == true ? true : false;
	}
}

if (!function_exists('solatec_cpt_dev_mode')) {
    add_filter('cpt_dev_mode', 'solatec_cpt_dev_mode');
    function solatec_cpt_dev_mode()
    {
        return defined('DEV_MODE') && DEV_MODE == true ? true : false;
    }
}
/**
 * Update custom post type edit with Elementor
 * **/
if (!function_exists('solatec_elementor_cpts')) {
    add_action('theme_core_ie_after_import', 'solatec_elementor_cpts');
    function solatec_elementor_cpts(){
        $default = (array)get_option('elementor_cpt_support');
        $cpt_support = array_merge(
            $default, 
            [
                //core
                'post',
                'page',
                'cms-footer',
                'cms-header-top',
                'cms-mega-menu',
                'portfolio',
                //theme
                'cms-project',
                'cms-service'
            ]
        );
        update_option( 'elementor_cpt_support', $cpt_support );
    }
}
/*
 *  Dashboard Configurations
 */
if (!function_exists('solatec_cpt_dashboard_config')) {
    add_filter('cpt_dashboard_config', 'solatec_cpt_dashboard_config');
    function solatec_cpt_dashboard_config()
    {
        return [
            'documentation_link'  => 'https://cmssuperheroes.gitbook.io/solatec-wordpress-theme/',
            'ticket_link'         => 'https://cmssuperheroes.ticksy.com/',
            'video_tutorial_link' => 'https://www.youtube.com/watch?v=3rMRAA19ya0&list=PL2sD6GXVuXxHj7yF4MBTB2tsPoV9UBLLP&index=1',
            'demo_link'           => 'http://demo.cmssuperheroes.com/themeforest/solatec/',
        ];
    }
}
/*
 *  Dashboard Configurations
 */