<?php
/**
 * The template for displaying all pages
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages
 * and that other 'pages' on your WordPress site may use a
 * different template.
 *
 * @package Soapee
 */
$classes = ['cms-content-container'];
if ( class_exists('\Elementor\Plugin') && \Elementor\Plugin::$instance->documents->get( get_the_ID() )->is_built_with_elementor() ) {
    $classes[] = 'elementor-container';
    $is_built_with_elementor = true;
} else {
    $classes[] = 'container';
    $is_built_with_elementor = false;
}
get_header();
?>
    
    <?php 
         if ( $is_built_with_elementor ) { 
            while ( have_posts() )
            {
                the_post();
                the_content();
            }
        } else {
    ?>
    <div class="container cms-content-container">
        <div class="row cms-content-row">
            <div id="cms-content-area" class="<?php solatec_content_css_class(['content_col'=> 'page_content_col','sidebar_pos' => 'page_sidebar_pos']); ?>">
                <?php
                    while ( have_posts() )
                    {
                        the_post();
                        get_template_part( 'template-parts/content', 'page' );
                        if ( comments_open() || get_comments_number() )
                        {
                            comments_template();
                        }
                    }
                ?>
            </div>
            <?php solatec_sidebar(['content_col'=> 'page_content_col', 'sidebar_pos' => 'page_sidebar_pos']); ?>
        </div>
    </div>
    <?php } ?>
    
<?php
get_footer();