<?php
/**
 * Template part for displaying posts in loop
 *
 * @package Soapee
 */
$sidebar = solatec_sidebar_position();
if(in_array($sidebar, ['0','none', 'bottom'])){
    $thumbnail_size = 'post-thumbnail';
} else {
    $thumbnail_size = 'large';
}
if(has_post_thumbnail() || solatec_configs('default_post_thumbnail') === '1'){
    $padding_class = 'p-lr-20 p-lr-lg-40';
} else {
    $padding_class = '';
}
?>
<div <?php post_class('cms-single-post'); ?>>
    <?php 
        solatec_post_media([
            'thumbnail_size' => $thumbnail_size,
            'wrap_class'     => '',
            'img_class'      => 'cms-radius-16',
            'media_content' => false
        ]);
    ?>
    <div class="<?php echo esc_attr($padding_class);?>">
        <?php
            solatec_post_meta([
                'show_date'   => solatec_get_opts('post_date_on','1'),
                'show_cat'    => solatec_get_opts('post_categories_on','1'),
                'show_author' => solatec_get_opts('post_author_on','1'),
                'show_cmt'    => solatec_get_opts('post_comments_on','1'),
                'show_icon'   => false,
                'class'       => 'bg-white cms-radius-tr-16 pt-25 mb-25 clearfix',
                'taxo'        => solatec_get_custom_post_taxonomies(get_post_type(), 'cat')
            ]);
            solatec_post_title(['class' => 'text-24 text-lg-40 lh-lg-50 font-700 pt-15 mb-30']);
        ?>
        <div class="cms-post-content mb-30 clearfix"><?php
            the_content();
        ?></div>
        <?php 
            // post page
            solatec_post_link_pages(['class' => 'mb-30']);
        ?>
        <?php
            // post share
            // param: show_share, class, title, social_class
            solatec_socials_share_default([
                'class'        => 'gutters-10 gutters-grid justify-content-between',
                'show_share'   => solatec_get_opts( 'post_social_share_on', '0' ),   
                'title'        => '<div class="col-auto"><div class="cms-heading font-700">'.esc_html__('Share This Article','solatec').'</div></div>',
                'social_class' => 'cms-socials cms-social-layout-3',
                'before'       => '<div class="cms-radius-8 bdr-2 bdr-solid bdr-accent p-20 mb-25">',
                'after'        => '</div>'
            ]);
            // Post tag
            // param: show_tag, title
            solatec_post_tagged_in([
                'show_tag'  => solatec_get_opts( 'post_tags_on', '1' ), 
                'title'     => '<div class="cms-heading font-700">'.esc_html__('Tags:','solatec').'</div>',
                'style'     => 'custom', 
                'separator' => ', ',
                'class'     => ''                                                                            
            ]);
        ?>
    </div>
    <?php
        // Next/Preview Post link
        // param: show_nav, class, prev_title, next_title
        solatec_posts_nav_link([
            'show_nav'       => solatec_get_opt('post_nav_link_on', '1'),
            'class'          => 'gutters-grid',
            'thumbnail_size' => '90x67',
            'before'         => '<div class="mt-25 overflow-hidden p-tb-30 bdr-tb-1 bdr-lr-0 bdr-main bdr-solid">',
            'after'          => '</div>' 
        ]);

        // Author info
        // param: show_author, class
        solatec_post_author_info([
            'class'       => 'gutters-30 gutters-grid',
            'title_class' => 'text-18 mb-10 mt-n8',
            'show_author' => solatec_get_opt('post_author_info_on', '0'),
            'before'      => '<div class="mt-40 pt-40 p-lr-40 pb-30 bg-light-accent cms-radius-8 clearfix overflow-hidden cms-bottom-divider cms-bottom-divider-accent">',
            'after'       => '</div>' 
        ]);
        // Related post
        // param: class, show_related, title, posts_per_page, post_tyle
        solatec_related_post([
            'class'  => '',
            'before' => '<div class="mt-30 p-30 bg-white cms-shadow-1 cms-shadow-hover-2 cms-transition cms-radius-8 clearfix">',
            'after'  => '</div>' 
        ]);
    ?>
</div>