<?php
/**
 * Template part for displaying posts in loop
 *
 * @package Solatec
 */
if(has_post_thumbnail() || solatec_configs('default_post_thumbnail') === '1'){
    $class = 'pt-20 pt-lg-35 pl-20 pl-lg-40';
} else {
    $class = '';
}
?>
<div <?php post_class('cms-post-archive clearfix'); ?>>
    <div class="clearfix">
        <?php 
            solatec_post_media([
                'thumbnail_size' => 'medium_large',
                'wrap_class'     => '',
                'img_class'      => 'cms-radius-8'
            ]);
        ?>
        <div class="<?php echo esc_attr($class);?>"><?php
            solatec_post_meta(['class' => 'mb-5', 'show_icon' => false, 'show_date' => '0']);
            solatec_post_title(['tag' => 'div', 'class' => 'cms-heading text-24 lh-30 mb-25']);
            solatec_post_excerpt(['class' => 'mb-30', 'length' => solatec_get_opt('archive_excerpt_length', '55') , 'more' => '...']);
            solatec_post_link_pages(['class' => 'pb-40 empty-none']);
            solatec_post_readmore(['class' => 'btn btn-outline btn-primary btn-hover-accent']);
        ?></div>
    </div>
</div>