<?php
/**
 * Template part for displaying default header layout
 */
?>
<header id="cms-header" class="<?php solatec_header_css_class('relative cms-shadow-3'); ?>">
    <div class="<?php solatec_header_container_css_class(); ?>">
        <div class="row justify-content-between gutters-20 gutters-xl-40 align-items-center">
            <?php solatec_logo(['class' => 'col-auto']); ?>
            <div class="cms-navigation col">
                <div class="row gutters-50 justify-content-between">
                    <div class="col-12 col-xl-basic">
                        <div class="row align-items-center gutters-20 gutters-xl-40 justify-content-end">
                            <div class="col-auto cms-hidden-lg mb-xl-n15 z-ontop">
                                <div class="row justify-content-end">
                                    <div class="cms-header-space col-12"></div>
                                    <?php 
                                    solatec_header_social([
                                        'before' => '<div class="cms-header-socials col-auto">', 
                                        'after'  => '</div>',
                                        'icon_class' => 'menu-icon menu-color'
                                    ]);
                                    solatec_header_hotline([
                                        'class'      => 'col-auto',
                                        'icon_class' => 'text-18 text-primary cmsi-phone-alt',
                                    ]);
                                    solatec_header_cart(['class' => 'col-auto']);
                                    solatec_header_search(['class' => 'col-auto']);
                                    solatec_header_language_switcher(['class' => 'col-auto', 'full_names' => true]);
                                ?></div>
                            </div>
                            <div class="col-12 cms-hidden-lg"></div>
                            <div class="cms-main-navigation col-12 col-xl-auto">
                                <?php get_template_part( 'template-parts/header/header-menu' ); ?>
                            </div>
                            <div class="col-12"></div>
                            <?php solatec_secondary_menu([
                                'before' => '<div class="col-12 col-xl-auto">',
                                'after'  => '</div>'
                            ]); ?>
                        </div>
                    </div>
                    <div class="header-separator col-auto cms-hidden-lg"><span class="header-divider h-100"></span></div>
                    <div class="<?php solatec_site_menu_right_class('col-12 col-xl-auto align-self-center');?>">
                        <div class="cms-navigation-attrs-inner row gutters-30 align-items-center justify-content-center justify-content-md-start">
                            <?php
                                solatec_header_button([
                                    'class'     => 'col-auto',
                                    'btn_class' => 'btn btn-accent btn-lg cms-btn-header',
                                    'show_icon'  => true,
                                    'icon_class' => 'cmsi-arrow-circle-right',
                                    'icon_pos'   => 'after'
                                ]);
                                solatec_header_button2([
                                    'class'      => 'col-auto',
                                    'btn_class'  => 'btn btn-accent btn-lg cms-btn-header',
                                    'show_icon'  => true,
                                    'icon_class' => 'cmsi-arrow-circle-right',
                                    'icon_pos'   => 'after'
                                ]);
                                do_action('solatec_header_atts');
                            ?>
                        </div>
                    </div>
                </div>
            </div>
            <?php 
                if( (solatec_get_opts( 'hidden_sidebar_on', '0' ) == '1' && is_active_sidebar('sidebar-hidden')) )  { //|| solatec_get_opts('header_switch_language', '0') == 'all' 
                    $hidden_sidebar = '';
                } else {
                    $hidden_sidebar = 'cms-hidden-n-xl';
                }
            ?>
            <div class="col col-lg-auto <?php echo esc_attr($hidden_sidebar);?>">
                <div class="row align-items-center justify-content-end">
                    <?php
                        solatec_header_social([
                            'before' => '<div class="cms-header-socials col-auto cms-hidden-n-xl">', 
                            'after'  => '</div>',
                            'icon_class' => 'menu-icon menu-color'
                        ]);
                        solatec_header_hotline([
                            'class'      => 'col-auto cms-hidden-n-xl d-none d-md-flex',
                            'icon_class' => 'text-18 text-primary cmsi-phone-alt',
                        ]);
                        solatec_header_cart(['class' => 'col-auto cms-hidden-n-xl']);
                        solatec_header_search(['class' => 'col-auto cms-hidden-n-xl']);
                        solatec_header_language_switcher(['class' => 'col-auto cms-hidden-n-xl', 'full_names' => true]);
                        do_action('solatec_header_mobile_atts');
                        solatec_hidden_sidebar_icon(['class' => 'col-auto']);
                        solatec_mobile_menu_icon(['class' => 'col-auto']);
                    ?>
                </div>
            </div>
        </div>
    </div>
</header>