<?php
//Message
if(!function_exists('solatec_woocommerce_checkout_coupon_message')){
	add_filter('woocommerce_checkout_coupon_message','solatec_woocommerce_checkout_coupon_message');
	function solatec_woocommerce_checkout_coupon_message(){
		return '<span class="cms-added-to-cart-msg">'.esc_html__( 'Have a coupon?', 'solatec' ) . '</span> <a href="#" class="showcoupon">' . esc_html__( 'Click here to enter your code', 'solatec' ) . '</a>';
	}
}

// add inner wrap div to order review columns
if(!function_exists('solatec_woocommerce_checkout_order_review_inner_open')){
	add_action('woocommerce_checkout_order_review','solatec_woocommerce_checkout_order_review_inner_open', 0);
	function solatec_woocommerce_checkout_order_review_inner_open(){
		echo '<div class="cms-woocommerce-checkout-review-order-inner p-30 bg-accent">';
	}
}
if(!function_exists('solatec_woocommerce_checkout_order_review_inner_close')){
	add_action('woocommerce_checkout_order_review','solatec_woocommerce_checkout_order_review_inner_close', 999);
	function solatec_woocommerce_checkout_order_review_inner_close(){
		echo '</div>';
	}
}

// add heading to order review columns
if(!function_exists('solatec_woocommerce_checkout_order_review')){
	add_action('woocommerce_checkout_order_review','solatec_woocommerce_checkout_order_review', 1);
	function solatec_woocommerce_checkout_order_review(){ ?>
		<div id="cms-order-review-heading" class="h2 text-white text-uppercase"><?php esc_html_e( 'Your order', 'solatec' ); ?></div>
	<?php }
}

// add div wrap content after order review title
if(!function_exists('solatec_woocommerce_checkout_order_review_inner2_open'))
{
	add_action('woocommerce_checkout_order_review','solatec_woocommerce_checkout_order_review_inner2_open', 2);
	function solatec_woocommerce_checkout_order_review_inner2_open(){
		echo '<div class="cms-woocommerce-checkout-review-order-inner2 cms-radius-8 cms-shadow-1 overflow-hidden bg-white text-body">';
	}
}
if(!function_exists('solatec_woocommerce_checkout_order_review_inner2_close'))
{
	add_action('woocommerce_checkout_order_review','solatec_woocommerce_checkout_order_review_inner2_close', 998);
	function solatec_woocommerce_checkout_order_review_inner2_close(){
		echo '</div>';
	}
}

// custom proceed to paypal button
if(!function_exists('solatec_woocommerce_order_button_html')){
	add_filter('woocommerce_order_button_html', 'solatec_woocommerce_order_button_html');
	function solatec_woocommerce_order_button_html(){
		$order_button_text = apply_filters( 'woocommerce_order_button_text', esc_html__( 'Place order', 'solatec' ) );
		return '<button type="submit" class="button btn-lg btn-accent" name="woocommerce_checkout_place_order" id="place_order" value="' . esc_attr( $order_button_text ) . '" data-value="' . esc_attr( $order_button_text ) . '">' . esc_html( $order_button_text ) . '</button>';
	}
}